/*->c.curvelo */

#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "transform.h"


#include "err.h"
#include "xext.h"
#include "poll.h"
#include "temp.h"
#include "alloc.h"
#include "fsx.h"
#include "trans.h"
#include "xmath.h"
#include "colour.h"
#include "deb.h"
#include "dbhi.h"


#include "etc.h"



#include "constants.h"
#include "str.h"
#include "mhi.h"

#include "curvelo.h"








/* results of a ray from x,y to left infinity, on a line cx[0],cx[1]    */
/* in INTERXY X denotes the line, and Y the end of the other line on it */


int hintersection(int x,int y,coordstr * cx)
{
 int y0;
 int y1;
 int x0;
 int x1;
 big temp1;
 big temp2;
 big result;
 int bits;

 y0=cx[0].y-y;
 y1=cx[1].y-y;

 if(!y0)
 {
  bits=0;
  x0=cx[0].x-x;
  x1=cx[1].x-x;

  if(!y1)  /* colinear */
  {
   if(x1>=0) bits|=(INTERCO|INTER10|INTER01|INTER);
   if(x0>=0) bits|=(INTERCO|INTER10|INTER00|INTER);
  }
  else
  if(x0>0)  bits|=(INTER00|INTER);
  else
  if(x0==0) bits|=(INTER00|INTER10|INTER);

  return(bits);
 }
 else
 if(!y1)
 {
  if(cx[1].x>x)  return(INTER01|INTER);
  else
  if(cx[1].x==x) return(INTER01|INTER10|INTER);
 }
 else
 if((y0 ^ y1)<0)
 {
  x0=cx[0].x-x;
  x1=cx[1].x-x;

  if((x0 ^ x1)<0)
  {
   /* cut if (x1*y0-x0*y1)/(y1-y0) <0 */

   /*
      s1=x1 ^ y0;
      s2=x0 ^ y1;

      if((s1 ^ s2)<0)  s1 and s2 have different signs
                       sign of product is s1

   */

   bigmul(&temp1,x1,y0);
   bigmul(&temp2,x0,y1);
   bigsub(&temp1,&temp2,&result);

   if(y1>y0 && result.hi<0) return(INTER);
   else
   if(y1<y0)
   {
    if(result.hi==0 && result.lo==0) return(INTER10|INTER);
    else
    if(result.hi>=0)                 return(INTER);
   }
  }
  else
  if(x0>0) return(INTER);
 }

 return(0);
}




/* intersections of horizontal ray  ray[0]->ray[1] with cx[0],cx[1] */

int hintersectionr(coordstr * ray,coordstr * cx,coordstr * result)
{
 int y0;
 int y1;
 int x0;
 int x1;
 int mx;
 big temp1;
 big temp2;
 big rbig;
 int x;
 int y;
 int bits;

 y=ray[0].y;
 y0=cx[0].y-y;
 y1=cx[1].y-y;


 if(!y0)
 {
  x=ray[0].x;
  x0=cx[0].x-x;
  x1=cx[1].x-x;
  mx=ray[1].x-x;

  if(!y1)   /* colinear */
  {
   bits=0;

   if(x0>=0 && x0<=mx) bits=(INTERCO|INTER00|INTER);
   if(x1>=0 && x1<=mx) bits=(INTERCO|INTER01|INTER);

   return(bits);
  }
  else
  if(x0>=0 && x0<=mx)
  {
   result->y=y;
   result->x=x0+x;
   return(INTER00|INTER);
  }
 }
 else
 if(!y1)
 {
  x=ray[0].x;
  x1=cx[1].x-x;
  mx=ray[1].x-x;

  if(x1>=0 && x1<=mx)
  {
   result->y=y;
   result->x=x1+x;
   return(INTER01|INTER);
  }
 }
 else
 if((y0 ^ y1)<0)
 {
  x=ray[0].x;
  x0=cx[0].x-x;
  x1=cx[1].x-x;
  mx=ray[1].x-x;

  if(x0<0)
  {
   if(x1<0) return(0);
  }
  else
  if(x0>mx)
  {
   if(x1>mx) return(0);
  }

  if(x0==x1)  /* vertical line */
  {
   if(x0<0 || x0>mx) return(0);

   result->y=y;
   result->x=x0+x;

   if(x0==0)  return(INTER10|INTER);
   if(x0==mx) return(INTER11|INTER);

   return(INTER);
  }
  else
  {
   /* cut if (x1*y0-x0*y1)/(y1-y0) <0 */

   bigmul(&temp1,x1,y0);
   bigmul(&temp2,x0,y1);
   bigsub(&temp1,&temp2,&rbig);

   if(rbig.hi || rbig.lo)
   {
    if(rbig.hi<0)
    {
     if(y0>y1) return(0);
    }
    else
    {
     if(y1>y0) return(0);
    }

    x0=bigdiv(&rbig,y0-y1);

    if(x0>=0 && x0<=mx)
    {
     result->y=y;
     result->x=x0+x;

     if(x0==mx) return(INTER11|INTER);
     else       return(INTER);
    }
   }
   else
   {
    result->y=y;
    result->x=x;
    return(INTER10|INTER);
   }
  }
 }

 return(0);
}




int hintersectionc(coordstr * ray,coordstr * cx,cutstr * result)
{
 result->dx1=ray[1].x-ray[0].x;
 result->dy1=ray[1].y-ray[0].y;
 result->dx2=cx[1].x-cx[0].x;
 result->dy2=cx[1].y-cx[0].y;
 return(hintersectionr(ray,cx,&result->c));
}






int vintersectionr(coordstr * ray,coordstr * cy,coordstr * result)
{
 int x0;
 int x1;
 int y0;
 int y1;
 int my;
 big temp1;
 big temp2;
 big rbig;
 int y;
 int x;
 int bits;


 x=ray[0].x;
 x0=cy[0].x-x;
 x1=cy[1].x-x;


 if(!x0)
 {
  y=ray[0].y;
  y0=cy[0].y-y;
  y1=cy[1].y-y;
  my=ray[1].y-y;

  if(!x1)
  {
   bits=0;

   if(y0>=0 && y0<=my) bits=(INTERCO|INTER00|INTER);
   if(y1>=0 && y1<=my) bits=(INTERCO|INTER01|INTER);

   return(bits);
  }
  else
  if(y0>=0 && y0<=my)
  {
   result->x=x;
   result->y=y0+y;
   return(INTER00|INTER);
  }
 }
 else
 if(!x1)
 {
  y=ray[0].y;
  y1=cy[1].y-y;
  my=ray[1].y-y;

  if(y1>=0 && y1<=my)
  {
   result->x=x;
   result->y=y1+y;
   return(INTER01|INTER);
  }
 }
 else
 if((x0 ^ x1)<0)
 {
  y=ray[0].y;
  y0=cy[0].y-y;
  y1=cy[1].y-y;
  my=ray[1].y-y;

  if(y0<0)
  {
   if(y1<0) return(0);
  }
  else
  if(y0>my)
  {
   if(y1>my) return(0);
  }


  if(y0==y1)  /* horizontal line */
  {
   if(y0<0 || y0>my) return(0);

   result->x=x;
   result->y=y0+y;

   if(y0==0)  return(INTER10|INTER);
   if(y0==my) return(INTER11|INTER);

   return(INTER);
  }
  else
  {
   /* cut if (y1*x0-y0*x1)/(x1-x0) <0 */

   bigmul(&temp1,y0,x1);
   bigmul(&temp2,y1,x0);
   bigsub(&temp1,&temp2,&rbig);

   if(rbig.hi || rbig.lo)
   {
    y0=bigdiv(&rbig,x1-x0);

    if(y0>=0 && y0<=my)
    {
     result->x=x;
     result->y=y0+y;

     if(y0==my) return(INTER11|INTER);
     else       return(INTER);
    }
   }
   else
   {
    result->y=y;
    result->x=x;
    return(INTER10|INTER);
   }
  }
 }

 return(0);
}



int vintersectionc(coordstr * ray,coordstr * cx,cutstr * result)
{
 result->dx1=ray[1].x-ray[0].x;
 result->dy1=ray[1].y-ray[0].y;
 result->dx2=cx[1].x-cx[0].x;
 result->dy2=cx[1].y-cx[0].y;

 return(vintersectionr(ray,cx,&result->c));
}






int linefraction(coordstr * cx,int x,int y)
{
 int dx;
 int dy;

 dx=cx[1].x-cx[0].x;
 dy=cx[1].y-cx[0].y;

 if(dx<0)
 {
  if(dy<0)
  {
   if(dx<dy) return(-(x-cx[0].x));
   else      return(-(y-cx[0].y));
  }
  else
  {
   if(dx<-dy) return(-(x-cx[0].x));
   else       return((y-cx[0].y));
  }
 }
 else
 {
  if(dy>=0)
  {
   if(dx>dy) return((x-cx[0].x));
   else      return((y-cx[0].y));
  }
  else
  {
   if(dx<-dy) return((x-cx[0].x));
   else       return(-(y-cx[0].y));
  }
 }
}







/* input two lines, (x00,y00) (x01,y01) and (x10,y10) (x11,y11) */
/* output x,y the intersection                                  */


int intersection(coordstr * coord0,coordstr * coord1,cutstr * result)
{
 big mt;
 big mb;
 big nt;
 big temp1;
 big temp2;
 int x00;
 int x01;
 int x10;
 int x11;
 int y00;
 int y01;
 int y10;
 int y11;
 int x00s;
 int x01s;
 int y00s;
 int y01s;
 int Ax;
 int Bx;
 int Cx;
 int Ay;
 int By;
 int Cy;
 int bits;



 x00=coord0[0].x;
 x01=coord0[1].x;
 x10=coord1[0].x;
 x11=coord1[1].x;
 y00=coord0[0].y;
 y01=coord0[1].y;
 y10=coord1[0].y;
 y11=coord1[1].y;


 Ax=x01-x00;
 Bx=x11-x10;

 if(Ax<0)   /* x01<x00 */
 {
  x00s=x01;
  x01s=x00;
 }
 else
 {
  x00s=x00;
  x01s=x01;
 }

 if(Bx<0)   /* x11<x10 */
 {
  if(x10<x00s || x11>x01s) return(0);
 }
 else       /* x11>x10 */
 {
  if(x11<x00s || x10>x01s) return(0);
 }



 Ay=y01-y00;
 By=y11-y10;

 if(Ay<0)   /* y01<y00 */
 {
  y00s=y01;
  y01s=y00;
 }
 else
 {
  y00s=y00;
  y01s=y01;
 }

 if(By<0)   /* y11<y10 */
 {
  if(y10<y00s || y11>y01s) return(0);
 }
 else       /* y11>y10 */
 {
  if(y11<y00s || y10>y01s) return(0);
 }

 Cx=x00-x10;
 Cy=y00-y10;


 bigmul(&temp1,Cx,By);
 bigmul(&temp2,Bx,Cy);
 bigsub(&temp1,&temp2,&mt);    /* mt=Cx*By-Bx*Cy -> -d */

 bigmul(&temp1,Bx,Ay);
 bigmul(&temp2,Ax,By);
 bigsub(&temp1,&temp2,&mb);    /* mb=Bx*Ay-Ax*By -> -f */


 if(mb.hi<0)                                      /* mb<0 */
 {
  if(mt.hi>=0 && mt.lo>0) return(0);              /* mt>0   */
  if(mt.hi<mb.hi) return(0);                      /* mt<mb  */
  if(mt.hi==mb.hi && mt.lo<mb.lo) return(0);
 }
 else                                             /* mb>=0  */
 {                                                         
  if(mt.hi<0) return(0);                          /* mt<0   */
  if(mt.hi>mb.hi) return(0);                      /* mt>mb  */
  if(mt.hi==mb.hi && mt.lo>mb.lo) return(0);
 }

 bigmul(&temp1,Ax,-Cy);
 bigmul(&temp2,-Cx,Ay);
 bigsub(&temp1,&temp2,&nt);   /* nt=-(Ax*Cy-Cx*Ay) -> -e */


 if(mb.hi<0)                                      /* mb<0 */
 {
  if(nt.hi>=0 && nt.lo>0) return(0);              /* nt>0   */
  if(nt.hi<mb.hi) return(0);                      /* nt<mb  */
  if(nt.hi==mb.hi && nt.lo<mb.lo) return(0);
 }
 else                                             /* mb>=0  */
 {                                                         
  if(nt.hi<0) return(0);                          /* nt<0   */
  if(nt.hi>mb.hi) return(0);                      /* nt>mb  */
  if(nt.hi==mb.hi && nt.lo>mb.lo) return(0);
 }

 bits=INTER;

 if(mb.lo==0 && mb.hi==0)      /* colinear */
 {
  bits|=INTERCO;
 }
 else
 {
  if(!mt.lo)                       bits|=INTER10;
  if(mt.lo==mb.lo)                 bits|=INTER11;
  if(!nt.hi && !nt.lo)             bits|=INTER00;
  if(nt.hi==mb.hi && nt.lo==mb.lo) bits|=INTER01;

  bignormalise(&mt,&mb);

  result->c.x=x00+scale(Ax,mt.hi,mb.hi);
  result->c.y=y00+scale(Ay,mt.hi,mb.hi);
 }

 result->dx1=Ax;
 result->dy1=Ay;
 result->dx2=Bx;
 result->dy2=By;
 result->type=bits;

 return(1);
}


/*******************************************************************************************************/


#ifdef NEVER

int bezval1(int p0,int p1,int p2,int p3,int u)
{
 int up;
 int u2;
 int u3;
 int up2;
 int up3;
 int v;

 up=0x10000-u;

 u2=ttmul(u,u);
 u3=ttmul(u,u2);
 up2=ttmul(up,up);
 up3=ttmul(up,up2);

 v=ttmul(p0,up3)+
   3*ttmul(p1,ttmul(u,up2))+
   3*ttmul(p2,ttmul(u2,up))+
   ttmul(p3,u3);

 return(v);
}


#endif


int bezmaxmin(int p0,int p1,int p2,int p3,int * val,int * uval)
{
 int a;
 int b;
 int c;
 big sum;
 big temp1;
 big temp2;
 int disc;
 int u1;
 int u2;
 int n;



 if(p0==p1)
 {
  if(p3==p2) return(0);

  a =6*p1-9*p2+3*p3;
  b=-6*p1+6*p2;

  if(a)
  {
   u1=-scale(b,0x10000,a);
   if(u1>=0 && u1<=0x10000)
   {
    if(val)  *val=bezvalx(p0,p1,p2,p3,u1);
    if(uval) *uval=u1;
    return(1);
   }
  }
 }
 else
 if(p3==p2)
 {
  a=-6*p0+18*p1-12*p2;
 /* b= 6*p0-12*p1+6*p2; */  /* -(6*p1-6*p2) */
  b=6*p0-6*p1;

  if(a)
  {
   u1=-scale(b,0x10000,a);
   if(u1>=0 && u1<=0x10000)
   {
    if(val)  *val=bezvalx(p0,p1,p2,p3,u1);
    if(uval) *uval=u1;
    return(1);
   }
  }
 }
 else
 if(p0<p3 && p1>p0 && p1<p3 && p2<p3 && p2>p0) return(0);
 else
 if(p0>p3 && p1<p0 && p1>p3 && p2>p3 && p2<p0) return(0);
 else
 {
  a=-3*p0+9*p1-9*p2+3*p3;
  b= 6*p0-12*p1+6*p2;
  c= -3*p0+3*p1;

  if(a)
  {
   bigmul(&temp1,b,b);
   bigmul(&temp2,4*a,c);
   bigsub(&temp1,&temp2,&sum);

   if(sum.hi>=0)
   {
    if(sum.hi || sum.lo)
    {
     disc=bigsquareroot(&sum);

     u1=-b-disc;
     u2=-b+disc;

     u1=scale(u1,0x10000,2*a);
     u2=scale(u2,0x10000,2*a);

     if(u1>u2) SWOP(u1,u2);

     n=0;

     if(u1>=0 && u1<=0x10000)
     {
      if(val)  *val++=bezvalx(p0,p1,p2,p3,u1);
      if(uval) *uval++=u1;
      n++;
     }

     if(u2>=0 && u2<=0x10000)
     {
      if(val)  *val=bezvalx(p0,p1,p2,p3,u2);
      if(uval) *uval=u2;
      n++;
     }

     return(n);
    }
    else
    {
     u1=-b;
     if(u1>=0 && u1<=0x10000)
     {
      if(val)  *val=bezvalx(p0,p1,p2,p3,u1);
      if(uval) *uval=u1;
      return(1);
     }
    }
   }
  } 
  else
  {
   if(b)
   {
    u1=-scale(c,0x10000,b);
    if(u1>=0 && u1<=0x10000)
    {
     if(val)  *val=bezvalx(p0,p1,p2,p3,u1);
     if(uval) *uval=u1;
     return(1);
    }
   }
  }
 }
 return(0);
}


/*  if(uval[0]<0x1000)
  {
   bezsplit2(p,&bp[0].b,&b,uval[0]);
   u=scale(0x10000,uval[1]-uval[0],0x10000-uval[0]);
   bezsplit2(&b,&bp[1].b,&bp[2].b,u);
  }
  else
  {
   bezsplit2(p,&a,&bp[2].b,uval[1]);
   u=scale(0x10000,uval[0],uval[1]);
   bezsplit2(&a,&bp[0].b,&bp[1].b,u);
  }  */



/*

static void bezdevsub(bezsplitstr * b)
{
 b->d01=b->b.leftc.y-b->b.left.y;

 if(!b->d01) b->d02=2*b->b.left.y-4*b->b.leftc.y+2*b->b.rightc.y;
 else        b->d02=0;

 b->d11=b->b.right.y-b->b.rightc.y;

 if(!b->d11) b->d12=2*b->b.leftc.y-4*b->b.rightc.y+2*b->b.right.y;
 else        b->d12=0;
}

*/



void bezchunks(bezier * b,bezsplitstr * bp,int * np,bezier * r)
{
 int    n;
 int    uval[2];
 bezier p;

 p=*b;

 n=bezmaxmin(p.left.y,p.leftc.y,p.rightc.y,p.right.y,NULL,uval);
 *np=n+1;

 if(n==0)
 {
  bp[0].umin=0;
  bp[0].umax=0x10000;
  bp[0].b=p;
 }
 else
 if(n==1)
 {
  bezsplit2(&p,&bp[0].b,&bp[1].b,uval[0]);

  bp[0].b.rightc.y=bp[0].b.right.y;
  bp[1].b.leftc.y=bp[1].b.left.y;

  bp[0].umin=0;
  bp[0].umax=uval[0];

  bp[1].umin=uval[0];
  bp[1].umax=0x10000;
 }
 else
 {
  bezsplit3(&p,&bp[0].b,&bp[1].b,&bp[2].b,uval[0],uval[1]);

  bp[0].b.rightc.y=bp[0].b.right.y;
  bp[1].b.leftc.y=bp[1].b.left.y;

  bp[1].b.rightc.y=bp[1].b.right.y;
  bp[2].b.leftc.y=bp[2].b.left.y;

  bp[0].umin=0;
  bp[0].umax=uval[0];

  bp[1].umin=uval[0];
  bp[1].umax=uval[1];

  bp[2].umin=uval[1];
  bp[2].umax=0x10000;
 }

 if(r) *r=p;
}



/* we know this is a monotonic curve in y */
/* looking for cuts on x axis x>=0        */ 

static int hbsub(bezier * p)
{
 bezier a;
 bezier b;
 bezier t;
 int    temp;

 t=*p;


/* dprintf(5,"xxxxxxxxxxxxxx"); */

 while(1)
 {
  /* y coords */

  a.left=t.left;
  b.right=t.right;


  temp=(t.leftc.y+t.rightc.y)/2;

  a.leftc.y =(t.left.y+t.leftc.y)/2;
  a.rightc.y=(temp+a.leftc.y)/2;
  b.rightc.y=(t.rightc.y+t.right.y)/2;
  b.leftc.y =(temp+b.rightc.y)/2;

  a.right.y=(a.rightc.y+b.leftc.y)/2;


  /* x coords */

  temp=(t.leftc.x+t.rightc.x)/2;

  a.leftc.x =(t.left.x+t.leftc.x)/2;
  a.rightc.x=(temp+a.leftc.x)/2;
  b.rightc.x=(t.rightc.x+t.right.x)/2;
  b.leftc.x =(temp+b.rightc.x)/2;

  a.right.x=(a.rightc.x+b.leftc.x)/2;

  b.left=a.right;


  if(!a.left.y)
  {
   if(a.left.x>=0) return(1);
   else           {/*dprintf(5,"!aleft.y x<0");*/return(0);}
  }
  else
  if(!a.right.y)
  {
   if(a.right.x>=0) return(1);
   else            {/*dprintf(5,"!aright.y x<0");*/return(0);}
  }
  else
  if((a.left.y ^ a.right.y)<0)
  {
   if((a.left.x ^ a.right.x )<0 ||
      (a.left.x ^ a.rightc.x)<0 ||
      (a.left.x ^ a.leftc.x )<0)
   {
    /* split */

    t=a;
   }
   else
   if(a.left.x>=0) return(1);
   else           {/*dprintf(5,"aleft==aright x<0");*/return(0);}
  }
 /* else          b.left=a.right 
  if(!b.left.y)
  {
   if(b.left.x>=0) return(1);
   else            return(0);
  }     */
  else
  if(!b.right.y)
  {
   if(b.right.x>=0) return(1);
   else            {/*dprintf(5,"!bright.y x<0");*/return(0);}
  }
  else
  if((b.left.y ^ b.right.y)<0)
  {
   if((b.left.x ^ b.right.x )<0 ||
      (b.left.x ^ b.rightc.x)<0 ||
      (b.left.x ^ b.leftc.x )<0)
   {
    /* split */

    t=b;
   }
   else
   if(b.left.x>=0) return(1);
   else           {/*dprintf(5,"bleft=bright x<0");*/return(0);}
  }
  else {/*dprintf(5,"equal y's");*/return(0);}
 }

 return(0);
}




/* results of a ray from x,y to left infinity, on a curve cx[0],cx[1]... */
/* in INTERXY X denotes the line, and Y the end of the other line on it  */


int hbintersection(int x,int y,coordstr * cx)
{
 int         val[2];
 int         uval[2];
 int         i;
 int         n;
 int         roots;
 bezier      p;
 bezsplitstr split[3];



 p.left.y=cx[0].y-y;
 p.leftc.y=cx[1].y-y;
 p.rightc.y=cx[2].y-y;
 p.right.y=cx[3].y-y;

 if((p.left.y^p.leftc.y)<0  || 
    (p.left.y^p.rightc.y)<0 || 
    (p.left.y^p.right.y)<0)
 {
  p.left.x=cx[0].x-x;
  p.leftc.x=cx[1].x-x;
  p.rightc.x=cx[2].x-x;
  p.right.x=cx[3].x-x;

  if((p.left.x^p.leftc.x)<0  || 
     (p.left.x^p.rightc.x)<0 || 
     (p.left.x^p.right.x)<0)
  {
   /* get y roots - calculate x values */

   bezchunks(&p,split,&n,NULL);

 /*  dprintf(10,"get y roots - calculate x values n=%d",n); */

   roots=0;

   for(i=0;i<n;i++)
   {
    roots+=hbsub(&split[i].b);
   }

   return(roots);
  }
  else
  if(p.left.x>0)  /* any y root is an x root */
  {
   roots=0;

   n=bezmaxmin(p.left.y,p.leftc.y,p.rightc.y,p.right.y,val,uval);

  /* dprintf(10,"any y root is an x root n=%d",n); */

   if(n)
   {
    if((p.left.y ^ val[0])<0)      roots++;

    if(n==2)
    {
     if((val[0] ^ val[1])<0)       roots++;
     if((val[1] ^ p.right.y)<0)    roots++;
    }
    else
    {
     if((val[0] ^ p.right.y)<0)    roots++;
    }
   }
   else roots=1;

   return(roots);
  }
 }

 return(0);
}


/*************************************************************************/

/* this is the closest we can get a max/min to being inside the */
/* tangent bounds                                               */

#define BEZMAXERR 32


static int hbsubr(bezier * p,int mx,cutstr * result,int iumin,int iumax)
{
 bezier a;
 bezier b;
 bezier t;
 int    temp;
 int    umid;
 int    umin;
 int    umax;

 t=*p;
 umin=iumin;
 umax=iumax;


 while(1)
 {
  umid=(umin+umax)/2;

  /* y coords */

  a.left=t.left;
  b.right=t.right;


  temp=(t.leftc.y+t.rightc.y)/2;

  a.leftc.y =(t.left.y+t.leftc.y)/2;
  a.rightc.y=(temp+a.leftc.y)/2;
  b.rightc.y=(t.rightc.y+t.right.y)/2;
  b.leftc.y =(temp+b.rightc.y)/2;

  a.right.y=(a.rightc.y+b.leftc.y)/2;


  /* x coords */

  temp=(t.leftc.x+t.rightc.x)/2;

  a.leftc.x =(t.left.x+t.leftc.x)/2;
  a.rightc.x=(temp+a.leftc.x)/2;
  b.rightc.x=(t.rightc.x+t.right.x)/2;
  b.leftc.x =(temp+b.rightc.x)/2;

  a.right.x=(a.rightc.x+b.leftc.x)/2;

  b.left=a.right;


/*  dprintf(0,"aleft=%d bright=%d",a.left.y,b.right.y); */


  if(!a.left.y && !a.right.y)
  {


   return(0);
  }
  else
  if(!a.left.y)
  {
   if(a.left.x>=0 && a.left.x<=mx) 
   {
    memset(result,0,sizeof(cutstr));

    result->type=INTER;

    if(umin==iumin) 
    {
     result->type|=INTER00;
     if(a.left.x==0) result->type|=INTER10;
    }

    result->c.x=a.left.x;
    result->c.y=0;
    result->u2=umin;
    result->umin2=iumin;
    result->umax2=iumax;

    return(1);
   }
   else           {/*dprintf(5,"!aleft.y x<0");*/return(0);}
  }
  else
  if(!b.right.y)
  {
   if(b.right.x>=0 && b.right.x<=mx) 
   {
    memset(result,0,sizeof(cutstr));

    result->type=INTER;

    if(umax==iumax) 
    {
     result->type|=INTER01;
     if(b.right.x==0) result->type|=INTER11;
    }

    result->c.x=b.right.x;
    result->c.y=0;
    result->u2=umax;
    result->umin2=iumin;
    result->umax2=iumax;
    return(1);
   }
   else            {/*dprintf(5,"!aright.y x<0");*/return(0);}
  }
  else
  if(!a.right.y)
  {
   if(a.right.x>=0 && a.right.x<=mx) 
   {
    memset(result,0,sizeof(cutstr));

    result->type=INTER;
    result->c.x=a.right.x;
    result->c.y=0;
    result->u2=umid;
    result->umin2=iumin;
    result->umax2=iumax;
    return(1);
   }
   else            {/*dprintf(5,"!aright.y x<0");*/return(0);}
  }
/*  else                          not used because b.left=a.right
  if(!b.left.y)
  {
   if(b.left.x>=0 && b.left.x<=mx) 
   {
    memset(result,0,sizeof(cutstr));

    result->type=INTER;
    result->c.x=b.left.x;
    result->c.y=0;
    result->u2=umid;
    result->umin2=iumin;
    result->umax2=iumax;
    return(1);
   }
   else           return(0);
  }  */
  else
  if((a.left.y ^ a.right.y)<0)
  {
   if(a.left.x<0 && a.leftc.x<0 && a.rightc.x<0 && a.right.x<0) return(0);
   if(a.left.x>mx && a.leftc.x>mx && a.rightc.x>mx && a.right.x>mx) return(0);
   t=a;
   umax=umid;
  }
  else
  if((b.left.y ^ b.right.y)<0)
  {
   if(b.left.x<0 && b.leftc.x<0 && b.rightc.x<0 && b.right.x<0) return(0);
   if(b.left.x>mx && b.leftc.x>mx && b.rightc.x>mx && b.right.x>mx) return(0);
   t=b;
   umin=umid;
  }
  else return(0);
 }

 return(0);
}





/* intersections of horizontal ray  ray[0]->ray[1] with cx[0],cx[1]... */

int hbintersectionr(coordstr * ray,coordstr * cx,cutstr * result)
{
 int         y;
 int         x;
 int         mx;
 bezier      p;
 int         n;
 int         i;
 int         roots;
 bezsplitstr split[3];

 y=ray[0].y;

 p.left.y  =cx[0].y-y;
 p.leftc.y =cx[1].y-y;
 p.rightc.y=cx[2].y-y;
 p.right.y =cx[3].y-y;

/* if((p.left.y^p.leftc.y)<0  || 
    (p.left.y^p.rightc.y)<0 || 
    (p.left.y^p.right.y)<0)  */

 if(p.left.y>BEZMAXERR   && p.leftc.y>BEZMAXERR && 
    p.rightc.y>BEZMAXERR && p.right.y>BEZMAXERR) return(0);

 if(p.left.y<-BEZMAXERR && p.leftc.y<-BEZMAXERR && 
    p.rightc.y<-BEZMAXERR && p.right.y<-BEZMAXERR) return(0);

 {
  x=ray[0].x;
  mx=ray[1].x-x;

  p.left.x  =cx[0].x-x;
  p.leftc.x =cx[1].x-x;
  p.rightc.x=cx[2].x-x;
  p.right.x =cx[3].x-x;


  if(p.left.x<0  && p.leftc.x<0  && p.rightc.x<0  && p.right.x<0)  return(0);
  if(p.left.x>mx && p.leftc.x>mx && p.rightc.x>mx && p.right.x>mx) return(0);

  roots=0;

  bezchunks((bezier*)cx,split,&n,NULL);

  for(i=0;i<n;i++)
  {

 /*  dprintf(0,"chunk=%d umin=%x umax=%x",i,split[i].umin,split[i].umax);
   dprintf(0,"left x=%d y=%d right x=%d y=%d",
                          split[i].b.left.x,split[i].b.left.y, 
                          split[i].b.right.x,split[i].b.right.y); */


   split[i].b.left.y-=y;
   split[i].b.leftc.y-=y;
   split[i].b.right.y-=y;
   split[i].b.rightc.y-=y;

   split[i].b.left.x-=x;
   split[i].b.leftc.x-=x;
   split[i].b.right.x-=x;
   split[i].b.rightc.x-=x;


   if(hbsubr(&split[i].b,mx,&result[roots],split[i].umin,split[i].umax))
   {
    if(n>1)
    {
     if(i==0)
     {
      if(result[roots].type & INTER01) result[roots].type|=INTERMX2;
      result[roots].type&=~INTER01;
     }
     else
     if(i==(n-1))
     {
      if(result[roots].type & INTER00) result[roots].type|=INTERMX2;
      result[roots].type&=~INTER00;
     }
     else
     {
      if(result[roots].type & INTER00) result[roots].type|=INTERMX2;
      if(result[roots].type & INTER01) result[roots].type|=INTERMX2;
      result[roots].type&=~(INTER00|INTER01);
     }
    }

    result[roots].c.x+=x;
    result[roots].c.y+=y;

   /* dprintf(0,"result at x=%d y=%d",result[roots].c.x,result[roots].c.y); */

    roots++;
   }
  }

  return(roots);
 }

 return(0);
}



int hbintersectionc(coordstr * ray,coordstr * cx,cutstr * result)
{
 int cuts;
 int n;

 cuts=hbintersectionr(ray,cx,result);

 for(n=0;n<cuts;n++)
 {
  if(result[n].type & INTERMX2)
  {
   bezdev((bezier *)cx,result[n].u2,&result[n].dx2,NULL,NULL,&result[n].d2y2);
  }
  else
  {
   bezdev((bezier *)cx,result[n].u2,NULL,&result[n].dy2,NULL,NULL);
  }
 }

 return(cuts);
}


/****************************************************************************/



#ifdef NEVER



static int vbsubr(bezier * p,int my,cutstr * result,int iumin,int iumax)
{
 bezier a;
 bezier b;
 bezier t;
 int    temp;
 int    umid;
 int    umin;
 int    umax;

 t=*p;
 umin=iumin;
 umax=iumax;


 while(1)
 {
  umid=(umin+umax)/2;

  /* y coords */

  a.left=t.left;
  b.right=t.right;


  temp=(t.leftc.y+t.rightc.y)/2;

  a.leftc.y =(t.left.y+t.leftc.y)/2;
  a.rightc.y=(temp+a.leftc.y)/2;
  b.rightc.y=(t.rightc.y+t.right.y)/2;
  b.leftc.y =(temp+b.rightc.y)/2;

  a.right.y=(a.rightc.y+b.leftc.y)/2;


  /* x coords */

  temp=(t.leftc.x+t.rightc.x)/2;

  a.leftc.x =(t.left.x+t.leftc.x)/2;
  a.rightc.x=(temp+a.leftc.x)/2;
  b.rightc.x=(t.rightc.x+t.right.x)/2;
  b.leftc.x =(temp+b.rightc.x)/2;

  a.right.x=(a.rightc.x+b.leftc.x)/2;

  b.left=a.right;



  if(!a.left.x && !a.right.x)
  {


   return(0);
  }
  else
  if(!a.left.x)
  {
   if(a.left.y>=0 && a.left.y<=my) 
   {
    memset(result,0,sizeof(cutstr));

    result->type=INTER;

    if(umin==iumin) 
    {
     result->type|=INTER00;
     if(a.left.y==0) result->type|=INTER10;
    }

    result->c.y=a.left.y;
    result->c.x=0;
    result->u2=umin;
    result->umin2=iumin;
    result->umax2=iumax;

    return(1);
   }
   else           {/*dprintf(5,"!aleft.y x<0");*/return(0);}
  }
  else
  if(!a.right.x)
  {
   if(a.right.y>=0 && a.right.x<=my) 
   {
    memset(result,0,sizeof(cutstr));

    result->type=INTER;
    result->c.y=a.right.y;
    result->c.x=0;
    result->u2=umid;
    result->umin2=iumin;
    result->umax2=iumax;
    return(1);
   }
   else            {/*dprintf(5,"!aright.y x<0");*/return(0);}
  }
  else
  if((a.left.x ^ a.right.x)<0)
  {
   if(a.left.y<0 && a.leftc.y<0 && a.rightc.y<0 && a.right.y<0) return(0);
   if(a.left.y>my && a.leftc.y>my && a.rightc.y>my && a.right.y>my) return(0);
   t=a;
   umax=umid;
  }
/*  else                          not used because b.left=a.right
  if(!b.left.x)
  {
   if(b.left.y>=0 && b.left.y<=my) 
   {
    memset(result,0,sizeof(cutstr));

    result->type=INTER;
    result->c.y=b.left.y;
    result->c.x=0;
    result->u2=umid;
    result->umin2=iumin;
    result->umax2=iumax;
    return(1);
   }
   else           return(0);
  }  */
  else
  if(!b.right.x)
  {
   if(b.right.y>=0 && b.right.y<=my) 
   {
    memset(result,0,sizeof(cutstr));

    result->type=INTER;

    if(umax==iumax) 
    {
     result->type|=INTER01;
     if(b.right.y==0) result->type|=INTER11;
    }

    result->c.y=b.right.y;
    result->c.x=0;
    result->u2=umax;
    result->umin2=iumin;
    result->umax2=iumax;
    return(1);
   }
   else            {/*dprintf(5,"!aright.y x<0");*/return(0);}
  }
  else
  if((b.left.x ^ b.right.x)<0)
  {
   if(b.left.y<0 && b.leftc.y<0 && b.rightc.y<0 && b.right.y<0) return(0);
   if(b.left.y>my && b.leftc.y>my && b.rightc.y>my && b.right.x>my) return(0);
   t=b;
   umin=umid;
  }
  else return(0);
 }

 return(0);
}



/* intersections of vertical ray  ray[0]->ray[1] with cx[0],cx[1]... */

int vbintersectionr(coordstr * ray,coordstr * cx,cutstr * result)
{
 int         y;
 int         x;
 int         my;
 bezier      p;
 int         n;
 int         i;
 int         roots;
 bezsplitstr split[3];


 x=ray[0].x;

 p.left.x  =cx[0].x-x;
 p.leftc.x =cx[1].x-x;
 p.rightc.x=cx[2].x-x;
 p.right.x =cx[3].x-x;


/* if((p.left.y^p.leftc.y)<0  || 
    (p.left.y^p.rightc.y)<0 || 
    (p.left.y^p.right.y)<0)  */

 if(p.left.x>BEZMAXERR   && p.leftc.x>BEZMAXERR && 
    p.rightc.x>BEZMAXERR && p.right.x>BEZMAXERR) return(0);

 if(p.left.x<-BEZMAXERR && p.leftc.x<-BEZMAXERR && 
    p.rightc.x<-BEZMAXERR && p.right.x<-BEZMAXERR) return(0);

 {
  y=ray[0].y;
  my=ray[1].y-y;

  p.left.y  =cx[0].y-y;
  p.leftc.y =cx[1].y-y;
  p.rightc.y=cx[2].y-y;
  p.right.y =cx[3].y-y;


  if(p.left.y<0  && p.leftc.y<0  && p.rightc.y<0  && p.right.y<0)  return(0);
  if(p.left.y>my && p.leftc.y>my && p.rightc.y>my && p.right.y>my) return(0);

  roots=0;


  bezchunks((bezier*)cx,split,&n,NULL);

  for(i=0;i<n;i++)
  {
   split[i].b.left.y-=y;
   split[i].b.leftc.y-=y;
   split[i].b.right.y-=y;
   split[i].b.rightc.y-=y;

   split[i].b.left.x-=x;
   split[i].b.leftc.x-=x;
   split[i].b.right.x-=x;
   split[i].b.rightc.x-=x;

   if(vbsubr(&split[i].b,my,&result[roots],split[i].umin,split[i].umax))
   {
    if(n>1)
    {
     if(i==0)
     {
      if(result[roots].type & INTER01) result[roots].type|=INTERMX2;
      result[roots].type&=~INTER01;
     }
     else
     if(i==(n-1))
     {
      if(result[roots].type & INTER00) result[roots].type|=INTERMX2;
      result[roots].type&=~INTER00;
     }
     else
     {
      if(result[roots].type & INTER00) result[roots].type|=INTERMX2;
      if(result[roots].type & INTER01) result[roots].type|=INTERMX2;
      result[roots].type&=~(INTER00|INTER01);
     }
    }

    result[roots].c.x+=x;
    result[roots].c.y+=y;
    roots++;
   }
  }
  return(roots);
 }

 return(0);
}



int vbintersectionc(coordstr * ray,coordstr * cx,cutstr * result)
{
 int cuts;
 int n;

 cuts=vbintersectionr(ray,cx,result);

 for(n=0;n<cuts;n++)
 {
  result[n].dy1=ray[0].y-ray[1].y;

  if(result[n].type & INTERMX2)
  {
   bezdev((bezier *)cx,result[n].u2,NULL,&result[n].dx2,NULL,&result[n].d2y2);
  }
  else
  {
   bezdev((bezier *)cx,result[n].u2,&result[n].dx2,&result[n].dy2,NULL,NULL);
  }
 }

 return(cuts);
}


#endif



int vbintersectionr(coordstr * ray,coordstr * cx,cutstr * result)
{
 return(bintersection(ray,cx,result));
}



int vbintersectionc(coordstr * ray,coordstr * cx,cutstr * result)
{
 int cuts;
 int n;

 cuts=vbintersectionr(ray,cx,result);

 for(n=0;n<cuts;n++)
 {
  bezdev((bezier *)cx,result[n].u2,&result[n].dx2,&result[n].dy2,NULL,NULL);

  result[n].dx1=ray[1].x-ray[0].x;
  result[n].dy1=ray[1].y-ray[0].y;
 }

 return(cuts);
}


/****************************************************************************/


static int      brcount;
static cutstr * bresult;
static int      biumin;
static int      biumax;



#define BEZSPLIT  256
#define LINESPLIT 256


static int bsub(aboxstr * box,bezier * p,int ulo,int uhi)
{
 bezier  a;
 bezier  b;
 aboxstr ba;
 aboxstr bb;
 int     temp;
 int     umid;
 int     splitx;
 int     splity;


 /* box and bezier don't overlap return 0 */

 if(p->left.x<p->right.x)
 {
  ba.x0=p->left.x;
  ba.x1=p->right.x;
 }
 else
 {
  ba.x1=p->left.x;
  ba.x0=p->right.x;
 }


 if(p->leftc.x<ba.x0)  ba.x0=p->leftc.x;
 else
 if(p->leftc.x>ba.x1)  ba.x1=p->leftc.x;

 if(p->rightc.x<ba.x0) ba.x0=p->rightc.x;
 else
 if(p->rightc.x>ba.x1) ba.x1=p->rightc.x;


 if(p->left.y<p->right.y)
 {
  ba.y0=p->left.y;
  ba.y1=p->right.y;
 }
 else
 {
  ba.y1=p->left.y;
  ba.y0=p->right.y;
 }

 if(p->leftc.y<ba.y0)  ba.y0=p->leftc.y;
 else
 if(p->leftc.y>ba.y1)  ba.y1=p->leftc.y;

 if(p->rightc.y<ba.y0) ba.y0=p->rightc.y;
 else
 if(p->rightc.y>ba.y1) ba.y1=p->rightc.y;


 if(box->x0<box->x1)
 {
  if(box->x1<ba.x0) return(0);
  if(box->x0>ba.x1) return(0);
  splitx=(box->x1-box->x0)>LINESPLIT;
 }
 else
 {
  if(box->x0<ba.x0) return(0);
  if(box->x1>ba.x1) return(0);
  splitx=(box->x0-box->x1)>LINESPLIT;
 }

 if(box->y0<box->y1)
 {
  if(box->y1<ba.y0) return(0);
  if(box->y0>ba.y1) return(0);
  splity=(box->y1-box->y0)>LINESPLIT;
 }
 else
 {
  if(box->y0<ba.y0) return(0);
  if(box->y1>ba.y1) return(0);
  splity=(box->y0-box->y1)>LINESPLIT;
 }


 if((ba.x1-ba.x0)<=BEZSPLIT && (ba.y1-ba.y0)<=BEZSPLIT)
 {
  coordstr cx1[2];
  coordstr cx2[2];
  int      code;

  cx1[0].x=box->x0;
  cx1[0].y=box->y0;
  cx1[1].x=box->x1;
  cx1[1].y=box->y1;

  cx2[0].x=p->left.x;
  cx2[0].y=p->left.y;
  cx2[1].x=p->right.x;
  cx2[1].y=p->right.y;

  code=intersection(cx1,cx2,&bresult[brcount]);
  if(code)
  {
   if(!(code & (INTER00|INTER10|INTERCO)))
   {
    if((ba.x1-ba.x0)>(ba.y1-ba.y0))
    {
     if(cx2[0].x==ba.x0)
     {
      bresult[brcount].u2=ulo+scale(bresult[brcount].c.x-ba.x0,uhi-ulo,
                                                   ba.x1-ba.x0);
     }
     else
     {
      bresult[brcount].u2=ulo+scale(ba.x1-bresult[brcount].c.x,uhi-ulo,
                                    ba.x1-ba.x0);
     }
    }
    else
    {
     if(cx2[0].y==ba.y0)
     {
      bresult[brcount].u2=ulo+scale(bresult[brcount].c.y-ba.y0,uhi-ulo,
                                                   ba.y1-ba.y0);
     }
     else
     {
      bresult[brcount].u2=ulo+scale(ba.y1-bresult[brcount].c.y,uhi-ulo,
                                    ba.y1-ba.y0);
     }
    }

    bresult[brcount].umin2=biumin;
    bresult[brcount].umax2=biumax;
    brcount++;
   }
  }

  return(1);
 }


 a.left=p->left;
 b.right=p->right;

  /* x coords */

 temp=(p->leftc.x+p->rightc.x)/2;

 a.leftc.x =(p->left.x+p->leftc.x)/2;
 a.rightc.x=(temp+a.leftc.x)/2;
 b.rightc.x=(p->rightc.x+p->right.x)/2;
 b.leftc.x =(temp+b.rightc.x)/2;

 a.right.x=(a.rightc.x+b.leftc.x)/2;

  /* y coords */

 temp=(p->leftc.y+p->rightc.y)/2;

 a.leftc.y =(p->left.y+p->leftc.y)/2;
 a.rightc.y=(temp+a.leftc.y)/2;
 b.rightc.y=(p->rightc.y+p->right.y)/2;
 b.leftc.y =(temp+b.rightc.y)/2;

 a.right.y=(a.rightc.y+b.leftc.y)/2;

 b.left=a.right;

 umid=(uhi+ulo)/2;

 if(splitx || splity)
 {
  ba.x0=box->x0;
  ba.x1=(box->x1+box->x0)/2;
  bb.x0=ba.x1; 
  bb.x1=box->x1;

  ba.y0=box->y0;
  ba.y1=(box->y0+box->y1)/2;
  bb.y0=ba.y1;
  bb.y1=box->y1;

  bsub(&ba,&a,ulo,umid);
  bsub(&ba,&b,umid,uhi);

  bsub(&bb,&a,ulo,umid);
  bsub(&bb,&b,umid,uhi);
 }
 else
 {
  bsub(box,&a,ulo,umid);
  bsub(box,&b,umid,uhi);
 }

 return(0);
}





/*

 get curvature


 int     x1;
 int     x2;
 int     y1;
 int     y2;
 int     x;
 int     y;
 int     l;


 x1=(coord1[2].x-coord1[1].x)-(coord1[1].x-coord1[0].x);
 if(x1<0) x1=-x1;
 x2=(coord1[3].x-coord1[2].x)-(coord1[2].x-coord1[1].x);
 if(x2<0) x2=-x2;

 y1=(coord1[2].y-coord1[1].y)-(coord1[1].y-coord1[0].y);
 if(y1<0) y1=-y1;
 y2=(coord1[3].y-coord1[2].y)-(coord1[2].y-coord1[1].y);
 if(y2<0) y2=-y2;

 x=MAX(x1,x2);
 y=MAX(y1,y2);

 l=MAX(x,y);

*/



/* coord0 2 points of line  */
/* coord1 4 points of curve */


int bintersection(coordstr * coord0,coordstr * coord1,cutstr * result)
{
 aboxstr     box;
 int         i;
 int         n;
 bezsplitstr split[3];
 int         dx1;
 int         dy1;

 box.x0=coord0[0].x;
 box.y0=coord0[0].y;
 box.x1=coord0[1].x;
 box.y1=coord0[1].y;

 brcount=0;       /* this is a global static variable */
 bresult=result;  /* this is a global static variable */

 bezchunks((bezier*)coord1,split,&n,NULL);
 for(i=0;i<n;i++)
 {
  biumin=split[i].umin;
  biumax=split[i].umax;
  bsub(&box,&split[i].b,biumin,biumax);
 }

 if(brcount)
 {
  dx1=box.x1-box.x0;
  dy1=box.y1-box.y0;

  for(i=0;i<brcount;i++)
  {
   result[i].dx1=dx1;
   result[i].dy1=dy1;
  }
 }

 return(brcount);
}







static void bqbound(bezier * p,aboxstr * ba)
{
 register int lo;
 register int hi;

 if(p->left.x<p->right.x)
 {
  lo=p->left.x;
  hi=p->right.x;
 }
 else
 {
  lo=p->right.x;
  hi=p->left.x;
 }

 if(p->leftc.x<lo)  lo=p->leftc.x;
 else
 if(p->leftc.x>hi)  hi=p->leftc.x;

 if(p->rightc.x<lo) lo=p->rightc.x;
 else
 if(p->rightc.x>hi) hi=p->rightc.x;

 ba->x0=lo;
 ba->x1=hi;

 if(p->left.y<p->right.y)
 {
  lo=p->left.y;
  hi=p->right.y;
 }
 else
 {
  lo=p->right.y;
  hi=p->left.y;
 }

 if(p->leftc.y<lo)  lo=p->leftc.y;
 else
 if(p->leftc.y>hi)  hi=p->leftc.y;

 if(p->rightc.y<lo) lo=p->rightc.y;
 else
 if(p->rightc.y>hi) hi=p->rightc.y;

 ba->y0=lo;
 ba->y1=hi;
}


static void bdivide(bezier * p,bezier * a,bezier * b)
{
 int temp;

 a->left=p->left;
 b->right=p->right;

  /* x coords */

 temp=(p->leftc.x+p->rightc.x)/2;

 a->leftc.x =(p->left.x+p->leftc.x)/2;
 a->rightc.x=(temp+a->leftc.x)/2;
 b->rightc.x=(p->rightc.x+p->right.x)/2;
 b->leftc.x =(temp+b->rightc.x)/2;

 a->right.x=(a->rightc.x+b->leftc.x)/2;

  /* y coords */

 temp=(p->leftc.y+p->rightc.y)/2;

 a->leftc.y =(p->left.y+p->leftc.y)/2;
 a->rightc.y=(temp+a->leftc.y)/2;
 b->rightc.y=(p->rightc.y+p->right.y)/2;
 b->leftc.y =(temp+b->rightc.y)/2;

 a->right.y=(a->rightc.y+b->leftc.y)/2;

 b->left=a->right;
}




int bezvalx(int p0,int p1,int p2,int p3,int u)
{
 int temp;
 int up;
 int aleftc;
 int arightc;
 int bleftc;
 int brightc;


 u=CUT(u,0,0x10000);

 up=0x10000-u;

 temp=ttmul(up,p1)+ttmul(u,p2);

 aleftc =ttmul(up,p0)+ttmul(u,p1);
 arightc=ttmul(up,aleftc)+ttmul(u,temp);

 brightc=ttmul(up,p2)+ttmul(u,p3);
 bleftc =ttmul(up,temp)+ttmul(u,brightc);

 return(ttmul(up,arightc)+ttmul(u,bleftc));
}





/* 0<=u<=0x10000 */

void bezsplit2(bezier * p,bezier * a,bezier * b,int u)
{
 int temp;
 int up;

 u=CUT(u,0,0x10000);

 if(u==0)
 {
  *b=*p;
  a->left=p->left;
  a->leftc=p->left;
  a->rightc=p->left;
  a->right=p->left;
 }
 else
 {
  up=0x10000-u;

  a->left=p->left;
  b->right=p->right;

  /* x coords */

  temp=ttmul(up,p->leftc.x)+ttmul(u,p->rightc.x);

  a->leftc.x =ttmul(up,p->left.x)+ttmul(u,p->leftc.x);
  a->rightc.x=ttmul(up,a->leftc.x)+ttmul(u,temp);
  b->rightc.x=ttmul(up,p->rightc.x)+ttmul(u,p->right.x);
  b->leftc.x =ttmul(up,temp)+ttmul(u,b->rightc.x);

  a->right.x=ttmul(up,a->rightc.x)+ttmul(u,b->leftc.x);

  /* y coords */

  temp=ttmul(up,p->leftc.y)+ttmul(u,p->rightc.y);

  a->leftc.y =ttmul(up,p->left.y)+ttmul(u,p->leftc.y);
  a->rightc.y=ttmul(up,a->leftc.y)+ttmul(u,temp);
  b->rightc.y=ttmul(up,p->rightc.y)+ttmul(u,p->right.y);
  b->leftc.y =ttmul(up,temp)+ttmul(u,b->rightc.y);

  a->right.y=ttmul(up,a->rightc.y)+ttmul(u,b->leftc.y);

  b->left=a->right;
 }
}



#ifdef NEVER

void bezsplit3(bezier * p,bezier * a,bezier * b,bezier * c,int u1,int u2)
{
 int    temp;
 int    up1;
 int    up2;
 bezier b1;
 bezier b2;

 u1=CUT(u1,0,0x10000);
 u2=CUT(u2,0,0x10000);

 if(u1==0)
 {
  a->left=p->left;
  a->leftc=p->left;
  a->rightc=p->left;
  a->right=p->left;

  bezsplit2(p,b,c,u2);
 }
 else
 if(u2==0x10000)
 {
  c->left=p->right;
  c->leftc=p->right;
  c->rightc=p->right;
  c->right=p->right;

  bezsplit2(p,a,b,u1);
 }
 else
 {
  up1=0x10000-u1;
  up2=0x10000-u2;

  a->left=p->left;
  c->right=p->right;

 /* x coords */

  temp=ttmul(up1,p->leftc.x)+ttmul(u1,p->rightc.x);

  a->leftc.x =ttmul(up1,p->left.x)+ttmul(u1,p->leftc.x);
  a->rightc.x=ttmul(up1,a->leftc.x)+ttmul(u1,temp);

  b1.rightc.x=ttmul(up1,p->rightc.x)+ttmul(u1,p->right.x);
  b1.leftc.x =ttmul(up1,temp)+ttmul(u1,b1.rightc.x);

  a->right.x=b1.left.x=ttmul(up1,a->rightc.x)+ttmul(u1,b1.leftc.x);


  temp=ttmul(up2,p->leftc.x)+ttmul(u2,p->rightc.x);

  b2.leftc.x=ttmul(up2,p->left.x)+ttmul(u2,p->leftc.x);
  b2.rightc.x=ttmul(up2,b2.leftc.x)+ttmul(u2,temp);

  c->rightc.x=ttmul(up2,p->rightc.x)+ttmul(u2,p->right.x);
  c->leftc.x =ttmul(up2,temp)+ttmul(u2,c->rightc.x);
  b2.right.x=c->left.x=ttmul(up2,b2.rightc.x)+ttmul(u2,c->leftc.x);


  /* y coords */

  temp=ttmul(up1,p->leftc.y)+ttmul(u1,p->rightc.y);
  
  a->leftc.y =ttmul(up1,p->left.y)+ttmul(u1,p->leftc.y);
  a->rightc.y=ttmul(up1,a->leftc.y)+ttmul(u1,temp);

  b1.rightc.y=ttmul(up1,p->rightc.y)+ttmul(u1,p->right.y);
  b1.leftc.y =ttmul(up1,temp)+ttmul(u1,b1.rightc.y);

  a->right.y=b1.left.y=ttmul(up1,a->rightc.y)+ttmul(u1,b1.leftc.y);


  temp=ttmul(up2,p->leftc.y)+ttmul(u2,p->rightc.y);

  b2.leftc.y=ttmul(up2,p->left.y)+ttmul(u2,p->leftc.y);
  b2.rightc.y=ttmul(up2,b2.leftc.y)+ttmul(u2,temp);                                                                                
  c->rightc.y=ttmul(up2,p->rightc.y)+ttmul(u2,p->right.y);
  c->leftc.y =ttmul(up2,temp)+ttmul(u2,c->rightc.y);
  b2.right.y=c->left.y=ttmul(up2,b2.rightc.y)+ttmul(u2,c->leftc.y);


  b->left=b1.left;
  b->leftc=b1.leftc;
  b->right=b2.right;
  b->rightc=b2.rightc;
 }
}

#endif





void bezsplit3(bezier * p,bezier * a,bezier * b,bezier * c,int u1,int u2)
{
 bezier t;

 u1=CUT(u1,0,0x10000);
 u2=CUT(u2,0,0x10000);

 if(u1==0)
 {
  a->left=p->left;
  a->leftc=p->left;
  a->rightc=p->left;
  a->right=p->left;

  bezsplit2(p,b,c,u2);
 }
 else
 if(u2==0x10000)
 {
  c->left=p->right;
  c->leftc=p->right;
  c->rightc=p->right;
  c->right=p->right;

  bezsplit2(p,a,b,u1);
 }
 else
 {
  if(u1<0x8000)
  {
   bezsplit2(p,a,&t,u1);
   u2=scale(u2-u1,0x10000,0x10000-u1);
   bezsplit2(&t,b,c,u2);
  }
  else
  {
   bezsplit2(p,&t,c,u2);
   u1=scale(u1,0x10000,u2);
   bezsplit2(&t,a,b,u1);
  }
 }
}
















static int biumin1;
static int biumin2;
static int biumax1;
static int biumax2;



static int bbsub(bezier * p1,int ulo1,int uhi1,
                 bezier * p2,int ulo2,int uhi2)
{
 bezier  a1;
 bezier  b1;
 aboxstr ba1;
 bezier  a2;
 bezier  b2;
 aboxstr ba2;
 int     dx1;
 int     dy1;
 int     dx2;
 int     dy2;
 int     umid1;
 int     umid2;
 int     split1;
 int     split2;


 /* don't overlap return 0 */

 bqbound(p1,&ba1);
 bqbound(p2,&ba2);

 if(ba1.x0>ba2.x1 || ba1.x1<ba2.x0) return(0);
 if(ba1.y0>ba2.y1 || ba1.y1<ba2.y0) return(0);

 umid1=(ulo1+uhi1)/2;
 umid2=(ulo2+uhi2)/2;

 dx1=ba1.x1-ba1.x0;
 dx2=ba2.x1-ba2.x0;
 dy1=ba1.y1-ba1.y0;
 dy2=ba2.y1-ba2.y0;

 split1=(dx1>BEZSPLIT) || (dy1>BEZSPLIT);
 split2=(dx2>BEZSPLIT) || (dy2>BEZSPLIT);

 if(!split1 && !split2)
 {
  coordstr cx1[2];
  coordstr cx2[2];
  int      code;

  cx1[0].x=p1->left.x;
  cx1[0].y=p1->left.y;
  cx1[1].x=p1->right.x;
  cx1[1].y=p1->right.y;

  cx2[0].x=p2->left.x;
  cx2[0].y=p2->left.y;
  cx2[1].x=p2->right.x;
  cx2[1].y=p2->right.y;

  code=intersection(cx1,cx2,&bresult[brcount]);
  if(code)
  {
   if(!(code & (INTER00|INTER10|INTERCO)))
   {
    if((ba1.x1-ba1.x0)>(ba1.y1-ba1.y0))
    {
     if(cx1[0].x==ba1.x0)
     {
      bresult[brcount].u1=ulo1+scale(bresult[brcount].c.x-ba1.x0,uhi1-ulo1,
                                                   ba1.x1-ba1.x0);
     }
     else
     {
      bresult[brcount].u1=ulo1+scale(ba1.x1-bresult[brcount].c.x,uhi1-ulo1,
                                     ba1.x1-ba1.x0);
     }
    }
    else
    {
     if(cx1[0].y==ba1.y0)
     {
      bresult[brcount].u1=ulo1+scale(bresult[brcount].c.y-ba1.y0,uhi1-ulo1,
                                                   ba1.y1-ba1.y0);
     }
     else
     {
      bresult[brcount].u1=ulo1+scale(ba1.y1-bresult[brcount].c.y,uhi1-ulo1,
                                     ba1.y1-ba1.y0);
     }
    }

    if((ba2.x1-ba2.x0)>(ba2.y1-ba2.y0))
    {
     if(cx2[0].x==ba2.x0)
     {
      bresult[brcount].u2=ulo2+scale(bresult[brcount].c.x-ba2.x0,uhi2-ulo2,
                                                   ba2.x1-ba2.x0);
     }
     else
     {
      bresult[brcount].u2=ulo2+scale(ba2.x1-bresult[brcount].c.x,uhi2-ulo2,
                                     ba2.x1-ba2.x0);
     }
    }
    else
    {
     if(cx2[0].y==ba2.y0)
     {
      bresult[brcount].u2=ulo2+scale(bresult[brcount].c.y-ba2.y0,uhi2-ulo2,
                                                   ba2.y1-ba2.y0);
     }
     else
     {
      bresult[brcount].u2=ulo2+scale(ba2.y1-bresult[brcount].c.y,uhi2-ulo2,
                                     ba2.y1-ba2.y0);
     }
    }


    bresult[brcount].umin1=biumin1;
    bresult[brcount].umax1=biumax1;
    bresult[brcount].umin2=biumin2;
    bresult[brcount].umax2=biumax2;

    brcount++;
   }
  }

  return(1);
 }

 if(split1 && split2)
 {
  bdivide(p1,&a1,&b1);
  bdivide(p2,&a2,&b2);

  bbsub(&a1,ulo1,umid1,&a2,ulo2,umid2);
  bbsub(&a1,ulo1,umid1,&b2,umid2,uhi2);

  bbsub(&b1,umid1,uhi1,&a2,ulo2,umid2);
  bbsub(&b1,umid1,uhi1,&b2,umid2,uhi2);
 }
 else
 if(split1)
 {
  bdivide(p1,&a1,&b1);
  bbsub(&a1,ulo1,umid1,p2,ulo2,uhi2);
  bbsub(&b1,umid1,uhi1,p2,ulo2,uhi2);
 }
 else
 /*if(split2) */
 {
  bdivide(p2,&a2,&b2);
  bbsub(p1,ulo1,uhi1,&a2,ulo2,umid2);
  bbsub(p1,ulo1,uhi1,&b2,umid2,uhi2);
 }

 return(0);
}



/* coord0 4 points of curve */
/* coord1 4 points of curve */


int bbintersection(coordstr * coord0,coordstr * coord1,cutstr * result)
{
 int         i;
 int         j;
 int         n1;
 int         n2;
 bezsplitstr split1[3];
 bezsplitstr split2[3];

 brcount=0;
 bresult=result;

 bezchunks((bezier*)coord0,split1,&n1,NULL);
 bezchunks((bezier*)coord1,split2,&n2,NULL);

 for(i=0;i<n1;i++)
 {
  for(j=0;j<n2;j++)
  {
   biumin1=split1[i].umin;
   biumax1=split1[i].umax;
   biumin2=split2[j].umin;
   biumax2=split2[j].umax;

   bbsub(&split1[i].b,split1[i].umin,split1[i].umax,
         &split2[j].b,split2[j].umin,split2[j].umax);
  }
 }

 return(brcount);
}





void bezval(bezier * b,coordstr * c,int u)
{
 c->x=bezvalx(b->left.x,b->leftc.x,b->rightc.x,b->right.x,u);
 c->y=bezvalx(b->left.y,b->leftc.y,b->rightc.y,b->right.y,u);
}



/* get extent of a Bezier section */

void bezgetext1(int p0,int p1,int p2,int p3,int * min,int * max
                                                 ,int * umin,int * umax)
{
 int xmin;
 int xmax;
 int xumin;
 int xumax;
 int val[2];
 int uval[2];
 int i;
 int n;


 if(p0<p3)
 {
  xmin=p0;
  xmax=p3;
  xumin=0;
  xumax=0x10000;
 }
 else
 {
  xmin=p3;
  xmax=p0;
  xumin=0x10000;
  xumax=0;
 }


 n=bezmaxmin(p0,p1,p2,p3,val,uval);
 for(i=0;i<n;i++)
 {
  if(val[i]<xmin)
  {
   xmin=val[i];
   xumin=uval[i];
  }
  else
  if(val[i]>xmax)
  {
   xmax=val[i];
   xumax=uval[i];
  }
 }

 *min=xmin;
 *max=xmax;

 if(umin) *umin=xumin;
 if(umax) *umax=xumax;
}





void bezgetext(bezier * b,aboxstr * abox)
{
 bezgetext1(b->left.x,b->leftc.x,b->rightc.x,b->right.x,&abox->x0,&abox->x1,
                                                               NULL,NULL);

 bezgetext1(b->left.y,b->leftc.y,b->rightc.y,b->right.y,&abox->y0,&abox->y1,
                                                               NULL,NULL);
}




void bezdev(bezier * b,int u,int * dx,int * dy,int * d2x,int * d2y)
{
 int up;
 int u2;
 int up2;
 int uup;

 up=0x10000-u;
 u2=ttmul(u,u);
 up2=ttmul(up,up);
 uup=ttmul(up,u);

 if(dx)   *dx=ttmul(b->left.x,-up2)+
              ttmul(b->leftc.x,-2*uup+up2)+
              ttmul(b->rightc.x,-u2+2*uup)+
              ttmul(b->right.x,u2);
 
 if(d2x) *d2x=ttmul(b->left.x,2*up)+
              ttmul(b->leftc.x,2*u-4*up)+
              ttmul(b->rightc.x,-4*u+2*up)+
              ttmul(b->right.x,2*u);

 if(dy)   *dy=ttmul(b->left.y,-up2)+
              ttmul(b->leftc.y,-2*uup+up2)+
              ttmul(b->rightc.y,-u2+2*uup)+
              ttmul(b->right.y,u2);
 
 if(d2y) *d2y=ttmul(b->left.y,2*up)+
              ttmul(b->leftc.y,2*u-4*up)+
              ttmul(b->rightc.y,-4*u+2*up)+
              ttmul(b->right.y,2*u);
}




#define PXMSK 0xFFFFFFFF
#define PYMSK 0xFFFFFFFF


void validpath(boxstr * box,int * flags,int * p)
{
 int xlo;
 int xhi;
 int ylo;
 int yhi;
 int x;
 int y;
 int lx;
 int ly;
 bezier b;
 aboxstr abox;

 *flags=0;


 p++;                      /* skip move - we hope */
 x=*p;
 x&=PXMSK;
 *p++=xlo=xhi=x;

 y=*p;
 y&=PYMSK;
 *p++=ylo=yhi=y;


 while(*p!=DRAWEND)
 {
  lx=x;
  ly=y;


  if(*p==DRAWCLOSE)
  {
   p++;
  }
  else
  if(*p==DRAWDRAW || *p==DRAWMOVE)
  {
   p++;

   x=*p;
   x&=PXMSK;
   *p++=x;

   y=*p;
   y&=PYMSK;
   *p++=y;

   xlo=MIN(x,xlo);
   xhi=MAX(x,xhi);
   ylo=MIN(y,ylo);
   yhi=MAX(y,yhi);
  }
  else
  if(*p==DRAWCURVE)
  {
   p++;

   b.left.x=lx;
   b.left.y=ly;

   b.leftc.x=*(p+0);
   b.leftc.x&=PXMSK;

   b.leftc.y=*(p+1);
   b.leftc.y&=PYMSK;

   b.rightc.x=*(p+2);
   b.rightc.x&=PXMSK;

   b.rightc.y=*(p+3);
   b.rightc.y&=PYMSK;

   b.right.x=*(p+4);
   x=b.right.x&=PXMSK;

   b.right.y=*(p+5);
   y=b.right.y&=PYMSK;

/*   b.leftc.x=b.left.x+(b.right.x-b.left.x)/3;
   b.rightc.x=b.left.x+(2*(b.right.x-b.left.x))/3;

   b.leftc.y=b.left.y+(b.right.y-b.left.y)/3;
   b.rightc.y=b.left.y+(2*(b.right.y-b.left.y))/3;  */


   *p++=b.leftc.x;
   *p++=b.leftc.y;
   *p++=b.rightc.x;
   *p++=b.rightc.y;
   *p++=b.right.x;
   *p++=b.right.y;


   bezgetext(&b,&abox);
   xlo=MIN(xlo,abox.x0);
   xhi=MAX(xhi,abox.x1);
   ylo=MIN(ylo,abox.y0);
   yhi=MAX(yhi,abox.y1);
  }
 }

 box->x=xlo;
 box->w=xhi-xlo;
 box->y=ylo;
 box->h=yhi-ylo;
}



