/*->c.file */

#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "font.h"
#include "transform.h"
#include "xprocess.h"
#include "deb.h"
#include "bits.h"


#include "err.h"
#include "filetype.h"
#include "fsx.h"
#include "bf.h"
#include "task.h"
#include "xext.h"
#include "poll.h"
#include "alloc.h"
#include "trans.h"
#include "etc.h"
#include "bits.h"
#include "timex.h"
#include "scrap.h"
#include "ram.h"
#include "save.h"
#include "hourglass.h"


#include "obj.h"

#include "constants.h"
#include "str.h"
#include "reslink.h"
#include "object.h"
#include "page.h"
#include "section.h"
#include "tools.h"
#include "main.h"
#include "view.h"
#include "toolbox.h"
#include "select.h"
#include "clip.h"
#include "undo.h"
#include "pref.h"
#include "transload.h"
#include "utils.h"
#include "main.h"

#include "pxstr.h"
#include "pict.h"
#include "draw.h"

#include "txstr.h"
#include "text.h"
#include "fox.h"
#include "textimport.h"
#include "style.h"

#include "impex.h"

#include "line.h"

#include "group.h"
#include "gline.h"


#include "new.h"
#include "newx.h"
#include "dbnew.h"
#include "dbmore.h"

#include "dbfile.h"




#include "xcolour.h"
#include "conf.h"

#include "border.h"
#include "xprint.h"


#include "ofile.h"

#include "dscript.h"


#include "file.h"





#define FL_KEEPNAME 0x1
#define FL_NOTUSER  0x2
#define FL_NEWNAME  0x4






filestr * firstfile;

static int       docno=1;

int filetest;





void gennewname(filestr * file,char * name)
{
 filestr * nextfile;

// cprintf("gennew %s",name?name:"none");

 if(name)
 {
  xzstrncpy(file->name,name,FILENAMELEN);
 }
 else
 {
  do
  {
   tsprintf(FILENAMELEN,file->name,"{NEWNAME}%d{NEWEXT}",docno);

   /* if(++docno==100) docno=0; */
   ++docno;

   nextfile=firstfile;
   while(nextfile)
   {
    if(file!=nextfile && !strcmp(file->name,fs_leaf(nextfile->name))) break;
    nextfile=nextfile->next;
   }
  } while(nextfile);
 }
}


static void scrapnewname(filestr * file)
{
 char name[FILENAMELEN];

 if(!file->saved && docno>0)
 {
  xsprintf(sizeof(name),NULL,name,"{NEWNAME}%d{NEWEXT}",docno-1);
  trans(name,sizeof(name));
  if(!strcmp(name,file->name)) docno--;
 }
}




#define FSPOSTPONE 6000
#define FSKEYTIME  1000


static os_error * autosavestart(filestr * file);



/* called on autosave timeout */

/* prevent recursion, prevent being called on more than one file at once */

static void autosaveevent(int userhandle)
{
 os_error       * err;
 filestr        * file;
 prefdatastr    * prefs;
 int              result;
 static filestr * asfile;


// cprintf("autosaveevent zero %d key %d",zerotime,keytime);


 file=(filestr*)userhandle;
 prefs=prefp(file);
 if(prefs->autosave)
 {
  if((file!=asfile && asfile) || inprinter)
  {
   addscheduledevent(autosaveevent,(int)file,FSPOSTPONE);
  }
  else
  if(!asfile)
  {
   if((zerotime-keytime)<FSKEYTIME)
   {
    addscheduledevent(autosaveevent,(int)file,FSKEYTIME);
   }
   else
   {
    asfile=file;
    file->autosave=0;
    if(file->saved)
    {
     sxbeep(AUTOSBEEP,0,0);

     if(prefs->autosaveprompt || !file->savedonce)
     {
      /* filepopsave(file); */
      confirmparent(file->view->handle,CONYN,&result,"{FS23}",fs_leaf(file->name));
      if(result==1)
      {
       report(err=savedocs(file->name,file,FTYPE2));
       file->savedonce=(err==NULL);
      }
      else  // rejected save prompt
      {

      }
     }
     else
     {
      report(err=savedocs(file->name,file,FTYPE2));
     }
    }
    else
    {
     confirmparent(file->view->handle,CONYN,&result,"{FS24}");
     if(result==1) filepopsave(file,0);
    }
    asfile=NULL;
    if(file->modded[DOC] || file->modded[MST]) autosavestart(file);
   }
  }
 }
}



/* called when file changed, add scheduled event */

static os_error * autosavestart(filestr * file)
{
 prefdatastr * prefs;

#ifndef READER
 prefs=prefp(file);
 if(prefs->autosave)
 {
//  cprintf("autosavestart %d",prefs->autosaveperiod);
  addscheduledevent(autosaveevent,(int)file,prefs->autosaveperiod);
  file->autosave=1;
 }
#endif

 return(NULL);
}


/* called when file saved, or when file closed */

static os_error * autosaveclear(filestr * file)
{
 if(file->autosave)
 {
  remscheduledevent(autosaveevent,(int)file);
  file->autosave=0;
 }

 return(NULL);
}



void autosavereset(filestr * file)
{
 if(file->autosave)
 {
  remscheduledevent(autosaveevent,(int)file);
  file->autosave=0;
 }
 if(file->modded[DOC]) autosavestart(file);
}










#define MODFREE 0x1000


os_error * modfile(filestr * file,int section)
{
 os_error   * err;
 sectionstr * sectionp;
 int          branch;
 int          claim;

 err=fob_checkfree(MODFREE,file);
 if(!err)
 {
  if(file->merge)
  {
   err=geterror(EMRG);
  }
  else
  if(!file->writeable)
  {
   claim=0;
   event(EVENT_FILEWRITEFAIL,file,(int)&claim);
   err=geterror(ENOWR);
  }
  else
  {
   if(section>0 && file->viewn[MST])
   {
    fob_mod(section,file,(fobjptr)&sectionp);
    branch=sectionp->branch;
    if(branch==DOC)
    {
     if(file->modded[MST]) return(geterror(FS12));
    }
    else
    {
     sectionp->changed=1;
    }
   }
   else
   {
    branch=DOC;
    if(section==0 && file->modded[MST]) return(geterror(FS12));
   }

   if(!file->modded[branch]++) 
   { 
    updatealltitles(file);
    autosavestart(file);
    event(EVENT_FILEMODIFIED,file,NULL);
   }
  }
 }

 return(err);
}










void unmodfile(filestr * file) /* called by dscript */
{
 file->modded[MST]=file->modded[DOC]=0;
 file->saved=1;
 autosaveclear(file);
}



int ischanged(int fp)
{
 return(menufile->modded[DOC]);
 USE(fp);
}



int unsaved(void)
{
 filestr * nextfile;
 int       n;

 n=0;
 nextfile=firstfile;

 while(nextfile)
 {
  if(nextfile->modded[0]) n++;
  nextfile=nextfile->next;
 }

 return(n);
}




/* final act of getting rid of file structure */

os_error * deletefile(filestr * file)
{
 os_error * err;
 filestr  * next;
 filestr  * prev;

 remfiletools(file);

 next=file->next;
 prev=file->prev;

 if(next) next->prev=prev;
 if(prev) prev->next=next;
 if(firstfile==file) firstfile=next;

          err=sfree((flex_ptr)&(file->name));
 if(!err) err=sfree((flex_ptr)&file);

 return(err);
}



static os_error * closedoc2(filestr * file,int scrap)
{
 os_error * err;

 autosaveclear(file);

 if(!scrap) event(EVENT_FCLOSE,file,0);
 else       event(EVENT_FSCRAP,file,0);

 ob_deletedomain((domainstr**)&file->domain);

 scrapnewname(file);

 err=deletefile(file);

 if(file==menufile) 
 {
  menufile=NULL;
  menuview=NULL;
 }

 return(err);
}

/* there is a problem because FOPEN and FCLOSE events should balance  */
/* or else e.g. the spell check will miscount dictionaries            */
/* that means closedoc() should only be called after and FOPEN        */
/* FSCRAP should be called instead of FCLOSE when a file structure is */
/* scrapped */

os_error * closedoc(filestr * file)
{
 return(closedoc2(file,0));
}



/* void filescrap(int file); */

void filescrap(int fp)
{
 filestr * file;

 file=(filestr*)stack[fp];

 scrapviews(file);

 zreport(closedoc(file));
}



/* void getfiletimestring(string & format,string & result,int file); */

void getfiletimestring(int fp)
{
 filestr * file;
 char      format[128];
 char      result[128];

 file=(filestr*)stack[fp+2];
 xzstrncpy(format,stringptr(stack[fp]),sizeof(format));
 writets(result,format,(arctime*)file->timex);
 assignstring(stack[fp+1],result);
}



os_error * newfile(filestr ** filep)
{
 os_error * err;
 filestr  * file;

 err=salloc((flex_ptr)filep,sizeof(filestr));
 if(!err)
 {
  file=*filep;

// NB gennewname() assumes the size of file->name

  err=salloc((flex_ptr)&(file->name),FILENAMELEN);
  if(!err)
  {
   if(firstfile) firstfile->prev=file;
   file->next=firstfile;
   firstfile=file;

   err=addfiletools(file);
   getcurtime((arctime *)file->timex);
   file->readable=file->writeable=1;
   file->writeunlocked=file->readunlocked=1;
			file->compatability=compatability;
  }
  else
  {
   sfree((flex_ptr)filep);
  }
 }
 return(err);
}




/*****************************************************************************/


static os_error * makestylesheet(filestr * file,filestr ** sfilep)
{
 os_error * err;
 filestr  * sfile;
 filehdr  * hdr;
 int        i;

 err=newfile(sfilep);
 if(!err)
 {
  sfile=*sfilep;
  sfile->notuserfile=1;
		sfile->compatability=file->compatability;

  err=ob_createdomain((domainstr**)&sfile->domain);
  if(!err)
  {
   err=fob_create(sizeof(filehdr),sfile,OFILEHDR,(fobjptr)&hdr);
   if(!err)
   {
    sfile->hdr=*hdr;

    for(i=EVENT_MKSTYLE0;i<=EVENT_MKSTYLEF;i++)
    {
     err=event(i,sfile,(int)file);
     if(err) break;
    }
   }
   if(err) ob_deletedomain((domainstr**)&sfile->domain);
  }
  if(err) deletefile(sfile);
  else
  {
   event(EVENT_FOPEN,sfile,0);
  }
 }
 return(err);
}


/*****************************************************************************/

       filestr   * xloadfile;
static int         xloadtype;


/* load file from disc */

static os_error * loadscript(char * name,int type,int userhandle,int xvolatile)
{
 os_error  * err;

 err=NULL;

//	cprintf("load script");

 runscript(name,0);

 return(err);

 type=type;
 userhandle=userhandle;
 xvolatile=xvolatile;
}



static os_error * loadscriptpost(int userhandle)
{
 os_error * err;

 err=NULL;

//	cprintf("load script post");

 runscriptpost();

 zerofilesquit(err);


 return(err);

 USE(userhandle);
}


/*****************************************************************************/

static posnstr textloadposn;




static os_error * loadtext(char * name,int type,int userhandle,int xvolatile)
{
 os_error   * err;
 filestr    * file;
 sectionstr * sectionp;
 sobjectstr * sob;
 int          method;

 method=0;

          err=createdefnewdoc(&file,NULL);
          event(EVENT_FOPEN,file,0);
 if(!err) err=createnewview(file,DOC,NULL,0);
 if(!err)
 {
  xloadfile=file;
  textloadposn.file=file;
  textloadposn.view=file->view;
  textloadposn.section=file->hdr.section[DOC];
  sectionp=(sectionstr*)fob_find(textloadposn.section,file);
  textloadposn.page=sectionp->chain.child;
  getmainframe(textloadposn.section,file,&textloadposn.object);
 }

 if(!err && textloadposn.object)
 {
  sob=(sobjectstr*)fob_find(textloadposn.object,textloadposn.file);
  textloadposn.otype=sob->type;
  err=objectloadtype(name,type,&textloadposn,&method);
  if(!err) objectload(name,type,xvolatile,&textloadposn);
 }

 return(err);

 USE(userhandle);
}


static os_error * loadtextpost(int userhandle)
{
 return(objectloadpost(&textloadposn,OBDIRECTLOAD));
 USE(userhandle);
}


/*****************************************************************************/


/* load file from disc */

static int loadpostactive;


static oloadfn     voloadfile;
static oloadpostfn voloadfilepost;


void registeroload(oloadfn xoloadfile,oloadpostfn xoloadfilepost)
{
 voloadfile=xoloadfile;
 voloadfilepost=xoloadfilepost;
}




void fob_testtree(filestr * file);


os_error * loaddoc(char * name,int type,int bits,int xvolatile)
{
 os_error  * err;
 domainstr * domain;
 int         object;
 fstat       f;
 buffer      bf;
 objfilehdr  fhdr;
 int         result;


 err=NULL;

	cprintf("load doc**");

 xloadtype=type;

 if(!xvolatile)
 {
  fs_stat(name,&f);
  if(f.length==0)
  {
   err=geterror(FS28);
  }
 }

 if(!err)
 {
  hourglasson();

  err=newfile(&xloadfile);
  if(!err)
  {
   if(voloadfile && (type==FTYPE || type==STYPE))/* if can load old files too */
   {
    err=bf_open(name,'r',DEFBUFFSIZE,&bf);
    if(!err)
    {
     err=bf_read(&bf,&fhdr,sizeof(objfilehdr));

     if(!err)
     {
      if(fhdr.progmark[0]=='1' && !strcmp(fhdr.progname,"Ovation"))
      {
							xloadfile->compatability=workcompatability;
       err=voloadfile(name,&bf,type==STYPE,xloadfile);
       xloadfile->oldformat=1;
      }
      else
      {
       err=ob_readfile(&bf,&fhdr,&domain,&object);				// reading object header not file header
       if(!err)
       {
								xloadfile->compatability=MAX(fhdr.compatability,compatability);
        xloadfile->domain=domain;
        xloadfile->hdr=*((filehdr*)fob_find(object,xloadfile));
       }
      }
     }
     err=bf_close(&bf,err);
    }
   }
   else
   {
    err=ob_loadfile(name,&domain,&object,(filetest & FILELDTST)!=0,&xloadfile->compatability);
    if(!err)
    {
					if(xloadfile->compatability<compatability) xloadfile->compatability=compatability;
     xloadfile->domain=domain;

/*   fob_testtree(xloadfile);  */

     if(filetest & FILELDTST)
     {
      err=fob_test(xloadfile);
      if(err)
      {
//      dataloadcomplete(name);
       hourglassoff();

       confirmparent(NULL,CONYN|CONFORCE,&result,"{FS27}");

       if(result==1) err=NULL;

       hourglasson();
      }
     }
     if(!err)
     {
      xloadfile->hdr=*((filehdr*)fob_find(object,xloadfile));
      if(xloadfile->hdr.np[DOC]==0)
      {
       type=xloadtype=STYPE2;
      }
     }
    }
   }

   if(err) deletefile(xloadfile);
  }

  if(!err)
  {
   cprintf("load doc type %x",type);

   gennewname(xloadfile,
       (((type==STYPE)||(type==STYPE2))&& !(bits & FL_KEEPNAME))||(bits & FL_NEWNAME)?NULL:name);

   xloadfile->notuserfile=((bits & FL_NOTUSER)!=0);

   unmodfile(xloadfile);

   if(xvolatile || type==STYPE2 || type==STYPE)
   {
   /* getcurtime((arctime*)xloadfile->timex); */
    xloadfile->saved=0;
   }
   else
   {
                         /* wrong for ram tran */
    filetime(&f,(arctime*)xloadfile->timex);
   }
  }

  hourglassoff();
 }


 if(err) zerofilesquit(err);

 return(err);
}



os_error * loaddocpost1(int * load,int flags)
{
 os_error * err;

cprintf("docpost1+0 %d",*load);

 if(xloadfile->oldformat)
 {
  err=voloadfilepost(xloadfile,xloadtype,load);
 }
 else
 {
  err=stylefontload(xloadfile,load,flags);
 }

cprintf("docpost1+1 %d",*load);

 if(!err && *load)
 {
  err=pictfontload(xloadfile,load,flags);
 }

cprintf("docpost1+2 %d",*load);

 return(err);
}





os_error * loaddocpost(int userhandle)
{
 os_error * err;
 int        load;
 int        i;
 int        claim;



 cprintf("loaddocpost"); 


 loadpostactive=1;

 err=loaddocpost1(&load,0);

 cprintf("loaddocpost load=%d",load); 

 if(load)
 {
  if(xloadtype==STYPE || xloadtype==STYPE2)
  {
   for(i=EVENT_LOADSTYLE0;i<=EVENT_LOADSTYLEF;i++)
   {
    err=event(i,xloadfile,NULL);
    if(err) break;
   }
  }
 }


 if(load)
 {
/* fob_testtree(xloadfile);   */

  prefinitpassword(xloadfile);

  err=event(EVENT_FOPEN,xloadfile,0);

  if(!err)
  {
   if(!xloadfile->readable)
   {
    claim=0;
    err=event(EVENT_FILENOREAD,xloadfile,(int)&claim);
    if(!claim && !xloadfile->readable) err=geterror(ENORD);
   }
  }

  if(err) closedoc(xloadfile);
  else
  if(!xloadfile->noview && xloadfile->readable)  
  {
   defaultviewdata(xloadfile);
   err=createnewview(xloadfile,DOC,NULL,0);
  }

  if(!err) err=undoloadfile(xloadfile);
 }
 else
 {
  err=closedoc2(xloadfile,1);
  xloadfile=NULL;
 }

 loadpostactive=0;

	zerofilesquit(NULL);		// potentially this might mean errors not reported
																		    	// closedoc2() above is zero'ing some errors anyway

 return(err);

 USE(userhandle);
}




/***************************************************************************/

static char   * xloadname;
static int      xloadvolatile;





static os_error * loadfile(char * name,int type,int userhandle,int xvolatile)
{
 xloadtype=type;

 if(type==FTYPE || type==STYPE || type==FTYPE2 || type==STYPE2)
                    return(loaddoc(name,type,userhandle,xvolatile));
 else
 if(type==SCRIPT2)  return(loadscript(name,type,userhandle,xvolatile));
 else
 if(type==TEXTFILE || type==UNICODETEXTFILE) return(loadtext(name,type,userhandle,xvolatile));
 else
 if(type==DTYPE2)   return(dsloadfile(name,type,userhandle,xvolatile));
 

 return(geterror(FS26));
}



static os_error * loadfilepost(int userhandle)
{

 if(xloadtype==FTYPE || xloadtype==STYPE || 
    xloadtype==FTYPE2 || xloadtype==STYPE2)            return(loaddocpost(userhandle));
 else
 if(xloadtype==SCRIPT2)                                return(loadscriptpost(userhandle));
 else
 if(xloadtype==TEXTFILE || xloadtype==UNICODETEXTFILE) return(loadtextpost(userhandle));
 else
 if(xloadtype==DTYPE2)                                 return(dsloadfilepost(userhandle));

 return(NULL);
}








os_error * loadanyfile(char * name,int flags)
{
 os_error * err;
 fstat      f;
 int        transhandle;
 char       transname[FILENAMELEN];
 int        transtype;

 err=fs_stat(name,&f);  // cprintf("name=%s type=%x",name,f.type);
 if(!err)
 {
  if(f.object)
  {
   if((f.type==FTYPE  || f.type==DTYPE2 || f.type==STYPE || 
       f.type==FTYPE2 || f.type==STYPE2 || f.type==SCRIPT2 ||
       (f.type==TEXTFILE && (impexbitx(TEXTFILE,0,0) & IMPXLOAD))	||
       (f.type==UNICODETEXTFILE && (impexbitx(UNICODETEXTFILE,0,0) & IMPXLOAD))
      )
     )
   {
    err=loadfile(name,f.type,0,0);
    if(!err)
    {
     if(f.type!=SCRIPT2)
     {
      xloadfile->noview=((flags & FLNOVIEW)!=0);
      xloadfile->permanent=
        xloadfile->alwayspermanent=((flags & FLPERMANENT)!=0);
     }
     err=loadfilepost(0);
    }
   }
   else
   {
    err=sc_create(&transhandle);
    if(!err)
    {
     xzstrncpy(transname,sc_name(transhandle),sizeof(transname));

     if(f.object==2)
     {
      transtype=DTYPE2;
      err=translatefile(name,IMP,transname,DTYPE2);
     }
     else
     {
      err=transload(name,transname,&transtype);
     }

     if(!err)
     {
      cprintf("transtype %x name %s",transtype,transname);

      err=loadfile(transname,transtype,0,0);
      if(!err)
      {
       if(transtype!=SCRIPT2)
       {
        xloadfile->noview=((flags & FLNOVIEW)!=0);
        xloadfile->permanent=
        xloadfile->alwayspermanent=((flags & FLPERMANENT)!=0);

        xzstrncpy(xloadfile->name,fs_leaf(name),FILENAMELEN);
        fs_checkextension(xloadfile->name,"dpd");
        updatealltitles(xloadfile);
       }
       err=loadfilepost(0);
      }
     }

      cprintf("loadfile post");

     fs_delete(sc_name(transhandle));
     sc_remove(transhandle,err);
    }
   }
  }
  else
  if(flags & FLNOLOAD) err=geterror(FS26);
 }


 return(err);
}



/* int filefromview(int view);  */

int filefromview(int fp)
{
 viewstr * view;

 view=(viewstr*)stack[fp];
 if(view) return((int)view->file);

 return(0);
}


/* int currentview(void) */

int currentview(void)
{
 return((int)menuview);
}


/* int currentfile(void) */

int currentfile(void)
{
 return((int)menufile);
}



int setcurrentview(int fp)
{
 viewstr * oldview;
 oldview=menuview;
 menuview=(viewstr*)stack[fp];
 if(menuview) menufile=menuview->file;
	else									menufile=NULL;

 return((int)oldview);
}


int setcurrentfile(int fp)
{
 filestr * oldfile;
 oldfile=menufile;
 menufile=(filestr*)stack[fp];
 if(menufile) menuview=menufile->view;
 else         menuview=NULL;
 return((int)oldfile);
}


void setcurrentfileview(filestr * file,viewstr * view)
{
 menufile=file;
 menuview=(view==NULL)?menufile->view:view;
}



/* int fileinfo(int file,string & s) */


int fileinfo(int fp)
{
 filestr     * file;
 int           s;

 file=(filestr*)stack[fp];
 s=stack[fp+1];

 assignstring(s,file->name);

 return( file->saved|
        ((file->modded[DOC]!=0)<<1)|
        (file->readable<<2)|
        (file->writeable<<3)|
        (file->notuserfile<<4)
       );
}




int issaved(int fp)
{
 return(menufile->saved);
 USE(fp);
}



int nextfile(int fp)
{
 filestr * file;

 file=(filestr*)stack[fp];
 if(!file) file=firstfile;
 else      file=file->next;

 return((int)file);
}


int nextuserfile(int fp)
{
 filestr * file;

 file=(filestr*)stack[fp];
 if(!file) file=firstfile;
 else      file=file->next;

 while(file && file->notuserfile) file=file->next;

 return((int)file);
}





filestr * firstfilep(void)
{
 return(firstfile);
}




void reverttosaved(int fp)
{
 os_error * err;
 char       name[FILENAMELEN];
 int        result;

 err=NULL;

 if(!menufile->saved) err=geterror(EBDS);
 else
 {
  confirmparent(menuview->handle,CONDC,&result,"{FS07}");

  if(result==1)
  {
   xzstrncpy(name,menufile->name,sizeof(name));
   closefile(menufile);
   err=loadanyfile(name,FLNOLOAD);
   if(!err)
   {
    menufile=xloadfile;
    menuview=menufile->view;
   }
   else
   {


   }
  }
 }

 if(err) zerofilesquit(err);

 zreport(err);

 USE(fp);
}



/* flush file to disc */

static os_error * savedoc1(char * name,filestr * file,int type)
{
 os_error * err;
 filehdr  * hdr;
 int        print;
 int        oldlen;
 fstat      f;
 int        result;


// cprintf("save file0 %s",name);

#ifdef READER
 err=geterror(FS25);
#else

 err=NULL;
 print=(type & PRSAVETYPE);
 type&=~PRSAVETYPE;


 if(type==FTYPE2)
 {
  err=undosavefile(file,type);
  if(!err)
  {
//   cprintf("save file1 %s",name);
   oldlen=strlen(name);
   event(EVENT_FPRESAVE,file,(int)name);
   if(!oldlen || strlen(name))
   {
//    cprintf("save file2 %s",name);
    fob_mod(file->hdr.key,file,(fobjptr)&hdr);
    *hdr=file->hdr;

    if(filetest & FILESVTST)
    {
     err=fob_test(file);
     if(err)
     {
      confirmparent(file->view->handle,CONYN|CONFORCE,&result,"{FS27}");

      if(result==1) err=NULL;
     }
    }

    if(!err) err=ob_savefile(name,file->domain,file->hdr.key,type,(filetest & FILESVTST)!=0,file->compatability);

    if(!err && !print)
    {
     if(0)
     {
      getcurtime((arctime*)file->timex);
     }
     else
     {
      fs_stat(name,&f);
      if(f.object) filetime(&f,(arctime*)file->timex);
     }

//     cprintf("presave name %s %s",name,file->name);

     if(cstrcmp(name,file->name) || file->modded[DOC])
     {
      xzstrncpy(file->name,name,FILENAMELEN);
//      cprintf("save %s",file->name);
      event(EVENT_FILESAVED,file,0);
      unmodfile(file);
      updatealltitles(file);
     }
    }
   }
  }
  undopostsavefile(file);
 } 
 else
 if(type==STYPE2)
 {
  fob_mod(file->hdr.key,file,(fobjptr)&hdr);
  *hdr=file->hdr;

  err=ob_savefile(name,file->domain,file->hdr.key,type,(filetest & FILESVTST)!=0,file->compatability);
 }
 else
 if(type==DTYPE2) err=dssavefile(name,file);

#endif

 return(err);
}


os_error * savedoc(char * name,filestr * file,int type)
{
 os_error * err;
 filestr  * sfile;
 int        result;

// cprintf("save doc %s",name);

 if(type & PRSAVETYPE) err=savedoc1(name,file,type);
 else
 if(file->viewn[MST]) err=geterror(FS22);
 else
 {
  if(file->oldformat)
  {
   if(!cstrcmp(name,file->name))
   {
    confirmparent(file->view->handle,CONYN,&result,"{FS20}");
    if(result!=1) return(NULL);
   }
   file->oldformat=0;
  }


  if(type==STYPE2)
  {
   err=makestylesheet(file,&sfile);
   if(!err) err=savedoc1(name,sfile,type);
   closedoc(sfile);
  }
  else
  {
   err=savedoc1(name,file,type);
  }
 }

 return(err);
}



os_error * savedocs(char * name,filestr * file,int type)
{
 char temp[FILENAMELEN];
 xzstrncpy(temp,name,sizeof(temp));
 return(savedoc(temp,file,type));
}




void savedocument(int fp)
{
 os_error * err;
 char     * p;


 p=stringptr(stack[fp]);
 if(p[0])            err=savedocs(p,menufile,FTYPE2);
 else
 if(menufile->saved) err=savedocs(menufile->name,menufile,FTYPE2);
 else                err=geterror(EBDS);

 zreport(err);
}




// create a new document on disc, shell calls program with -new


os_error * createdocumentfile(char * filename)
{
 os_error * err;
 filestr  * file;
 filehdr  * hdr;


 err=createdefnewdoc(&file,NULL);
 if(!err)
 {
  fob_mod(file->hdr.key,file,(fobjptr)&hdr);
  *hdr=file->hdr;

  err=ob_savefile(filename,file->domain,file->hdr.key,FTYPE2,(filetest & FILESVTST)!=0,file->compatability);

  ob_deletedomain((domainstr**)&file->domain);
  deletefile(file);
 }

 return(err);
}





static char * defaultname[2]=
{
 "<HKEY_CURRENT_USER\\Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders\\AppData>\\DavidPilling\\OvationPro\\Default.dps",
 "<HKEY_CURRENT_USER\\Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders\\AppData>\\DavidPilling\\OvationPro\\Default.dpd"
};

static char * defaultbasename[2]=
{
 "<HKEY_LOCAL_MACHINE\\Software\\DavidPilling\\OvationPro\\>\\Default.dps",
 "<HKEY_LOCAL_MACHINE\\Software\\DavidPilling\\OvationPro\\>\\Default.dpd"

};




filestr * deffile;



filestr * getdeffile(void)
{
 return(deffile);
}


int defaultfile(int fp)
{
	return((int)deffile);
 USE(fp);
}



os_error * updatedefaultfile(void)
{
 os_error * err;           

	err=NULL;

	if(deffile)
	{
  err=fs_validatepath(multiuser?defaultname[0]:defaultbasename[0],0);
  if(!err) err=savedoc1(multiuser?defaultname[0]:defaultbasename[0],deffile,(deffile->hdr.ns[DOC]==0)?STYPE2:FTYPE2);
	}

	return(err);
}



void saveasdefault(int fp)
{
 os_error * err;
 int        result;

 err=confirmparent(menuview->handle,CONYN,&result,"{FS21}");
 if(result==1)
 {
  if(deffile) closedoc(deffile);

  err=makestylesheet(menufile,&deffile);
  if(!err)
  {
			err=updatedefaultfile();
			if(!err)
			{
				event(EVENT_NEWDEFAULT,deffile,0);		// change default file event
			}
  }
 }

 zreport(err);

 USE(fp);
}




static os_error * loaddefault(void)
{
 os_error * err;
 fstat      f;
 int        load;
 char     * name=NULL;


 err=NULL;

 name=NULL;
 if(multiuser) err=fs_pair(defaultname[0],defaultname[1],1,&name,&f);
 if(!err)
 {
  if(!name)
  {
   err=fs_pair(defaultbasename[0],defaultbasename[1],1,&name,&f);
  }
 }


 if(!err && name)
 {
  if(f.type==STYPE2 || f.type==FTYPE2)
  {
   err=loadfile(name,f.type,FL_KEEPNAME|FL_NOTUSER,0);
   if(!err)
   {
    deffile=xloadfile;
    err=loaddocpost1(&load,FL_NOFONTMISSING);
    if(err || !load)
    {
     closedoc(deffile);
     deffile=NULL;
    }
    else
    {
     undozerosize(deffile);
    }
   }
  }
 }
 return(err);
}




int scriptloadfile(int fp)
{
 char string[FILENAMELEN];
 xzstrncpy(string,stringptr(stack[fp]),sizeof(string));
 zreport(loadanyfile(string,FLNOLOAD));
 return((int)xloadfile);
}







static os_error * fileevent(int eventn,int user,filestr * file,buffer * bf)
{
 os_error      * err;
 int             doc;
 int             message;

 err=NULL;


 if(eventn==EVENT_DSSAVE0)
 {
		if(file->compatability>4)	err=bf_printfeoln(bf,2,"DOC={document {featurelevel %d}}",file->compatability);
		else                      err=bf_printfeoln(bf,2,"DOC={document}");
 }
 else
 if(eventn==EVENT_DSSAVE8)
 {
  doc=file->hdr.section[DOC];

  message=OM_DSSAVE;

  err=objectchainmessage(doc,file,&message,bf);
 }


 return(err);

 USE(user);
}




os_error * initdoc(void)
{
 os_error * err;

	// xcprintf("init doc entered");

          err=adddataopen(FTYPE2,loaddoc);
 if(!err) err=adddataopenpost(FTYPE2,loaddocpost);
 if(!err) err=adddataopen(STYPE2,loaddoc);
 if(!err) err=adddataopenpost(STYPE2,loaddocpost);

 if(!err) err=adddataopen(SCRIPT2,loadscript);
 if(!err) err=adddataopenpost(SCRIPT2,loadscriptpost);

 if(!err) err=adddataopen(DTYPE2,dsloadfile);
 if(!err) err=adddataopenpost(DTYPE2,dsloadfilepost);

 if(!err) err=adddataopen(TEXTFILE,loadfile);
 if(!err) err=adddataopenpost(TEXTFILE,loadfilepost);

 if(!err) err=adddataopen(UNICODETEXTFILE,loadfile);
 if(!err) err=adddataopenpost(UNICODETEXTFILE,loadfilepost);


	// xcprintf("event doc init");

 if(!err) err=event(EVENT_DOCINIT0,NULL,0);

	// xcprintf("ob init");

 if(!err) err=ob_init();

	// xcprintf("impex init");

 if(!err) err=impexinit();

	// xcprintf("toolbox init");

 if(!err) err=toolboxinit();

	// xcprintf("page init");

 if(!err) err=pageinit();

	// xcprintf("section init");

 if(!err) err=sectioninit();

	// xcprintf("text init");

 if(!err) err=textinit();

	// xcprintf("pict init");

 if(!err) err=pictinit();

	// xcprintf("draw init");

 if(!err) err=drawinit();

	// xcprintf("import init");

 if(!err) err=textimportinit();

	// xcprintf("line init");

 if(!err) err=lineinit();

	// xcprintf("group init");

 if(!err) err=groupinit();

	// xcprintf("guide init");

 if(!err) err=guidelineinit();


	// xcprintf("event init1");

 if(!err) err=event(EVENT_DOCINIT1,NULL,0);

	// xcprintf("select init");

 if(!err) err=selectinit();

	// xcprintf("new init");

 if(!err) err=newinit();

	// xcprintf("clip init");

 if(!err) err=clipboardinit();

	// xcprintf("border init");

 if(!err) err=borderinit();

	// xcprintf("dssave0");

 if(!err) err=addevent(EVENT_DSSAVE0,(eventfn)fileevent,0);

	// xcprintf("dssave 8");

 if(!err) err=addevent(EVENT_DSSAVE8,(eventfn)fileevent,0);

	// xcprintf("load default");

 if(!err) err=loaddefault();

	// xcprintf("event init 2");

 if(!err) err=event(EVENT_DOCINIT2,NULL,0);

	// xcprintf("init doc exit");

 return(err);
}



os_error * finitdoc(void)
{

	return(clipboardfinit());
}




void * fob_find(int n,filestr * file)
{
 return(ob_find(n,file->domain));
}

os_error * fob_mod(int n,filestr * file,fobjptr pointer)
{
 return(ob_mod(n,file->domain,(objptr)pointer));
}

os_error * fob_setbits(int n,filestr * file,int bits,objptr pointer)
{
 return(ob_setbits(n,file->domain,bits,(objptr)pointer));
}

os_error * fob_change(int n,filestr * file,int newsize,fobjptr pointer)
{
 return(ob_change(n,file->domain,newsize,(objptr)pointer));
}

os_error * fob_create(int size,filestr * file,int type,fobjptr pointer)
{
 return(ob_create(size,file->domain,type,(objptr)pointer));
}

os_error * fob_delete(int n,filestr * file)
{
 return(ob_delete(n,file->domain));
}

os_error * fob_lock(fobjptr pointer,int n,filestr * file)
{
 return(ob_lock((objptr)pointer,n,file->domain));
}

os_error * fob_unlock(fobjptr pointer,filestr * file)
{
 return(ob_unlock((objptr)pointer,file->domain));
}

os_error * fob_copy(fobjptr dpointer,filestr * dfile,int sn,filestr * sfile)
{
 return(ob_copy((objptr)dpointer,dfile->domain,sn,sfile->domain));
}

os_error * fob_static(fobjptr pointer,int n,filestr * file)
{
 return(ob_static((objptr)pointer,n,file->domain));
}

os_error * fob_free(fobjptr pointer,filestr * file)
{
 return(ob_free((objptr)pointer,file->domain));
}

int fob_size(int n,filestr * file,fobjptr pointer)
{
 return(ob_size(n,file->domain,(objptr)pointer));
}

os_error * fob_compact(filestr * file)
{
 return(ob_compactdomain(file->domain));
}

os_error * fob_compactall(void)
{
 return(ob_compactall());
}

os_error * fob_checkfree(int need,filestr * file)
{
 return(ob_checkfree(need,file->domain));
}

os_error * fob_test(filestr * file)
{
 return(ob_test(file->domain));
}


#ifdef _DEBUG

os_error * fob_testdebug(filestr * file,char * where)
{
	os_error * err;

 err=ob_test(file->domain);

 if(err) cprintf("test reports %s @ %s",err->errmess,where);

	report(err);

	return(err);
}

#endif


#ifndef PROD

void fob_testtree(filestr * file)
{
// ob_testtree(file->domain);
 USE(file);
}

#endif

