/*->c.reslink */

#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"

#include "err.h"
#include "fsx.h"
#include "bf.h"
#include "temp.h"
#include "xhelp.h"
#include "task.h"
#include "poll.h"
#include "applet.h"
#include "filetype.h"
#include "csv.h"

#include "constants.h"

#include "reslink.h"



static errtag errortable[]=
{
 EREPDEC,"{EREPDEC}",
 EREPNEG,"{EREPNEG}",
 EBADVAL,"{EBADVAL}",
 EBU,"{EBU}",
 EBD,"{EBD}",
 EBB,"{EBB}",
 EID,"{EID}",
 EPCD,"{EPCD}",
 EPCL,"{EPCL}", 
	EXV, "{EXV}",

 NE00,"{NE00}",
 NE01,"{NE01}",
 NE02,"{NE02}",
 NE03,"{NE03}",
 NE04,"{NE04}",
 NE05,"{NE05}",
 NE06,"{NE06}",
 NE07,"{NE07}",
 NE08,"{NE08}",
 NE09,"{NE09}",
 NE10,"{NE10}",
 EU00,"{EU00}",
 FOXNON,"{FOXNON}",
 FOXBAD,"{FOXBAD}",
 ES00,"{STYLE01}",
 ES01,"{STYLE02}",
 ES02,"{STYLE05}",
 ES03,"{STYLE08}",
 EC00,"{COL01}",
 EC01,"{COL02}",
 EC02,"{COL03}",
 EC03,"{COL04}",
 ESP00,"{SP01}",
 ESP01,"{SP02}",
 ESP02,"{SP03}",
 ESP03,"{SP07}",
 ESP04,"{SP10}",
 EDCOLD,"{EDCOLD}",
 EDCAPS,"{EDCAPS}",
 PA00,"{PA00}",
 PA01,"{PA01}",
 PA02,"{PA02}",
 PA03,"{PA03}",
 PA04,"{PA04}",
 STYLE03,"{STYLE03}",
 STYLE04,"{STYLE04}",
 BOX01,"{BOX01}",
 BOX02,"{BOX02}",
 BOX03,"{BOX03}",
 BOX04,"{BOX04}",
 BOX05,"{BOX05}",
 BOX06,"{BOX06}",
 FS11,"{FS11}",
 FS12,"{FS12}",
 FS13,"{FS13}",
 FS22,"{FS22}",
 FS25,"{FS25}",
 FS26,"{FS26}",
 FS28,"{FS28}",
 ECRCF,"{ECRCF}",
 ETRUNCF,"{ETRUNCF}",
 ERRNOHYP,"{NOHYP}",
 FI00,"{FI00}",
 FI01,"{FI01}",
 FI05,"{FI05}",
 FI06,"{FI06}",
 FI07,"{FI07}",
 FI09,"{FI09}",
 FI0A,"{FI0A}",
 FI0B,"{FI0B}",
 FI0C,"{FI0C}",
 FI0D,"{FI0D}",
 MAC6,"{MAC6}",
 MAC7,"{MAC7}",
 MAC8,"{MAC8}",
 MAC9,"{MAC9}",
 MACA,"{MACA}",
 MACB,"{MACB}",
 MACE,"{MACE}",
 ESCAPERR,"{ESC}",
 EVERSION,"{EVR}",
 EBDS,"{EBDS}",
 EOB00,"{OB00}",
 EOB01,"{OB01}",

 ETXE0,"{TXE0}",
 ETXE1,"{TXE1}",
 ETXE2,"{TXE2}", 
 ETXE3,"{TXE3}",
 ETXE4,"{TXE4}",
 ETXE5,"{TXE5}",
 ETXE6,"{TXE6}",
 ETXE7,"{TXE7}",
 ETXE8,"{TXE8}",

 EPX0,"{EPX0}",
 EPX1,"{EPX1}",
 EPX2,"{EPX2}",
 EPX3,"{EPX3}",
 EPX4,"{EPX4}",
 EPX5,"{EPX5}",
 EPX6,"{EPX6}",
 EPX7,"{EPX7}",

 ECH0,"{CH0}",
 ECH2,"{CH2}",

 ECOMPAT,"{EVS}",
 ENORD,  "{ENR}",
 ENOWR,  "{ENW}",

 DR00,   "{DR00}",

 BM00,   "{BM00}",
 BM01,   "{BM01}",

 EBDR1,  "{BDR1}",

 ESH0,   "{SH00}",

 ESSF,   "{SSF00}",

 EMRG,   "{PR12}",
	
 EFILETYPE,"{EFT}",

 ENOMENU,"{ENOM}",

 EOBJECT00,"{EO00}",

 ENOTRANS,"{ENOTR}",
 ENOFL,"{ENOFL}",
 EFLBAD,"{EFLBAD}",
 ENSFL,"{ENSFL}",
	EREFPX,"{EREFPX}",
 EUNC,"{EUNC}",
 EGTE,"{EGTE}",
 ELE100,"{ELE100}",

 ELAST ,""
};


static errlink errorlink;

static templates temptable[]=
{
 TCONF,1,0,"Confirm",
 TSAVE,0,0,"Savefile",
 TINFO,1,0,"Info",


 TMAIN,0,0,"Main",
// TMAINPANE,1,0,"MainPane",

 TMODCHAPTER,1,0,"ModChapter",

/* TPAGENUMBER,1,0,"PageNumber", */

 TPAGEGUIDES,1,0,"Guidelines",


 TECOL,1,0,"EditColour",
 TCOLP,1,0,"ColourP",
 TCHART,1,0,"ColourChart",
 TCHARTP,1,0,"ChartP",
 TOVERPRINT,1,0,"Overprint",
 TNEWCOL,1,0,"NewColour",
 TRENCOL,1,0,"RenameCol",
 TCOLOUR,1,0,"Colour",

 TGOTOPAGE,1,0,"GotoPage",
 TDELPAGE,1,0,"DeletePage",
 TINSPAGE,1,0,"InsertPage",
/* TNEWCHAP,1,0,"NewChapter", */

 TCOLUMN,1,0,"Column",
 
 TVRULER,1,0,"VRuler",
 THRULER,1,0,"HRuler",

/* TVPANE,1,0,"VPane", */
 THPANE,2,0,"HPane",
 TIPAL,1,0,"InfoPal",
 TGRID,1,0,"Grid",
 TSCALE,1,0,"Scale",
 TTOOLBOX,1,0,"ToolBox",
 TPICTURE,1,0,"Picture",
 TPICTINFO,1,0,"PicInfo",
 TPXFRAME,1,0,"PicFrame",
 TLINE,1,0,"Line",

 TFLOW,1,0,"TextFlow",

 TOBJECT,1,0,"Object",

 TDUPLICATE,1,0,"Duplicate",
 TXFRAME,1,0,"TextFrame",

 TSTYLE,1,0,"EditStyle",
 TSTYLEP,1,0,"EditStyleP",
 TNEWSTYLE,1,0,"NewStyle",
 TRENAMESTYLE,1,0,"RenameStyle",
 TUNDER,1,0,"Underline",
 TSTRIKE,1,0,"StrikeOut",
 TFORMATSTYLE,1,0,"FormatStyle",
 TTEXTSTYLE,1,0,"TextStyle",
 TRULES,1,0,"Rules",
 THANDJ,1,0,"Hyphen",
 TTEXT,1,0,"TextEffect",
 TFORMAT,1,0,"FormatEffct",
 TTABS,1,0,"Tabruler",
 TTABSTYLE,1,0,"TabsStyle",
 TTABEFFECT,1,0,"TabsEffect",

 TVIEW,1,0,"View",

 TSPELLPANE,1,0,"SpellPane",
 TSPELLCHECK,1,0,"SpellCheck",
 TEDITDICT,1,0,"EditDict",
 TLOADDICT,1,0,"LoadDict",
 TCREATEDICT,1,0,"CreateDict",
 TDICTPANE,1,0,"DictPane",
 TEDITPANE,1,0,"EditPane",

 TPRINT,1,0,"Print",
 TPRINTING,1,0,"Printing",

 TMISSINGFONT,1,0,"MissingFont",


 TFIND,1,0,"Find",
 TFOUND,1,0,"Found",
 TFILEINFO,1,0,"FileInfo",

 TGLINE,1,0,"GuideLine",

 TMACROS,1,0,"Macros",
 TMACROSP,2,0,"MacrosP",
 TNEWKEY,1,0,"NewKey",
 TNEWBUTTON,1,0,"NewButton",
 TNEWMACRO,1,0,"NewMacro",
 TBUTTONBOX,2,0,"ButtonBox",


 TCHTEXT,1,0,"Ch_Text",
 TCHPICT,1,0,"Ch_Picture",
 TCHVIEW,1,0,"Ch_View",
 TCHGENERAL,1,0,"Ch_General",
 TCHLINE,1,0,"Ch_Line",
 TCHOICES,1,0,"Choices",
 TCHOICESP,1,0,"ChoicesP",

 TSELECTTOOL,1,0,"SelectTool",
 TROTATETOOL,1,0,"RotateTool",
 TPATHTOOL,1,0,"PathTool",
 TMAGNIFYTOOL,1,0,"MagnifyTool",

 TTEXTTOOL,1,0,"TextTool",
 TLINETOOL,1,0,"LineTool",
 TPICTURETOOL,1,0,"PictureTool",
 TCROPTOOL,1,0,"CropTool",

 TSHAPE,1,0,"Shape",

 TBULLET,1,0,"Bullet",

 TJUSTIFY,1,0,"Justify",
 TCHARS,1,0,"Chars",
 TMERGETAG,1,0,"MergeTag",
/* TINDEX,1,0,"Index", */
/* TCONTENTS,1,0,"Contents", */


 TBORDER,1,0,"Border",
 TBORDERP,1,0,"BorderP",

 TPREFERENCES,1,0,"Preferences",
 TPREFTEXT,1,0,"Pr_Text",
 TPREFVIEW,1,0,"Pr_View",
 TPREFGENERAL,1,0,"Pr_General",

 TMERGESTYLE,1,0,"MergeStyle",

 TMAILMERGE,1,0,"MailMerge",
 TPRINTSHEET,1,0,"PrintSheet",
 TPRINTMARKS,1,0,"Marks",
 TLINKTOOL,1,0,"LinkTool",

 TFIELDS,1,0,"Fields",
 TFIELDSP,1,0,"FieldsP",
 TNEWFIELD,1,0,"NewField",

 TPIXIMPORT,1,0,"PixImport",
 TPROXY,1,0,"Proxy",
 TPIXREF,1,0,"PixRef",
 TPROXYCHOICE,1,0,"ProxyChoice",

 TCHPRINT,1,0,"Ch_Print",

 TINSERTSPACE,1,0,"InsertSpace",

// new for win

 TEDITBUTTON,1,0,"EditButton",
 TRULERPATCH,1,0,"RulerPatch",
 TPAL,1,0,"Palette",
 TCAPS,1,0,"Caps",
 TBORDERB,1,0,"BorderB",
 TBORDERS,1,0,"BorderS",
 TGPBOX1,1,0,"GPBOX1",
 TGPBOX2,1,0,"GPBOX2",
 TGPBOX4,1,0,"GPBOX4",
 TAPPMAN,1,0,"Appman",
 TAPPMANP,1,0,"Appmanp",

 TFONTMAN,1,0,"Fontman",
 TFONTMANREP,1,0,"Fontmanrep",
 TFONTMANIG,1,0,"Fontmanig",
 TFONTMANMAP,1,0,"Fontmanmap",
 TFONTMANPS,1,0,"Fontmanps",

 TFONTMENU,1,0,"Fontmenu",

 TTOOLBOX1,1,0,"Toolbox1",
 TIPAL1,1,0,"Infopal1",
 TPOSTSCRIPT,1,0,"PostScript",
	TCHARSP,1,0,"CharsP",
	TFONTSAMPLE,1,0,"FONTSAMPLE",

 TLAST,0,0,""
};


static templink templatelink;



static filetypelink filetypelink;

static filetypetag filetypetable[]=
{
 TEXTFILE,"txt","Text (*.txt)",
 TEXTFILE,"fff","Text (*.txt)",
	UNICODETEXTFILE,"txt","Unicode (*.txt)",
	UNICODETEXTFILE,"105","Unicode (*.txt)",
 OBEY,"obe","Obey (*.obe)",
 OBEY,"feb","Obey (*.obe)",
 DATA,NULL,"Data (*.dat)",
 DATA,"dat","Data (*.dat)",
 DATA,"ffd","Data (*.dat)",
 DRAW,"aff","Acorn Draw file format (*.aff)",
 DRAW,"drw","Acorn Draw file format (*.drw)",
 DRAW,"drw,aff","Acorn Draw file format (*.aff)",
 SPRITE,"spr","Sprite (*.spr)",
 SPRITE,"ff9","Sprite (*.spr)",
 SPRITE,"spr,ff9","Sprite (*.spr)",
 JPEG,"jpg","JPEG (*.jpg)",
 JPEG,"jpe","JPEG (*.jpe)",
 JPEG,"jpeg","JPEG (*.jpeg)",
 JPEG,"c85","JPEG (*.jpeg)",
 FTYPE2,"dpd","DTP Document (*.dpd)",
 FTYPE2,"b27","DTP Document (*.dpd)",
 FTYPE2,"dpd,b27","DTP Document (*.dpd)",
 STYPE2,"dps","DTP Style Sheet (*.dps)",
 STYPE2,"b26","DTP Style Sheet (*.dps)",
 DTYPE2,"ddl","DTP DDL file (*.ddl)",
 DTYPE2,"b25","DTP DDL file (*.ddl)",
 SCRIPT2,"csc","C script file (*.csc)",
 SCRIPT2,"b24","C script file (*.csc)",
 BMP,"bmp","BMP (*.bmp)",
 BMP,"69c","BMP (*.bmp)",
 CSV,"csv","CSV (*.csv)",
 CSV,"dfe","CSV (*.csv)",
 TIFFTYPE,"tif","TIFF (*.tif)",
 TIFFTYPE,"tiff","TIFF (*.tiff)",
 TIFFTYPE,"ff0","TIFF (*.tif)",
 FTYPE,"ovd","Ovation 1 Document (*.ovd)",
 FTYPE,"cdd","Ovation 1 Document (*.ovd)",
 STYPE,"ovs","Ovation 1 Style sheet (*.ovs)",
 STYPE,"cdc","Ovation 1 Style sheet (*.ovs)",
 CLEAR,"clr","Clear bitmap (*.clr)",
 CLEAR,"690","Clear bitmap (*.clr)",
 GIF,"gif","GIF bitmap (*.gif)",
 GIF,"695","GIF bitmap (*.gif)",
 PBM,"pbm","PBM bitmap (*.pbm)",
 PBM,"69e","PBM bitmap (*.pbm)",
 PCX,"pcx","PCX bitmap (*.pcx)",
 PCX,"697","PCX bitmap (*.pcx)",
 EPS,"eps","Encapsulated PostScript (*.eps)",
 EPS,"ff6","Encapsulated PostScript (*.eps)",
 PSCRIPT,"ps","PostScript (*.ps)",
 PSCRIPT,"ff5","PostScript (*.ps)",
 PNG,"png","PNG bitmap (*.png)",
 PNG,"b60","PNG bitmap (*.png)",
 ICO,"ico","Windows icon (*.ico)",
 ICO,"132","Windows icon (*.ico)",
 CURSOR,"cur","Windows cursor (*.cur)",
 CURSOR,"133","Windows cursor (*.cur)",
 PAL,"pal","RISC OS palette (*.pal)",
 PAL,"fed","RISC OS palette (*.pal)",
 WMETAF,"wmf","Windows meta file (*.wmf)",
 WMETAF,"b2f","Windows meta file (*.wmf)",
 EMETAF,"emf","Windows Enhanced meta file (*.emf)",
 EMETAF,"104","Windows Enhanced meta file (*.emf)",
 RTF,"rtf","RTF document (*.rtf)",
 RTF,"c32","RTF document (*.rtf)",
 DDF,"ddf","DDF file (*.ddf)",
 DDF,"707","DDF file (*.ddf)",
 IMP,"imp","Impression document (*.imp)",
 IMP,"bc5","Impression document (*.imp)",
 OAPPLET,"oap","DTP Applet (*.oap)",
 PRNFILE,"prn","Print file (*.prn)",
 ALLFILES,"*","All files (*.*)",

 FTDEFLT,"dat","Data (*.dat)",

 FTLAST,NULL,NULL,
};



os_error * resinit(char * resources)
{
 os_error * err;

          err=adderrortable(errortable,&errorlink);
 if(!err) err=addtemplates(resources,NULL,temptable,&templatelink);
 if(!err) err=addfiletypetable(filetypetable,&filetypelink);

 if(!err) err=event(EVENT_LOADERRORS,NULL,0);
 if(!err) err=event(EVENT_LOADTEMPLATES,NULL,0);
 if(!err) err=applettemplates();

 return(err);
}

