/*->c.xsect */

#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <ctype.h>


#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"

#include "err.h"
#include "transform.h"
#include "etc.h"
#include "poll.h"
#include "xext.h"
#include "trans.h"
#include "bits.h"
#include "deb.h"



#include "constants.h"
#include "str.h"
#include "object.h"
#include "chain.h"
#include "undo.h"

#include "reslink.h"

#include "view.h"
#include "viewo.h"
#include "viewr.h"
#include "file.h"
#include "select.h"
#include "pref.h"

#include "txstr.h"
#include "fl.h"

#include "page.h"

#include "clip.h"

#include "new.h"
#include "newx.h"
#include "modchap.h"
#include "chsect.h"

#include "mpage.h"
#include "xpage.h"

#include "xsect.h"






static os_error * relinklocalpage(objectloc * src,objectloc * dest)
{
 os_error * err;
 int        message;
 filestr  * dfile;


 dfile=dest->file;

 event(EVENT_DRELINK,dfile,0);

 message=OM_DLINK;

 err=objectmessage2(dest->section,dfile,&message,src->file);

 event(EVENT_DRELINK,dfile,1);

 return(err);
}




static os_error * copysect1(filestr * sfile,filestr * dfile,int s,int d,
                                                          int smode,int dmode)
{
 os_error * err;

 err=makemastersectionfrommaster(sfile,s,smode,dfile,d,dmode);

 return(err);
}



/* called to copy doc pages */

static os_error * copysect2(filestr * sfile,filestr * dfile,
                            int s,int d,
                            int smode,int dmode)
{
 os_error   * err;
 sectionstr * sectionp;
 pagestr    * pagep;
 objectloc    src;
 objectloc    dest;
 int          spage;
 int          dpage;
 newpagestr   newpage;
 transformstr tr;

 err=NULL;

 sectionp=(sectionstr*)fob_find(s,sfile);
 spage=sectionp->chain.child;
 dpage=0;

 while(spage)
 {
  memset(&src,0,sizeof(objectloc));
  memset(&dest,0,sizeof(objectloc));

  sectionp=(sectionstr*)fob_find(s,sfile);
  newpage.data=sectionp->data;
  pagep=(pagestr*)fob_find(spage,sfile);
  newpage.pagenumber=pagep->data.number; 

  dest.file=dfile;
  dest.section=d;
  dest.page=0;
  dest.branch=0;
  dest.object=0;

  err=objectnew(&dest,OPAGE,&newpage);

  sectionp=(sectionstr*)fob_find(d,dfile);

  if(dpage==0)
  {
   sectionp->chain.child=dest.object;
   sectionp->np=1;
   sectionp->data.pagenumber.number=newpage.pagenumber;
  }
  else
  {
   sectionp->np++;

   pagep=(pagestr*)fob_find(dpage,dfile);
   pagep->chain.next=dest.object;
   pagep=(pagestr*)fob_find(dest.object,dfile);
   pagep->chain.prev=dpage;
  }

  dpage=dest.object;

  dfile->hdr.np[DOC]++;

  src.file=sfile;
  src.section=s;
  src.page=spage;
  src.branch=0;
  src.object=spage;
  src.parent=spage;
  src.after=0;
  src.chain=0;
  src.copymode|=smode;

  dest.file=dfile;
  dest.section=d;
  dest.page=dpage;
  dest.branch=0;
  dest.object=0;
  dest.parent=dpage;
  dest.after=0;
  dest.chain=0;
  dest.copymode=LOCNEW|LOCFLOWDATA|LOCKEEPMASTER|LOCNOFLOW|dmode;
  
  tr_setidentity(&tr);
  
  err=objectcopy(&src,&dest,&tr);

  relinkpage(dpage,d,dfile);   /* master frames */

  pagep=(pagestr*)fob_find(spage,sfile);
  spage=pagep->chain.next;
 }


 relinklocalpage(&src,&dest);

 return(err);
}







static os_error * copysect(filestr * sfile,filestr * dfile,
                           int s,int dprev,int smode,int dmode)
{
 os_error        * err;
 sectiondatastr    sectiondata;
 sectionstr      * sectionp;
 int               sm;
 int               sd;
 int               dm;
 int               dd;
 int               dpm;
 int               dpd;
 objectloc         loc;
 int               section;
 int               doundo;

// cprintf("copy sect");


 err=NULL;

 doundo=dmode & LOCUNDO;
 dmode&=~LOCUNDO;

 sectionp=(sectionstr*)fob_find(s,sfile);
 if(!sectionp->branch)
 {
  sd=s;
  sm=sectionp->dual;
 }
 else
 {
  sm=s;
  sd=sectionp->dual;
 }


 if(dprev)
 {
  sectionp=(sectionstr*)fob_find(dprev,dfile);
  if(!sectionp->branch)
  {
   dpd=dprev;
   dpm=sectionp->dual;
  }
  else
  {
   dpm=dprev;
   dpd=sectionp->dual;
  }
 }
 else
 {
  dpm=dpd=0;
 }


 sectionp=(sectionstr*)fob_find(sm,sfile);
 sectiondata=sectionp->data;

 loc.file=dfile;
 loc.branch=1;

 err=objectnew(&loc,OSECTION,&sectiondata);

 dm=loc.object;

 /* link in new section */

 dfile->hdr.ns[MST]++;

 if(!dpm)
 {
  section=dfile->hdr.section[MST];
  dfile->hdr.section[MST]=dm;
  sectionp=(sectionstr*)fob_find(dm,dfile);
  sectionp->chain.next=section;
  if(section)
  {
   sectionp=(sectionstr*)fob_find(section,dfile);
   sectionp->chain.prev=dm;
  }
 }
 else
 {
  sectionp=(sectionstr*)fob_find(dpm,dfile);
  section=sectionp->chain.next;
  sectionp->chain.next=dm;
  sectionp=(sectionstr*)fob_find(dm,dfile);
  sectionp->chain.prev=dpm;
  sectionp->chain.next=section;
  if(section)
  {
   sectionp=(sectionstr*)fob_find(section,dfile);
   sectionp->chain.prev=dm;
  }
 }


 sectionp=(sectionstr*)fob_find(sd,sfile);
 sectiondata=sectionp->data;

 loc.file=dfile;
 loc.branch=0;

 err=objectnew(&loc,OSECTION,&sectiondata);

 dd=loc.object;

 /* link in new section */

 dfile->hdr.ns[DOC]++;

 if(!dpd)
 {
  section=dfile->hdr.section[DOC];
  dfile->hdr.section[DOC]=dd;
  sectionp=(sectionstr*)fob_find(dd,dfile);
  sectionp->chain.next=section;
  if(section)
  {
   sectionp=(sectionstr*)fob_find(section,dfile);
   sectionp->chain.prev=dd;
  }
 }
 else
 {
  sectionp=(sectionstr*)fob_find(dpd,dfile);
  section=sectionp->chain.next;
  sectionp->chain.next=dd;
  sectionp=(sectionstr*)fob_find(dd,dfile);
  sectionp->chain.prev=dpd;
  sectionp->chain.next=section;
  if(section)
  {
   sectionp=(sectionstr*)fob_find(section,dfile);
   sectionp->chain.prev=dd;
  }
 }


 sectionp=(sectionstr*)fob_find(dd,dfile);
 sectionp->dual=dm;
 sectionp=(sectionstr*)fob_find(dm,dfile);
 sectionp->dual=dd;


          err=copysect1(sfile,dfile,sm,dm,smode,dmode);
 if(!err) err=copysect2(sfile,dfile,sd,dd,smode,dmode);


 renumbersections(dfile);
 renumberpages(0,dd,0,dfile);

 recalcmaxpagesize(dfile,-1);

 err=fileresetviews(dfile,FRVREFRESH);


 if(doundo)
 {
  undostart(dfile);

  undowritefn(dfile,UDSECT,NULL,0);
  undowrite(dfile,&dm,sizeof(int));
  undowrite(dfile,&dd,sizeof(int));
   
  undoend(dfile);
 }


 return(err);
}





void copychapter(int fp)
{
 os_error   * err;
 filestr    * sfile;
 filestr    * dfile=NULL;
 int          section;
 int          copysection;


 err=NULL;

 sfile=menufile;
 copysection=menuview->section;

 if(sfile->viewn[MST]) err=geterror(FS13);

 if(!err) err=clipstart(NULL,NULL,NULL,&dfile);
 if(!err)
 {
  section=dfile->hdr.section[DOC];
  scrapsection(dfile,section);
  dfile->hdr.section[DOC]=0;

  section=dfile->hdr.section[MST];
  scrapsection(dfile,section);
  dfile->hdr.section[MST]=0;

  dfile->hdr.ns[DOC]=0;
  dfile->hdr.ns[MST]=0;
  dfile->hdr.np[DOC]=0;
  dfile->hdr.np[MST]=0;

  if(!err) err=copysect(sfile,dfile,copysection,0,0,LOCCLIP|LOCOVERWRITE);

  clipupdate();

  clipend(CLIP_SECTION,NULL);
 }

 zreport(err);

 USE(fp);
}





void pastechapter(int fp)
{
 os_error   * err;
 filestr    * sfile;
 filestr    * dfile;
 sectionstr * sectionp;
 int          section;
 int          after;
 int          dprev;
 int          cbtype;

 err=NULL;

 after=stack[fp];

 dfile=menufile;
 dprev=menuview->dsection;

 if(dfile->viewn[MST]) err=geterror(FS13);

 if(!err)
 {
  if(!after)
  {
   sectionp=(sectionstr*)fob_find(dprev,dfile);
   dprev=sectionp->chain.prev;
  }

  clipboardtype(&cbtype,NULL);
  if(cbtype==CLIP_SECTION)
  {
   err=clipopen(NULL,NULL,&section,&sfile);
   if(!err)
   {

// unicode compatability check
		  err=checkcompatability(sfile,section,CHECKC_CHAIN,dfile);
    if(!err) err=modfile(dfile,0);
    if(!err) err=copysect(sfile,dfile,section,dprev,LOCCLIP,LOCUNDO);
    clipclose(sfile);
   }
  }
 }

 zreport(err);
}



