/*->c.dbfile */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "flex.h"
#include "key.h"
#include "transform.h"


#include "wos.h"
#include "filetype.h"
#include "poll.h"
#include "xext.h"
#include "save.h"
#include "load.h"
#include "fsx.h"
#include "err.h"
#include "temp.h"
#include "timex.h"
#include "bits.h"
#include "bf.h"
#include "etc.h"
#include "trans.h"
#include "alloc.h"
#include "scrap.h"
#include "deb.h"
#include "dbhi.h"

#include "mhi.h"


#include "constants.h"
#include "str.h"
#include "reslink.h"

#include "obj.h"


#include "view.h"
#include "file.h"
#include "object.h"
#include "dscript.h"

#include "wc.h"

#include "transload.h"


#include "dbfile.h"






#define SOPTCHUNK (4*sizeof(saveoptionstr))


static int             saveoptionsn;
static saveoptionstr * saveoptions;

static char *          saveopttext;
static int             saveopttextsize;


#define SOPTTEXTCHUNK 128




os_error * xsetupsaveoptions(saveoptionstr * base,int basesize,
                             saveoptionfn xsaveoptfn,int * csavep)
{
 os_error * err;
 trans_info info;
 
 char     * p;
 int        len;

          err=schunk((flex_ptr)&saveoptions,basesize,SOPTCHUNK);
 if(!err) err=schunk((flex_ptr)&saveopttext,SOPTTEXTCHUNK,SOPTTEXTCHUNK);
 {
  XMEMCPYX(saveoptions,base,basesize);
  saveoptionsn=basesize/sizeof(saveoptionstr);
  saveopttextsize=0;

  info.context_ptr=0;

  while(1)
  {
   err=translateread(DTYPE2,-1,&info);
   if(err)
   {
    if(err->errnum==ENOTRANS || err->errnum==ENOFL) err=NULL;
    break;
   }

   err=schunk((flex_ptr)&saveoptions,(saveoptionsn+1)*sizeof(saveoptionstr),
                                                                    SOPTCHUNK);
   if(err) break;

   saveoptions[saveoptionsn].name=saveopttext+saveopttextsize;
   saveoptions[saveoptionsn].fn=xsaveoptfn;

   p=fs_typestring(info.dtype);
   len=strlen(p)+1;
   len=(len+3) & (~0x3);
   len+=sizeof(int);

   err=schunk((flex_ptr)&saveoptions,saveopttextsize+len+1,SOPTTEXTCHUNK);
   if(err) break;

   strcpy(saveopttext+saveopttextsize,p);
   saveopttextsize+=len-4;
   *(int*)(saveopttext+saveopttextsize)=info.dtype;
   saveopttextsize+=4;

   saveoptionsn++;
  }

  *(saveopttext+saveopttextsize)=0;


  if(!err)
  {
   setsaveoptions(saveoptionsn,saveoptions,csavep);
  }
 }

 return(err);
}



os_error * xgetsaveoption(int basemax,int opt,char * name,int * type)
{
 int    n;
 char * p;
 int    len;

 n=basemax;
 p=saveopttext;
 while(1)
 {
  len=strlen(p)+1;
  if(len<=1) break;
  len=(len+3) & ~(0x3);
  if(n==opt)
  {
   strcpy(name,p);
   p+=len;
   *type=*(int*)p;
   break;
  }
  p+=len+sizeof(int);
  n++;
 }

 return(NULL);
}



/****************************************************************************/

#define MAXOPTS 2

static int csave;



static os_error * saveoptfn(int handle,int opt,int * type,char * name,int maxlen)
{

 if(opt==1)
 {
//  tsprintf(FILENAMELEN,name,"{DDLF}");
  strcpy(name,menufile->name);
  fs_newextension(name,TEXT("ddl"));
  *type=DTYPE2;
 }
 else
 if(opt==0)
 {
  strcpy(name,menufile->name);
  *type=FTYPE2;
 }
 else
 {
  xgetsaveoption(MAXOPTS,opt,name,type);
 }

 csave=opt;

 return(NULL);
 USE(handle);
}


static saveoptionstr savebaseoptions[MAXOPTS]=
{
 TEXT("Ovation Pro"),saveoptfn,
 TEXT("DDL"),        saveoptfn,
};




static os_error * savedocfn(char * name,int type)
{
 os_error * err;
 int        sh;

// cprintf("file name docfn %s",menufile->name);

 if(type!=DTYPE2 && type!=FTYPE2 && type!=STYPE2)
 {
  err=sc_create(&sh);
  if(!err)
  {
   err=savedoc(sc_name(sh),menufile,DTYPE2);
   if(!err)
   {
    err=translatefile(sc_name(sh),DTYPE2,name,type);
    fs_delete(sc_name(sh));
   }
   err=sc_remove(sh,err);
  }
  return(err);
 }
 else
 {
  return(savedoc(name,menufile,type));
 }
}



static os_error * savedocs(char * name,int type)
{
 char temp[FILENAMELEN];
 xzstrncpy(temp,name,sizeof(temp));
 return(savedocfn(temp,type));
}



/* void savedocumentastype(string & name,int ftype); */

void savedocumentastype(int fp)
{
 os_error * err;
 char     * p;
 int        ftype;

 p=stringptr(stack[fp]);
 ftype=stack[fp+1];

 if(p[0])            err=savedocs(p,ftype);
 else
 if(menufile->saved) err=savedocs(menufile->name,ftype);
 else                err=geterror(EBDS);

 zreport(err);
}



static os_error * savedocfnx(char * name,int type)
{
 os_error * err;
 err=savedocfn(name,type);
 if(!err) 
 {
  closefile(menufile);
//  zapmenu();                   /* just in case they use Adjust */
 }
 return(err);
}


#ifdef NEVER
static os_error * savedocint(mousestr * m,char * name,int type)
{
 return(NULL);
 USE(m);
 USE(name);
 USE(type);
}



static os_error * savedocinfo(int * len)
{
 *len=csave?DEFDSSIZE:((domainstr*)(menufile->domain))->size;
 return(NULL);
}



static int docramsave(int flags)
{
 if(csave>1) return(1);
 else        return(0);
 USE(flags);
}


#endif


int savedocument_box(int fp)
{
 return(0);
 USE(fp);
#ifdef NEVER 
 os_error * err;
 int        open;
 static int menuhandle;
 int        handle;

 err=NULL;

 open=stack[fp];

 if(open)
 {
  csave=0;
  err=xsetupsaveoptions(savebaseoptions,sizeof(savebaseoptions),saveoptfn,&csave);
  if(!err) err=setsave(menufile->name,FTYPE2,savedocfn,&handle);
  if(!err) err=setsave2(savedocint,savedocinfo);
  if(!err) err=setsave3(docramsave);
  if(!err)
  {
   menuhandle=create_dbox(handle,menuhandle);
  }
 }
 else
 {
  closesave();
 }

 zreport(err);

 return(menuhandle);
#endif
}



os_error * filepopsave(filestr * file,int autoclose)
{
 os_error * err;
 TCHAR      name[FILENAMELEN];

 menufile=file;

 xzstrncpy(name,file->name,sizeof(name));

 err=xsetupsaveoptions(savebaseoptions,sizeof(savebaseoptions),saveoptfn,&csave);

// err=setsaveoptions(sizeof(savebaseoptions)/sizeof(saveoptionstr),savebaseoptions,&csave);

// if(!err) err=setsave(menufile->name,FTYPE2,autoclose?savedocfnx:savedocfn,&handle);

// if(!err) err=setsave2(savedocint,savedocinfo);
// if(!err) err=menuwindow(handle);

 if(!err) err=opensaveparent(name,NITEM(name),FTYPE2,autoclose?savedocfnx:savedocfn,file->view->handle);

 return(err);
}



void openfilesaveas(int fp)
{
 if(menufile) zreport(filepopsave(menufile,0));
 USE(fp);
}





int savestylesheet_box(int fp)
{
 return(0);
 USE(fp);
#ifdef NEVER

 os_error * err;
 int        open;
 static int menuhandle;
 int        handle;
 char       name[64];

 open=stack[fp];

 if(open)
 {
  tsprintf(sizeof(name),name,"{SS00}");
  err=setsave(name,STYPE2,savedocfn,&handle);
  setsave2(savedocint,NULL);
  menuhandle=create_dbox(handle,menuhandle);
 }
 else
 {
  closesave();
 }

 return(menuhandle);

#endif
}



void saveasstylesheet(int fp)
{
 os_error * err;
 TCHAR      name[MAX_PATH];

 tsprintf(sizeof(name),name,"{SS00}");

 err=opensaveparent(name,NITEM(name),STYPE2,savedocfn,menuview->handle);

 zreport(err);
 USE(fp);
}



void openexportbox(int fp)
{
 os_error * err;

 err=event(EVENT_EXPORTBOX2,menuview,0);

 zreport(err);
 USE(fp);
}



int export_box(int fp)
{
 return(0);
 USE(fp);

#ifdef NEVER
 int        open;
 static int menuhandle;
 int        handle;

 open=stack[fp];

 if(open)
 {
  event(EVENT_EXPORTBOX,menufile,(int)&handle);
  if(handle) menuhandle=create_dbox(handle,menuhandle);
 }
 else
 {
  closesave();
 }

 return(menuhandle);
#endif
}



int export_name(int fp)
{
 char   buff[64];
 char * name;

 name=NULL;
 event(EVENT_EXPORTNAME,menufile,(int)&name);
 if(name) 
 {
  tsprintf(sizeof(buff),buff,name);
  assignstring(stack[fp],buff);
 }

 return(name!=NULL);
}




static os_error * fimport(char * name,int type,int userhandle,int xvolatile)
{
 os_error * err;

 err=viewimport(name,type,(viewstr*)userhandle);

 return(err);
 USE(type);
 USE(userhandle);
 USE(xvolatile);
}



void openimportbox(int fp)
{
 os_error * err;
 loadoptstr opts;
 int        xtype=-1;
 int        copt;
 char       name[MAX_PATH];

 opts.description="All files (*.*)";
 opts.ntypes=1;
 opts.types=&xtype;

 strcpy(name,"");

 err=openloadparent(name,&copt,&opts,1,fimport,(int)menuview,menuview->handle);

 zreport(err);

 USE(fp);
}




static os_error * fload(char * name,int type,int userhandle,int xvolatile)
{
 os_error * err;

 err=loadanyfile(name,FLNOLOAD);

 return(err);
 USE(type);
 USE(userhandle);
 USE(xvolatile);
}



os_error * fileopenbox(void)
{
 os_error * err;
 loadoptstr opts;
 int        xtype=-1;
 int        copt;
 char       name[FILENAMELEN];

 opts.description="All files (*.*)";
 opts.ntypes=1;
 opts.types=&xtype;

 xzstrncpy(name,menufile->name,sizeof(name));

 err=openloadparent(name,&copt,&opts,1,fload,0,menuview->handle);


 return(err);
}


void openfileopen(int fp)
{
 zreport(fileopenbox());
 USE(fp);
}





/****************************************************************************/


static int   fileinfohandle;



static void fileinfozero(int userhandle)
{
 int       eof;
 int       fcount;

 wcdocnext(&eof,&fcount);
 if(eof) 
 {
  remzeroevent(fileinfozero,userhandle);
 }

 writeiconf(userhandle,9,"%d",fcount);
}



static os_error * fileinfokey(int handle,int userhandle,int icon,int * key);


static os_error * fileclose(int handle,int userhandle)
{

 remcloseevent(fileclose,handle,userhandle);
 remparentcloseevent(fileclose,handle,userhandle);
 remhelpevent(NULL,handle,TFILEINFO);
 remzeroevent(fileinfozero,handle);
 remkeyevent(fileinfokey,handle,0);
 closedown(&handle);
 fileinfohandle=0;

 return(NULL);
}



static os_error * fileinfokey(int handle,int userhandle,int icon,int * key)
{
 os_error * err;
 int        ch;

 err=NULL;

 ch=*key;

 if(ch==RETURN || ch==ESCAPE)
 {
  *key=-1;
  err=fileclose(handle,userhandle);
 }

 return(err);

 USE(icon);
}




void openfileinfo(int fp)
{
 os_error   * err;
 char         string[256];
 char         format[64];
 pagestr    * pagep;
 sectionstr * sectionp;
 int          swords;
 int          ssize;
 domainstr  * d;
 int          code;


 err=NULL;

 if(fileinfohandle) fileclose(fileinfohandle,0);

 err=createwindowparent(TFILEINFO,&fileinfohandle,menuview->handle);
 if(!err)
 {
  addhelpevent(NULL,fileinfohandle,TFILEINFO);
  addcloseevent(fileclose,fileinfohandle,0);
  addparentcloseevent(fileclose,fileinfohandle,0);

  writeicon(fileinfohandle,21,fs_leaf(menufile->name));

  getsysdate(format,1,1);
  writets(string,format,(arctime*)menufile->timex);
  writeicon(fileinfohandle,3,string);

  pagep=(pagestr*)fob_find(menuview->dpage,menufile);
  writeiconf(fileinfohandle,13,"%d",pagep->data.number);

  sectionp=(sectionstr*)fob_find(menuview->dsection,menufile);
  writeiconf(fileinfohandle,17,"%d",sectionp->data.number);

  writeiconf(fileinfohandle,15,"%d",menufile->hdr.np[DOC]);

  writeiconf(fileinfohandle,19,"%d",menufile->hdr.ns[DOC]);

  d=menufile->domain;
  writeicon(fileinfohandle,5,memstring(d->size));

  writeicon(fileinfohandle,9,"");  /* total words     */


  if((code=gettextstoryinfo(menufile,&ssize,&swords))!=0)
  {
   writeicon(fileinfohandle,7,memstring(ssize));
   writeiconfc(fileinfohandle,6,code==1?"{WC00}":"{WC01}");
   writeiconfc(fileinfohandle,10,code==1?"{WC02}":"{WC03}");
   writeiconf(fileinfohandle,11,"%d",swords); /* words in story  */
  }
  else
  {
   writeiconc(fileinfohandle,7,"");  /* story size      */
   writeiconc(fileinfohandle,11,""); /* words in story  */
  }

  addzeroevent(fileinfozero,fileinfohandle);
  addkeyevent(fileinfokey,fileinfohandle,0);

  wcdocfirst(menuview);

  popup(fileinfohandle,0);

  setfocus(fileinfohandle);
 }

 zreport(err);
 USE(fp);
}















int fileinfo_box(int fp)
{

 return(0);
 USE(fp);

#ifdef NEVER
 os_error   * err;
 int          open;
 static int   menuhandle;
 static int   fileinfohandle;
 char         string[256];
 char         format[64];
 pagestr    * pagep;
 sectionstr * sectionp;
 int          swords;
 int          ssize;
 domainstr  * d;
 int          code;


 err=NULL;

 open=stack[fp];

 if(open)
 {
  if(!fileinfohandle) 
  {
   err=createwindow(TFILEINFO,&fileinfohandle);
   addhelpevent(NULL,fileinfohandle,TFILEINFO);
  }

  writeicon(fileinfohandle,1,fs_leaf(menufile->name));

  getsysdate(format,1,1);
  writets(string,format,(arctime*)menufile->timex);
  writeicon(fileinfohandle,3,string);

  pagep=(pagestr*)fob_find(menuview->dpage,menufile);
  writeiconf(fileinfohandle,13,"%d",pagep->data.number);

  sectionp=(sectionstr*)fob_find(menuview->dsection,menufile);
  writeiconf(fileinfohandle,17,"%d",sectionp->data.number);

  writeiconf(fileinfohandle,15,"%d",menufile->hdr.np[DOC]);

  writeiconf(fileinfohandle,19,"%d",menufile->hdr.ns[DOC]);

  d=menufile->domain;
  writeicon(fileinfohandle,5,memstring(d->size));

  writeicon(fileinfohandle,9,"");  /* total words     */


  if((code=gettextstoryinfo(menufile,&ssize,&swords))!=0)
  {
   writeicon(fileinfohandle,7,memstring(ssize));
   writeiconfc(fileinfohandle,6,code==1?"{WC00}":"{WC01}");
   writeiconfc(fileinfohandle,10,code==1?"{WC02}":"{WC03}");
   writeiconf(fileinfohandle,11,"%d",swords); /* words in story  */
  }
  else
  {
   writeiconc(fileinfohandle,7,"");  /* story size      */
   writeiconc(fileinfohandle,11,""); /* words in story  */
  }

  menuhandle=create_dbox(fileinfohandle,menuhandle);

  if(!fzeroactive)
  {
   addzeroevent(fileinfozero,fileinfohandle);
   fzeroactive=1;
  }

  wcdocfirst(menuview);
 }
 else
 {
  remhelpevent(NULL,fileinfohandle,TFILEINFO);
  closedown(&fileinfohandle);
 }

 zreport(err);

 return(menuhandle);
#endif
}

