/*->c.dbline */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "transform.h"
#include "etc.h"

#include "wos.h"
#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "redraw.h"
#include "trans.h"
#include "bf.h"
#include "bits.h"


#include "dbhi.h"
#include "mhi.h"

#include "str.h"
#include "reslink.h"
#include "units.h"
#include "xcolour.h"
#include "file.h"
#include "geometry.h"

#include "dbcolour.h"
#include "view.h"
#include "posn.h"
#include "object.h"
#include "select.h"
#include "pref.h"

#include "dbchoices.h"

#include "dbscale.h"


#include "line.h"
#include "dbline.h"




/*****************************************************************************/

extern dboxstr linebox;

static boxbitstr ob;
static boxbitstr nb;


static unpackedlinedatastr cline;
static linechangebits      cbits;


static filestr   * cfile;
static viewstr   * cview;
static int         cobject;
static int         cunits;


static int linemenumode;


static int xcapswidth;
static int xcapsheight;



#define LINEDBOX  1
#define LINECHBOX 2
#define CAPSMODE  3


#define LINECOLICON 19
#define FILLCOLICON 36


/*************************************************************************************************************/


typedef os_error * (*pickcapsfn)(int caps,int width,int height);


static int pickxwidth;
static int pickxheight;
static int pickxcaps;

static pickcapsfn pickxfn;


static os_error * outrx(int value,char * string)
{
 strcpy(string,numbertostringxdp(value,2,0));
 return(NULL);
}

static os_error * inrx(int * value,char * string)
{
 os_error * err;
 err=stringtonumberxdp(string,value,2,0);
 return(err);
}



static os_error * capsicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;


 switch(m->i)
 {
   case  14:
           linemenumode=CAPSMODE;
           err=openmenuparent("trianglew_menu",handle);
           break;

   case  19:
           linemenumode=CAPSMODE;
           err=openmenuparent("triangleh_menu",handle);
           break;

 }

 return(err);

 USE(handle);
 USE(userhandle);
}



static os_error * capsclose(int code)
{
 os_error * err;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  if(pickxfn)
  {
   err=pickxfn(pickxcaps,pickxwidth,pickxheight);
  }
 }

 return(err);
}




static dbiconstr capsicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */
   16,  &pickxwidth, DBWRITE,  0,   0,      -1, -1, 3, -1,    inrx, outrx,
   20,  &pickxheight,DBWRITE,  0,   0,      -1, -1, 5,  1,    inrx, outrx,

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN, 0,0,    NULL, 0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE, 0,0,NULL, 0,

/* N   &V           Type     Grp   Flags   Msk Key   ESG   -   clickfn 0 */
   18, &pickxcaps,   DBRADIO,  0,    0,      0, F4,  1, 0,     NULL,   0,
   17, &pickxcaps,   DBRADIO,  0,    0,      1, F5,  1, 0,     NULL,   0,
   26, &pickxcaps,   DBRADIO,  0,    0,      2, F4,  1, 0,     NULL,   0,
   27, &pickxcaps,   DBRADIO,  0,    0,      3, F4,  1, 0,     NULL,   0,

   -1, NULL,                     0,     0,     0,  0,  0,  0,  0,  0,  0
};



static dboxstr capsbox=
{
 0,
 TCAPS,
 DBFIX,
 0,
 capsclose,
 capsicon,
 NULL,
 NULL,
 capsicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};





static os_error * pickcaps(int caps,int width,int height,pickcapsfn pick,dboxstr * parent)
{
 os_error * err;

 pickxcaps=caps;
 pickxwidth=width;
 pickxheight=height;
 pickxfn=pick;

 err=dodboxsp(&capsbox,1,parent,&dbviewstack);

 return(err);
}


/*************************************************************************************************************/


static os_error * colredrawsub(int handle,wimp_redrawstr * redrawstr,int more)
{
 os_error * err;

 err=NULL;

 while(more)
 {
  redrawblock(redrawstr,handle,FILLCOLICON,
                              vfindcolour2(NULL,cfile,&cline.data.fillcolour));

  redrawblock(redrawstr,handle,LINECOLICON,
                              vfindcolour2(NULL,cfile,&cline.data.linecolour));
  wimp_get_rectangle(redrawstr,&more);
 }
 return(err);
}


static os_error * lineredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;
 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) colredrawsub(handle,&redrawstr,more);
 return(err);
 userhandle=userhandle;
}


static void fillpickclose(colourvalue * colour)
{
 cline.data.fillcolour=*colour;
 wimp_set_icon_state(linebox.handle,FILLCOLICON,
                                    (wimp_iconflags)0,(wimp_iconflags)0);
}

static void linepickclose(colourvalue * colour)
{
 cline.data.linecolour=*colour;
 wimp_set_icon_state(linebox.handle,LINECOLICON,
                                    (wimp_iconflags)0,(wimp_iconflags)0);
}


static os_error * linedbgetwidth(int * width)
{
 *width=cline.data.thickness;
 return(NULL);
}


static os_error * linedbsetwidth(int width)
{
 cline.data.thickness=width;
 return(dbchangevalue(&cline.data.thickness,&linebox));
}


static os_error * pickstart(int caps,int width,int height)
{
 cline.data.startcaps=caps;
 cline.data.startwidth=width;
 cline.data.startheight=height;

 dbchangevalue(&cline.data.startcaps,&linebox);

 return(NULL);
}



static os_error * pickend(int caps,int width,int height)
{
 cline.data.endcaps=caps;
 cline.data.endwidth=width;
 cline.data.endheight=height;

 dbchangevalue(&cline.data.endcaps,&linebox);

 return(NULL);
}




static os_error * lineicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;


 linemenumode=LINEDBOX;

 switch(m->i)
 {

#ifdef NEVER
  case 20:            /* fill */
          break;
#endif

  case 37:            /* fill colour */
          err=pickcolour(cfile,&cline.data.fillcolour,fillpickclose,&linebox);
          break; 

  case 20:            /* line colour */
          err=pickcolour(cfile,&cline.data.linecolour,linepickclose,&linebox);
          break;

  case 17:            /* width */
          err=openlinewidthmenu(linedbsetwidth,linedbgetwidth,handle);
          break;

  case 23:            /* style */
          err=openmenuparent("linestyle_menu",handle);
          break;

/*
  case 29:
          err=openmenuparent("linestartcaps_menu",handle);
          break;

  case 32:
          err=openmenuparent("lineendcaps_menu",handle);
          break;
*/

  case 26:
          err=openmenuparent("linejoin_menu",handle);
          break;


  case 29:
          err=pickcaps(cline.data.startcaps,cline.data.startwidth,cline.data.startheight,pickstart,&linebox);
          break;

  case 32:
          err=pickcaps(cline.data.endcaps,cline.data.endwidth,cline.data.endheight,pickend,&linebox);
          break;



/*  case 39:
  case 40:
  case 41:
          err=openmenu("linewindingrule_menu");
          break; */
 }

 return(err);

 USE(handle);
 USE(userhandle);
}


static os_error * lineup(int line,filestr * file)
{
 os_error * err;
 linestr  * linep;

 err=lineupdate(&cline,&cbits,line,file);

 if(cbits.xtransform) 
 {
  linep=(linestr*)fob_find(line,file);
  err=transline(linep,file,boxtrans,0);
 }

 return(err);
}


static os_error * lineclose(int code)
{
 os_error * err;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  linechanges(cobject,cfile,&cline,&cbits);
  if((cbits.xtransform=(cmpboxbits(&ob,&nb)!=0))!=0)
  {
   setboxtrans(&ob,&nb);
   ob=nb;
  }
  modifyselection(lineup);
 }
 return(err);
}


os_error * linechangewidths(int width)
{            
 memset(&cbits,0,sizeof(linechangebits));
 cbits.xthickness=1;
 cline.data.thickness=width;
 return(modifyselection(lineup));
}



static setlinewidthmenuhandler ssmh;
static getlinewidthmenuhandler gsmh;



int getlinewidth(int fp)
{
 int width;

 width=0;

 if(gsmh) zreport(gsmh(&width));

 return(width);

 USE(fp);
}





void setlinewidth(int fp)
{
 if(ssmh) zreport(ssmh(stack[fp]));
}





os_error * openlinewidthmenu(setlinewidthmenuhandler xssmh,
                             getlinewidthmenuhandler xgsmh,int parent)

{
 ssmh=xssmh;
 gsmh=xgsmh;

 return(openmenuparent("linewidth_menu",parent));
}



/* setlinetriangle(int startcaps,int height,int multiple) */
/* startcaps==1 for leading cap       */
/* height==1 for cap height           */
/* multiple is ratio based on 0x10000 */


void setlinetriangle(int fp)
{
 int height;
 int multiple;

 height=stack[fp+1];
 multiple=stack[fp+2];


 if(linemenumode==LINEDBOX)
 {
  if(stack[fp])
  {
   if(height) cline.data.startheight=multiple;
   else       cline.data.startwidth=multiple;
  }
  else
  {
   if(height) cline.data.endheight=multiple;
   else       cline.data.endwidth=multiple;
  }
 }
 else
 if(linemenumode==LINECHBOX)
 {
  if(height) 
  {
   xcapsheight=multiple;
   choicechangevalue(&xcapsheight);
  }
  else
  {
   xcapswidth=multiple;
   choicechangevalue(&xcapswidth);
  }
 }
 else
 if(linemenumode==CAPSMODE)
 {
  if(height)
  {
   pickxheight=multiple;
   dbchangevalue(&pickxheight,&capsbox);
  }
  else
  {
   pickxwidth=multiple;
   dbchangevalue(&pickxwidth,&capsbox);
  }
 }
}

/* getlinetriangle(int startcaps,int height) */
/* return multiple                           */

int getlinetriangle(int fp)
{
 int height;

 height=stack[fp+1];

 if(linemenumode==LINEDBOX)
 {
  if(stack[fp])
  {
   if(height) return(cline.data.startheight);
   else       return(cline.data.startwidth);
  }
  else
  {
   if(height) return(cline.data.endheight);
   else       return(cline.data.endwidth);
  }
 }
 else
 if(linemenumode==LINECHBOX)
 {
  if(height) return(xcapsheight);
  else       return(xcapswidth);
 }
 else
 if(linemenumode==CAPSMODE)
 {
  if(height) return(pickxheight);
  else       return(pickxwidth);
 }

 return(0);
}


/* setlinecaps(int start,int caps) */

void setlinecaps(int fp)
{
 int caps;
 caps=stack[fp+1];
 if(stack[fp])
 {
  cline.data.startcaps=caps;
  dbchangevalue(&cline.data.startcaps,&linebox);
 }
 else
 {
  cline.data.endcaps=caps;
  dbchangevalue(&cline.data.endcaps,&linebox);
 }
}

/* getlinecaps(int start) */

int getlinecaps(int fp)
{
 if(stack[fp]) return(cline.data.startcaps);
 else          return(cline.data.endcaps);
}

int getlinewindingrule(int fp)
{
 return(cline.data.windingrule);
 USE(fp);
}

void setlinewindingrule(int fp)
{
 cline.data.windingrule=stack[fp];
 dbchangevalue(&cline.data.windingrule,&linebox);
}



/* void setlinestyle(int style,int size) */

void setlinestyle(int fp)
{
 cline.data.style=stack[fp];
 cline.data.stylescale=stack[fp+1];
 dbchangevalue(&cline.data.style,&linebox);
}


/* void getlinestyle(void) */

int getlinestyle(int fp)
{
 return(cline.data.style);
 USE(fp);
}



int getlinescale(int fp)
{
 return(cline.data.stylescale);
 USE(fp);
}



/* void setlinejoin(int join) */

void setlinejoin(int fp)
{
 cline.data.join=stack[fp];
 dbchangevalue(&cline.data.join,&linebox);
}

/* int getlinejoin(void) */

int getlinejoin(int fp)
{
 return(cline.data.join);
 USE(fp);
}


static os_error * outu(int value,char * string)
{
 strcpy(string,unitstostring(value,cunits));
 return(NULL);
}



static os_error * wrjoin(int value,char * string)
{
 switch(value)
 {
  case 0:
         tsprintf(32,string,"{MIT}");
         break;
  case 1:
         tsprintf(32,string,"{RND}");
         break;
  case 2:
         tsprintf(32,string,"{BEV}");
         break;
 }
 return(NULL);
}


/*

static os_error * wrwind(int value,char * string)
{
 if(value) tsprintf(32,string,"{WEO}");
 else      tsprintf(32,string,"{WNZ}");
 return(NULL);
}

*/


static os_error * wrcaps(int value,char * string)
{
 switch(value)
 {
  case 0:
         tsprintf(32,string,"{BUT}");
         break;

  case 1:
         tsprintf(32,string,"{RND}");
         break;

  case 2:
         tsprintf(32,string,"{SQR}");
         break;

  case 3:
         tsprintf(32,string,"{TRI}");
         break;
 }
 return(NULL);
}




static os_error * wrthick(int value,char * string)
{
 if(value) return(outu(value,string));
 else
 {
  tsprintf(32,string,"{THIN}");
  return(NULL);
 }
}



static os_error * rdthick(int * value,char * string)
{
 os_error * err;
 char       temp[64];

 err=NULL;

 tsprintf(sizeof(temp),temp,"{THIN}");
 if(!cstrcmp(temp,string)) *value=0;
 else                      err=stringtounits(string,value,cunits);

 return(err);
}




static os_error * inu(int * value,char * string)
{
 return(stringtounits(string,value,cunits));
}



static os_error * outux(int value,char * string)
{
 strcpy(string,unitstostring(value-prefp(cfile)->rulerx,cunits));
 return(NULL);
}

static os_error * inux(int * value,char * string)
{
 os_error * err;
 int        n;
 err=stringtounits(string,&n,cunits);
 *value=n+prefp(cfile)->rulerx;
 return(err);
}



static os_error * outuy(int value,char * string)
{
 strcpy(string,unitstostring(value-prefp(cfile)->rulery,cunits));
 return(NULL);
}

static os_error * inuy(int * value,char * string)
{
 os_error * err;
 int        n;
 err=stringtounits(string,&n,cunits);
 *value=n+prefp(cfile)->rulery;
 return(err);
}






static dbiconstr lineicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */
   33,  &nb.orgx,    DBWRITE,  0,   0,      -1, -1, 3, -1,    inux, outux,
    3,  &nb.orgy,    DBWRITE,  0,   0,      -1, -1, 5,  1,    inuy, outuy,
    5,  &nb.width,   DBWRITE,  0,   0,      -1, -1, 7,  3,    inu,  outu,
    7,  &nb.height,  DBWRITE,  0,   0,      -1, -1, 9,  5,    inu,  outu,
    9,  &nb.angle,   DBWRITE,  0,   DBASSOCINC,      -1, -1,-1,  7,readangle,writeangle,
   39,  &nb.skew,    DBWRITE,  0,   DBASSOCINC,      -1, -1,-1,  7,readskew,writeskew,

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN, 0,0,    NULL, 0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE, 0,0,NULL, 0,


 /* N   &V           Type     Grp   Flags   Step Key  max  min clickfn 0 */

   11, &nb.angle,    DBDEC   ,0,    0,       -0x10000,-1,MAXANGLE,
                                                        MINANGLE,NULL,0,

   12, &nb.angle,    DBINC   ,0,    0,       -0x10000,-1,MAXANGLE,
                                                        MINANGLE,NULL,0,

   41, &nb.skew,     DBDEC   ,0,    0,       -0x10000,-1,MAXSKEW,
                                                        MINSKEW,NULL,0,

   42, &nb.skew,     DBINC   ,0,    0,       -0x10000,-1,MAXSKEW,
                                                        MINSKEW,NULL,0,

 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

   13, &cline.lock,  DBTOGGLE, 0,    0,      1, F4,  0, 0,     NULL,   0,
   14, &cline.spread,DBTOGGLE, 0,    0,      1, F4,  0, 0,     NULL,   0,

   16, &cline.data.thickness,DBTEXT,0,0,      0,  0,  0, 0,     rdthick, wrthick,
   25, &cline.data.join,DBTEXT,     0,0,      0,  0,  0, 0,     NULL, wrjoin,

/* 40, &cline.data.windingrule,DBTEXT,0,0,    0,  0,  0, 0,   NULL, wrwind,*/

   28, &cline.data.startcaps,DBTEXT,0,0,      0,  0,  0, 0,     NULL, wrcaps,
   31, &cline.data.endcaps,DBTEXT,  0,0,      0,  0,  0, 0,     NULL, wrcaps,

   -1, NULL,                     0,     0,     0,  0,  0,  0,  0,  0,  0
};



static dboxstr linebox=
{
 0,
 TLINE,
 DBFIX,
 0,
 lineclose,
 lineicon,
 NULL,
 lineredraw,
 lineicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};



/* script function opens the new document dialogue box */

os_error * openlinebox(linestr * linep,filestr * file,viewstr * view)
{
 os_error * err;

 cfile=file;
 cview=view;
 cobject=linep->key;

 cline.data=linep->data;
 cline.lock=linep->flags.locked;
 cline.spread=linep->flags.spread;

 cunits=cview->data.units;

 getboxbits(&linep->fcurve.box,&linep->transform,&ob);
 nb=ob;

 err=dodboxspparent(&linebox,1,&linebox,&dbviewstack,view->handle);

 return(err);
}


/***************************************************************************/


static int xlinewidth;
//static int xcapswidth;
//static int xcapsheight;



static os_error * chclose(int code)
{
 if(code==DBOK || code==DBAPPLY)
 {
  defltlinedata.endwidth=xcapswidth;
  defltlinedata.startwidth=xcapswidth;
  defltlinedata.endheight=xcapsheight;
  defltlinedata.startheight=xcapsheight;
  defltlinedata.thickness=xlinewidth;
 }

 return(NULL);
}


static os_error * chsave(buffer * bf)
{
 return(bf_printfeol(bf,"linechoices(%d,%d,%d);",
                      defltlinedata.thickness,
                      defltlinedata.endwidth,defltlinedata.endheight));
}


void linechoices(int fp)
{
 defltlinedata.thickness=stack[fp];
 defltlinedata.endwidth=defltlinedata.startwidth=stack[fp+1];
 defltlinedata.endheight=defltlinedata.startheight=stack[fp+2];
}




static os_error * linechgetwidth(int * width)
{
 *width=xlinewidth;
 return(NULL);
}


static os_error * linechsetwidth(int width)
{
 xlinewidth=width;
 return(choicechangevalue(&xlinewidth));
}




static os_error * chicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;


 linemenumode=LINECHBOX;

 menuview=NULL; /* because these menus may use units */
 menufile=NULL;


 switch(m->i)
 {
   case  3:
           err=openlinewidthmenu(linechsetwidth,linechgetwidth,handle);
           break;

   case  7:
           err=openmenuparent("trianglew_menu",handle);
           break;

   case  9:
           err=openmenuparent("triangleh_menu",handle);
           break;
 }

 return(err);

 handle=handle;
 userhandle=userhandle;
}



/*
static os_error * wrcapd(int value,char * string)
{
 sprintf(string,"x%s",numbertostringxdp(value,2,0));
 return(NULL);
}
*/


static dbiconstr chicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

   22, &xlinewidth,  DBWRITE, 0,     0,    -1, -1, -1, -1,  rdthick, wrthick,
    6, &xcapswidth,  DBWRITE, 0,     0,    -1, -1, -1, -1,  inrx, outrx,
    8, &xcapsheight, DBWRITE, 0,     0,    -1, -1, -1, -1,  inrx, outrx,

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};



static os_error * chopen(void)
{
 cunits=MILIMS;
 xlinewidth=defltlinedata.thickness;
 xcapswidth=defltlinedata.endwidth;
 xcapsheight=defltlinedata.endheight;
 return(NULL);
}


static dboxstr chbox=
{
 0,
 TCHLINE,
 DBPANE,
 0,
 NULL,
 chicon,
 NULL,
 NULL,
 chicondefs,
 0,
 0
};


static subchoicestr ch=
{
 NULL,

 &chbox,

 "ch_line",
 "{CHL0}",

 chsave,
 chclose,
 NULL,
 chopen,
 NULL,
 NULL,
};



os_error * dblineinit(void)
{
 return(choicesadd(&ch));
}


