/*->c.dbpage */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "transform.h"

#include "wos.h"
#include "err.h"
#include "task.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "conf.h"
#include "deb.h"


#include "dbhi.h"
#include "mhi.h"

#include "str.h"
#include "constants.h"

#include "object.h"

#include "reslink.h"
#include "units.h"
#include "etc.h"

#include "view.h"
#include "viewo.h"
#include "file.h"
#include "dbscale.h"


#include "txstr.h"

#include "new.h"
#include "xpage.h"


#include "dbnew.h"
#include "dbpage.h"






static viewstr * cview;
static int       ccontmode;

static int npages;
static int pagen;
static int after;


/**************************************************************************/


static os_error * pagenout(int value,char * string)
{
 strcpy(string,numbertostring(value));
 return(NULL);
}


static os_error * pagenin(int * value,char * string)
{
 return(stringtonumber(string,value));
}


static os_error * pageouta(int value,char * string)
{
 if(value<0) *string=0;
 else        writepagenumbera(string,value,ccontmode,cview);
 return(NULL);
}


static os_error * pageina(int * value,char * string)
{
	cprintf("pageina");

 return(readpagenuma(string,value,cview));
}


/***************************************************************************/


static os_error * inspageclose(int code)
{
 os_error       * err;
 filestr        * file;
 int              bpage;
 int              bsect;


 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  file=cview->file;
  psapageno(pagen,&bpage,&bsect,file,cview->branch);
  err=doinsert(bpage,bsect,npages,after,file);
 }

 return(err);
}




static dbiconstr inspageicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

    5, &npages,        DBWRITE,0,   0,      -1, -1, 14, -1, pagenin,pagenout,
    4, &pagen,         DBWRITE,0,   0,      -1, -1, 14, -1, pageina,pageouta,  

    8,  &after,        DBRADIO,  0,   0,      1,F5,   2,0,NULL,0,
    7,  &after,        DBRADIO,  0,   0,      0,F6,   2,0,NULL,0,


 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN, 0,0,    NULL, 0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0, NULL, 0,

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr inspagebox=
{
 0,
 TINSPAGE,
 DBFIX,
 0,
 inspageclose,
 NULL,
 NULL,
 NULL,
 inspageicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};



void openinspagebox(int fp)
{
 filestr * file;
 int       branch;

 cview=menuview;
 file=cview->file;
 branch=cview->branch;

 npages=1;

 pagen=apageno(cview->dpage,cview->dsection,file,branch);
 ccontmode=contnum(file,branch);

 zreport(dodboxspparent(&inspagebox,1,&inspagebox,&dbviewstack,cview->handle));

 USE(fp);
}


/*****************************************************************************/

static int dfrom;
static int dto;



static os_error * delpageclose(int code)
{
 os_error       * err;
 filestr        * file;
 int              branch;
 int              fpage;
 int              lpage;
 int              fsect;
 int              lsect;


 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  if(dfrom>dto)
  {
   err=geterror(PA00);  /* First page number greater than last. */
  }
  else
  {
   file=cview->file;
   branch=cview->branch;

   psapageno(dfrom,&fpage,&fsect,file,branch);
   psapageno(dto,&lpage,&lsect,file,branch);

   if(dfrom>dto)
   {
    err=geterror(PA01); /* First page comes after last. */
   } 
   else
   if(fsect!=lsect)
   {
    err=geterror(PA03); /* First and last pages are in different chapters. */
   }
   else err=dodelete(fpage,lpage,fsect,file);
  }
 }
 return(err);
}



static dbiconstr delpageicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

    4, &dfrom,        DBWRITE,0,   0,      -1, -1, 14, -1, pageina,pageouta,
    3, &dto,          DBWRITE,0,   0,      -1, -1, 14, -1, pageina,pageouta,  

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN, 0,0,    NULL, 0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0, NULL, 0,

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr delpagebox=
{
 0,
 TDELPAGE,
 DBFIX,
 0,
 delpageclose,
 NULL,
 NULL,
 NULL,
 delpageicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};



void opendelpagebox(int fp)
{
 filestr  * file;
 int        branch;

 cview=menuview;
 file=cview->file;
 branch=cview->branch;

 dto=dfrom=apageno(cview->dpage,cview->dsection,file,branch);
 ccontmode=contnum(file,branch);

 zreport(dodboxspparent(&delpagebox,1,&delpagebox,&dbviewstack,cview->handle));

 USE(fp);
}



/****************************************************************************/

static int current;
static int dgoto;


static os_error * gotopageclose(int code)
{
 os_error       * err;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  gotopagea(cview,dgoto);
 }
 return(err);
}


static dbiconstr gotopageicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

    4, &current,      DBTEXT,0,   0,      -1,  -1, 14, -1,    NULL, pageouta,
    3, &dgoto,        DBWRITE,0,   0,      -1, -1, 14, -1, pageina, pageouta,  

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN, 0,0,    NULL, 0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0, NULL, 0,

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr gotopagebox=
{
 0,
 TGOTOPAGE,
 DBFIX,
 0,
 gotopageclose,
 NULL,
 NULL,
 NULL,
 gotopageicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};



void opengotopagebox(int fp)
{
 filestr  * file;
 int        branch;

 cview=menuview;
 file=cview->file;
 branch=cview->branch;

 current=apageno(cview->dpage,cview->dsection,file,branch);
 ccontmode=contnum(file,branch);

 dgoto=-1;

 zreport(dodboxspparent(&gotopagebox,1,&gotopagebox,&dbviewstack,cview->handle));

 USE(fp);
}




/************************************************************************/

void deletechapter(int fp)
{
 os_error   * err;
 int          result;
 sectionstr * sectionp;


 sectionp=(sectionstr*)fob_find(menuview->section,menufile);

 err=confirmparent(menuview->handle,CONDC,&result,"{CH1}",sectionp->data.number);
 if(!err)
 {
  if(result==1) err=remchapter(menuview->section,menuview);
 }

 zreport(err);
 USE(fp);
}

