/*->h.filllink */




typedef struct filldatastr
{
 int           x;
 int           y;
 int           scale;
 int           aspect;
 int           angle;
 int           skew;

 int           process;

 int           spareb;
 int           sparec;

 int           spare1;
 int           spare2;
 int           spare3;
 int           spare4;

} filldatastr;




typedef struct fillobjectstr
{
 int           key;
 int           type;

 chainstr      chain;

 transformstr  tr;

 int           filltype;

 int           spare1;
 int           spare2;

 filldatastr   data;

} fillobjectstr;




typedef struct filltoolstr
{
 int         x;
 int         y;
 int         rx;
 int         ry;
 int         angle;
 int         skew;
 colourvalue c1;
 colourvalue c2;
 int         filltype;
 int         scale;
 int         aspect;
 int         bits;
 int         process;



} filltoolstr;







typedef os_error * (*filldeletefn)(fillstr * fill,filestr * file);

typedef os_error * (*fillcopyfn)(fillstr * d,filestr * dfile,
                                 fillstr * s,filestr * sfile,int mode);

typedef os_error * (*fillrenderfn)(viewredrawstr * v,curvestr * c,
                                    curvestylestr * cstyle,transformstr * t);

typedef os_error * (*filldswritefn)(fillstr * fill,buffer * bf,filestr * file);


typedef os_error * (*fillpanefn)(int open,fillstr * fill,viewstr * view,
                                                         dboxstr * parent);


typedef os_error * (*fillsrenderfn)(aboxstr * abox,transformstr * restr,
                                    transformstr * filltr,
                                    viewredrawstr * v,curvestr * c,
                                    curvestylestr * cstyle,transformstr * tr);


typedef os_error * (*filldrenderfn)(aboxstr * abox,transformstr * restr,
                                    transformstr * filltr,
                                    viewredrawstr * v,curvestr * c,
                                    curvestylestr * cstyle,transformstr * tr,
                                    int * dorenderfill);



typedef os_error * (*fillcreatefn)(filestr * file,filldatastr * data,
                                                  fillstr * xnew,fillstr * old);


typedef os_error * (*fillapplyfn)(filestr * file,filltoolstr * tool,
                                                 fillstr * xnew,fillstr * old);


typedef os_error * (*filltoolfn)(filestr * file,filltoolstr * tool,
                                                fillstr * old);




#define FLF_BUFFER 0x1     /* must buffer to sprite                      */
#define FLF_SOLID  0x2     /* fill is solid - no need to fill background */



typedef struct fillblockstr
{
 int            parent;
 int            sibls[2];
 int            balance;

 int            filltype;

 fillrenderfn   frfn;
 fillcopyfn     fcfn;
 filldeletefn   fdfn;
 filldswritefn  fsfn;

 char         * name;
 dboxstr      * dbox;

 fillpanefn     fpfn;
 fillsrenderfn  render;
 fillcreatefn   create;

 int            flags;

 fillapplyfn    apply;
 filltoolfn     tool;

 filldrenderfn  renderd;


} fillblockstr;




extern fillblockstr *   getfillroot(void);


extern os_error     *   filllinkblock(fillblockstr * fillblock);


extern os_error     *   fillregister(fillrenderfn xfrfn,fillcopyfn xfcfn,
                                     filldeletefn xfdfn,filldswritefn xfsfn);


