/*->c.dbpicture */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "transform.h"
#include "xprocess.h"
#include "etc.h"

#include "wos.h"
#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "xmath.h"
#include "deb.h"

#include "dbhi.h"
#include "mhi.h"



#include "str.h"
#include "reslink.h"
#include "units.h"
#include "posn.h"
#include "object.h"

#include "view.h"
#include "viewr.h"
#include "file.h"
#include "select.h"
#include "dbscale.h"


#include "pxstr.h"
#include "pict.h"
#include "dbpict.h"
#include "pixtool.h"

#include "dbpicture.h"




/*****************************************************************************/

extern dboxstr picturebox;


static unpackedpicturedatastr  upd;

static viewstr    * cview;
static filestr    * cfile;
static int          cpictbox;
static int          cpicture;
static int          cpictsection;


static void picfit(void)
{
 dbreadvalues(&picturebox);
 pictscaletofit(cpictbox,&upd.pd,cfile);
 dbwritevalues(&picturebox);
}



static os_error * pictureicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 switch(m->i)
 {
  case 31:            /* fit */
          picfit();
          break;
 }

 return(NULL);

 handle=handle;
 userhandle=userhandle;

 return(err);

}





static os_error * pictureclose(int code)
{
 os_error      * err;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  pictcheckcentre(cpictbox,cfile,&upd.pd);
/*  dprintf(3,"cfile=%x",cfile); */

  err=pictupdatecontents(cpictbox,cpictsection,cfile,&upd);
  if(code==DBAPPLY) dbwritevalues(&picturebox);
 }

 return(err);
}




os_error * writepixpc(int value,char * string)
{
// cprintf("inscale %x",value);
 strcpy(string,numbertostringxdp(value,2,2));
//cprintf("outstring %s",string);
 return(NULL);
}



int pixcutscale(int scale)
{
 return(SGN(scale)*CUT(ABS(scale),PIXMINSCALE,PIXMAXSCALE));
}


os_error * readpixpc(int * value,char * string)
{
 os_error * err;
 int        scale;

 err=stringtonumberxdp(string,&scale,2,2);

 *value=pixcutscale(scale);

 return(err);
}



static os_error * outu(int value,char * string)
{
 strcpy(string,unitstostring(value,cview->data.units));
 return(NULL);
}


static os_error * inu(int * value,char * string)
{
 return(stringtounits(string,value,cview->data.units));
}



static int pxsu(int u,int step)
{
 return(pixsnap(cview,u));
 USE(step);
}





static os_error * clickhide(int handle,int userhandle,wimp_mousestr * m)
{

 upd.pd.hbits&=~HBVISIBLE;
 return(dbchangevalue(&upd.pd.hbits,&picturebox));
 USE(handle);
 USE(userhandle);
 USE(m);
}



static os_error * clickvisible(int handle,int userhandle,wimp_mousestr * m)
{

 upd.pd.hbits&=~HBHIDE;
 return(dbchangevalue(&upd.pd.hbits,&picturebox));
 USE(handle);
 USE(userhandle);
 USE(m);
}





static dbiconstr pictureicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* assume these are here */

   18, &upd.pd.xshift,   DBINC,0,   0,       1,   -1, MAXINT,MININT,NULL,
                                                              (dbwritefn)pxsu,
   17, &upd.pd.xshift,   DBDEC,0,   0,       1,   -1, MAXINT,MININT,NULL,
                                                              (dbwritefn)pxsu,

   22, &upd.pd.yshift,   DBINC,0,   0,       1,   -1, MAXINT,MININT,NULL,
                                                              (dbwritefn)pxsu,
   21, &upd.pd.yshift,   DBDEC,0,   0,       1,   -1, MAXINT,MININT,NULL,
                                                              (dbwritefn)pxsu,


   29, &upd.pd.scale,DBWRITE,  0,   DBASSOCINC,      -1, -1, 6, -1,readpixpc,writepixpc,
    6, &upd.pd.aspect,DBWRITE, 0,   DBASSOCINC,      -1, -1,11,  1,readpixpc,writepixpc,
   11, &upd.pd.angle,DBWRITE,  0,   DBASSOCINC,      -1, -1,16,  6,readangle,writeangle,
   33, &upd.pd.skew, DBWRITE,  0,   DBASSOCINC,      -1, -1,16,  6,readskew, writeskew,
   16, &upd.pd.xshift,DBWRITE, 0,   DBASSOCINC,      -1, -1,20, 11,    inu,  outu,
   20, &upd.pd.yshift,DBWRITE, 0,   DBASSOCINC,      -1, -1,-1, 16,    inu,  outu,


 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN, 0,0,    NULL, 0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE, 0,0,NULL, 0,
   46, NULL,         DBACTION, 0,   0,      DBAPPLY,-1, 0,0,NULL, 0,

 /* N   &V           Type     Grp   Flags   Step Key  max  min clickfn 0 */

    4, &upd.pd.scale,DBINC   ,0,    0,       (0x10000/100), -1, 
                           (10*0x10000),(0x10000/100),NULL,(dbwritefn)pixsnaps,

    3, &upd.pd.scale,DBDEC   ,0,    0,       (0x10000/100), -1, 
                           (10*0x10000),(0x10000/100),NULL,(dbwritefn)pixsnaps,

    9, &upd.pd.aspect,DBINC   ,0,    0,       (0x10000/100), -1,
                           (10*0x10000),(0x10000/100),NULL,(dbwritefn)pixsnaps,

    8, &upd.pd.aspect,DBDEC   ,0,    0,       (0x10000/100), -1,
                           (10*0x10000),(0x10000/100),NULL,(dbwritefn)pixsnaps,

   13, &upd.pd.angle, DBDEC   ,0,    0,       -0x10000,-1,MAXANGLE,
                                            MINANGLE,NULL,(dbwritefn)snapangle,

   14, &upd.pd.angle, DBINC   ,0,    0,       -0x10000,-1,MAXANGLE,
                                            MINANGLE,NULL,(dbwritefn)snapangle,

   36, &upd.pd.skew,  DBINC   ,0,    0,       -0x10000,-1,MAXSKEW,
                                            MINSKEW,NULL,(dbwritefn)snapangle,
   35, &upd.pd.skew,  DBDEC   ,0,    0,       -0x10000,-1,MAXSKEW,
                                            MINSKEW,NULL,(dbwritefn)snapangle,


 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

   23, &upd.pd.lockmode, DBRADIO,  0,   0,      0, F4,  0, 0,     NULL,   0,
   24, &upd.pd.lockmode, DBRADIO,  0,   0,      1, F4,  0, 0,     NULL,   0,
   25, &upd.pd.lockmode, DBRADIO,  0,   0,      2, F4,  0, 0,     NULL,   0,

   26, &upd.pd.fixaspect,DBTOGGLE, 0,   0,      1, F4,  0, 0,     NULL,   0,
   27, &upd.pd.autoscale,DBTOGGLE, 0,   0,      1, F4,  0, 0,     NULL,   0,

   28, &upd.pd.hbits,    DBTOGGLE, 0,   0, HBHIDE, F4,  0, 0,(dbreadfn)clickhide,   0,
   38, &upd.pd.hbits,    DBTOGGLE, 0,   0, HBBOTLEFT,F4,0, 0,NULL,0,
			47, &upd.pd.hbits,    DBTOGGLE, 0,   0, HBVISIBLE,F4,0, 0,(dbreadfn)clickvisible,0,

   40, &upd.tile,        DBTOGGLE, 0,   0,      1, F4,  0, 0,     NULL,   0,
   41, &upd.tiledx,      DBWRITE,  0,   0,     -1, -1,20, 11,    inu,  outu,
   42, &upd.tiledy,      DBWRITE,  0,   0,     -1, -1,20, 11,    inu,  outu,


   -1, NULL,         0,       0,   0,   0,  0,  0,  0,  0,      0

};



static dboxstr picturebox=
{
 0,
 TPICTURE,
 DBFIX,
 0,
 pictureclose,
 pictureicon,
 NULL,
 NULL,
 pictureicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};




os_error * openpicturebox1(int pict,int section,filestr * file,viewstr * view)
{
 os_error      * err;
 pictboxstr    * pictp;
 int             i;
 int             step;

/* dprintf(3,"cfile=%x",file); */

 cview=view;
 cfile=file;

 cpictbox=pict;
 cpictsection=section;

 step=pxunitstep(cview);
 for(i=0;i<4;i++) pictureicondefs[i].data.stepbutton.step=step;

 pictp=(pictboxstr*)fob_find(pict,file);

 cpicture=pictp->picture;

 unpackpicturedata(&upd,pictp);
 // cprintf("scale %x",upd.pd.scale);

 err=dodboxspparent(&picturebox,1,&picturebox,&dbviewstack,cview->handle);

 return(err);
}



/* script function opens the picture dialogue box */

void openpicturebox(int fp)
{
 os_error      * err;

 if(nselected(&cpictbox,menufile))
 {


  err=openpicturebox1(cpictbox,selsectk,menufile,menuview);
  zreport(err);
 }

 USE(fp);
}

