/*->c.splib */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"



#include "etc.h"
#include "colour.h"
#include "xmath.h"
#include "sprx.h"
#include "sp.h"
#include "err.h"
#include "deb.h"


#include "splib.h"



#ifdef NEVER

static os_error * flushcache(void)
{
 return(NULL);
/* os_regset rx;
 return(os_swix(ColourTrans_InvalidateCache,&rx));*/
}


#endif


/* optimisations - create new format sprites with 1bpp masks   */
/*                 don't create full mask for new mode sprites */


static void fillsprite(newsprite_header * shdr,newspstr * xnew)
{
 if(xnew->maskfill>=0) /* zero mask */
 {
  memset(((char*)shdr)+shdr->mask,xnew->maskfill,xnew->masksize);
  memset(((char*)shdr)+xnew->imagesize+xnew->masksize,
                                 xnew->maskfill,xnew->masksize2);
 }

 if(xnew->fill>=0) memset(((char*)shdr)+shdr->image,xnew->fill,xnew->imagesize);
}






static char dpitab[]={0,180,90,60,45,22};

static os_error * createsprites(newsprite_header ** spa,newspstr * xnew,
                                                 int xpix,int ypix,int mem)
{
 os_error      * err;
 int             spritelen;
 newsprite_header * shdr;
 int             palentries;
 int             paltab[256];
 int             bytewidth;
 int             imagesize;
 int             masksize;
 int             masksize2;
 int             palsize;
 int           * pal;
 int             i;


 err=NULL;

 if(xnew->spbpp>8) xnew->palette=0;

 xnew->ln2bpp=ln2(xnew->spbpp);

 if(xnew->palette==2) gengreypal(xnew->ln2bpp,&palentries,paltab);
 else
 if(xnew->palette==1) genpalette(xnew->ln2bpp,&palentries,paltab);
 else                 palentries=0;


// cprintf("palentries %d",palentries);

 palsize=2*palentries*sizeof(int);

 bytewidth=((xpix*xnew->spbpp+31) & (~31))>>3;

 spritelen=sizeof(sprite_header)+palsize;
 imagesize=bytewidth*ypix;

 spritelen+=imagesize;

 if(xnew->mask & 0x1) 
 {
  if(/*ISOS35 &&*/ !xnew->palette) 
  {
   masksize=((xpix+31)/32)*4*ypix;
   xnew->mbpp=1;
  }
  else
  {
   masksize=bytewidth*ypix;
   xnew->mbpp=xnew->spbpp;
  }
 }
 else masksize=0;

 if(xnew->mask & 0x2) masksize2=((xpix+31)/32)*4*ypix;
 else                 masksize2=0;

 xnew->masksize=masksize;
 xnew->masksize2=masksize2;
 xnew->imagesize=imagesize;

 spritelen+=masksize+masksize2;



 if(!mem)
 {
  if(!*spa) err=flex_alloc((flex_ptr)spa,spritelen);
  else      err=flex_extend((flex_ptr)spa,spritelen);
 }

/* dprintf(0,"spritelen=%d *spa=%x",spritelen,*spa); */

 if(!err)
 {
  shdr=*spa;
  pal=(int*)(((char*)shdr)+sizeof(sprite_header));

  shdr->next=spritelen;

  memset(shdr->name,0,12);
  strcpy(shdr->name,"xxxxx");

  shdr->width=(bytewidth/4)-1;
  shdr->height=ypix-1;
  shdr->lbit=0;
  shdr->rbit=(xpix*xnew->spbpp-1) & 31; 

  shdr->image=sizeof(sprite_header)+palsize;

  if(xnew->mask) shdr->mask=shdr->image+imagesize;
  else          shdr->mask=shdr->image;

  if(/*ISOS35 &&*/ !xnew->palette)
  {
   ((newsprite_header*)shdr)->selector.type.xdpi=dpitab[xnew->dx];
   ((newsprite_header*)shdr)->selector.type.ydpi=dpitab[xnew->dy];
   ((newsprite_header*)shdr)->selector.type.newtype=1;
   ((newsprite_header*)shdr)->selector.type.type=xnew->ln2bpp+1;
   ((newsprite_header*)shdr)->selector.type.alpha=0;
  }
  else
  {
   shdr->selector.mode.mode=xnew->mode;
  }

  for(i=0;i<palentries;i++)
  {
   pal[i*2]=pal[i*2+1]=paltab[i];
  }
 }
 return(err);
}



os_error * createsprite(newsprite_header ** spa,newspstr * xnew,
                                                          int xpix,int ypix)
{
 os_error * err;
 err=createsprites(spa,xnew,xpix,ypix,0);
 if(!err)  fillsprite(*spa,xnew);
 return(err);
}


os_error * createspritem(newsprite_header * spa,newspstr * xnew,
                                                          int xpix,int ypix)
{
 os_error * err;
 err=createsprites(&spa,xnew,xpix,ypix,1);
 if(!err)  fillsprite(spa,xnew);
 return(err);
}






int spritesize(newspstr *xnew,int xpix,int ypix)
{
 int spritelen;
 int maskwidth;
 int maskwidth2;
 int bytewidth;

 spritelen=sizeof(sprite_header);

 if(xnew->spbpp<=8 && xnew->palette)
 {
  if(xnew->palette==2) spritelen+=2*(1<<(xnew->spbpp))*sizeof(int);
  else                 spritelen+=2*palentriestab[ln2(xnew->spbpp)]*sizeof(int);
 }

 bytewidth=((xpix*xnew->spbpp+31) & (~31))>>3;

 if(xnew->mask) 
 {
  if(/*ISOS35 &&*/ !xnew->palette) maskwidth=((xpix+31)/32)*4;
  else                         maskwidth=bytewidth;
 }
 else                          maskwidth=0;

 if(xnew->mask & 0x2)          maskwidth2=((xpix+31)/32)*4;
 else                          maskwidth2=0;

 return(spritelen+ypix*(maskwidth+maskwidth2+bytewidth));
}



/* given memory, see how big a sprite we can make */
/* keeps fixed width, and calculates height       */

os_error * checksprite(int memory,newspstr *xnew,int * sxpix,int * sypix)
{
 os_error * err;
 int xpix;
 int ypix;
 int maskwidth;
 int maskwidth2;
 int bytewidth;
 int spritelen;
 int temp;


 err=NULL;

 xpix=*sxpix;
 ypix=*sypix;

 spritelen=sizeof(sprite_header);

 if(xnew->spbpp<=8 && xnew->palette)
 {
  if(xnew->palette==2) spritelen+=2*(1<<(xnew->spbpp))*sizeof(int);
  else                 spritelen+=2*palentriestab[ln2(xnew->spbpp)]*sizeof(int);
 }

 bytewidth=((xpix*xnew->spbpp+31) & (~31))>>3;

 if(xnew->mask) 
 {
  if(/*ISOS35 &&*/ !xnew->palette) maskwidth=((xpix+31)/32)*4;
  else                             maskwidth=bytewidth;
 }
 else                              maskwidth=0;

 if(xnew->mask & 0x2)              maskwidth2=((xpix+31)/32)*4;
 else                              maskwidth2=0;

 memory-=spritelen;

 temp=memory/(bytewidth+maskwidth+maskwidth2);
 if(temp<ypix) ypix=temp;

 if(ypix<=0) err=geterror(EMEM);

/* dprintf(0,"xpix=%d ypix=%d sx=%d yp=%d",xpix,ypix,*sxpix,*sypix); */

 *sxpix=xpix;
 *sypix=ypix;

 return(err);
}



/*****************************************************************************/

static splibstr  sp;



splibstr * sp_getsp(void)
{
 return(&sp);
}




os_error * sp_switch(int mask,newsprite_header * spa)
{
 os_error * err;

 err=NULL;
#ifdef NEVER
 saverx.r[0]=(mask?61:60)|512;
 saverx.r[1]=(int)spa;
 saverx.r[2]=(int)spa;
 saverx.r[3]=0;

// err=os_swix(OS_SpriteOp,&saverx);  /* output to sprite/mask */
 if(!err)
 {
  flushcache();
  vdumodevars();
 }

#endif
 return(err);
}



os_error * sp_switchtoscreen(vdustr * vdu)
{
 os_error * err;

 err=NULL;

#ifdef NEVER

// err=os_swix(OS_SpriteOp,&saverx);

 flushcache();

 if(vdu) cvdu=*vdu;
 else    vdumodevars();
#endif

 return(err);
}




/* going to send stuff to mask */

os_error * sp_rendermask(void)
{
 os_error * err;

 err=sp_switch(1,sp.spa);         /* switch to mask */
/* bbc_origin(-sbox.x0,-sbox.y0); */

 return(err);
}



/* going to send stuff to sprite */

os_error * sp_rendersprite(vdustr * vdu)
{
 os_error * err;

 err=NULL;

 if(!(sp.sflags & SP_NOMASK)) err=sp_switchtoscreen(vdu);

 sp_switch(0,sp.spa);             /* switch to sprite */

/* bbc_origin(-sbox.x0,-sbox.y0); */

 return(err);
}


os_error * sp_fill(void)
{
/* return(bbc_rectanglefill(sbox.x0,sbox.y0,sbox.x1-sbox.x0,sbox.y1-sbox.y0));
 */
 return(bbc_rectanglefill(0,0,sp.sbox.x1-sp.sbox.x0,sp.sbox.y1-sp.sbox.y0));
}



/* paint strip to screen */

os_error * sp_renderpaint(vdustr * vdu)
{
 os_error * err;
 sprite_id  id;
 int        area[8];
 int        left;
 int        right;
 int        top;
 int        bot;
// char       pixtrans[1024];


 err=sp_switchtoscreen(vdu);

 id.tag=sprite_id_addr;
 id.s.addr=sp.spa;


 if(sp.sflags & SP_SCALE)
 {
  left=sp.sxposp;
  right=left+sp.sxosp;
  bot=sp.syposp;
  top=bot+sp.syosp;

 /* dprintf(0,"top=%d bot=%d",top/256,bot/256); */

  if(sp.sflags & SP_INV56) SWOP(top,bot);

  area[0]=left;
  area[1]=top;

  area[2]=right;
  area[3]=top;

  area[4]=right;
  area[5]=bot;

  area[6]=left;
  area[7]=bot;
 }


 if(!sp.newsp.palette)
 {
  if(sp.sflags & SP_SCALE)
  {

#ifdef NEVER   
   err=selecttable(sp.spa->mode,    /* srce mode = sprite mode        */
                           0,       /* srce pal  = sprite/default pal */
                          -1,       /* dest mode = current mode       */
                    (int*)-1,       /* dest pal  = current pal        */
                    pixtrans
                   );
#endif

   err=sprite_put_trans((sprite_area *)0xFF,&id,8|(1<<8),
                       (sprite_transform*)area,NULL/*(sprite_pixtrans*)pixtrans*/);
  }
  else
  {
   err=sprite_put_given((sprite_area*)0xFF,&id,8,sp.sxpos,sp.sypos);
  }
 }
 else
 {
//  err=selectsptable(sp.spa,pixtrans,(sp.sflags & SP_WIDE)?1024:256);

  if(sp.sflags & SP_SCALE)
  {
   err=sprite_put_trans((sprite_area *)0xFF,&id,
                        8|(1<<8)|((sp.sflags & SP_WIDE)?(1<<5):0),
                        (sprite_transform*)area,NULL/*(sprite_pixtrans*)pixtrans*/);
  }
  else
  {
   err=sprite_put_scaled((sprite_area*)0xFF,&id,
                          8|((sp.sflags & SP_WIDE)?(1<<5):0),
                          sp.sxpos,sp.sypos,NULL,NULL /*(sprite_pixtrans*)pixtrans*/);
  }
 }

 return(err);
}




/* finished rendering, throw away any memory etc. */

os_error * sp_renderend(void)
{
 os_error * err;

 if(sp.spa) err=flex_free((flex_ptr)&sp.spa);
 else       err=NULL;

 return(err);
}




/* pass back the area we want painting */

// return 1 if there is more stuff
// return 0 finished

int sp_rendergetbox(wimp_box * box)
{

 sp.sxpos+=sp.sxos;
 sp.sxposp+=sp.sxosp;
 if(sp.sxpos>=sp.sbox.x1)
 {
  sp.sxpos=sp.sbox.x0;
  sp.sxposp=256*sp.sxpos;
  sp.sypos+=sp.syos;
  sp.syposp+=sp.syosp;
  if(sp.sypos>=sp.sbox.y1)
  {
  /* dprintf(0,"getx2"); */
   return(0);
  }
 }



 box->x0=sp.sxpos;
 box->y0=sp.sypos;
 box->x1=box->x0+sp.sxos;
 box->y1=box->y0+sp.syos;

 fillsprite(sp.spa,&sp.newsp);     /* resetting mask */




#ifdef NEVER
 
 char     * screen;
 char     * sprite;
 int        linesize;
 int        spritesize;
 int        xshift;
 int        i;
 int        ypix;
 int        scrpix;


/* dprintf(0,"render get sx=%d sxos=%d",sp.sxpos,sp.sxos); */



/* dprintf(0,"render get sx=%d sxos=%d",sp.sxpos,sp.sxos); */


 box->x0=sp.sxpos;
 box->y0=sp.sypos;
 box->x1=box->x0+sp.sxos;
 box->y1=box->y0+sp.syos;

 fillsprite(sp.spa,&sp.newsp);     /* resetting mask */

 if(sp.sflags & SP_BACKFILL)
 {
/*  dprintf(0,"back fill"); */

  screen=(char*)bbc_vduvar(bbc_ScreenStart);
  linesize=bbc_modevar(-1,bbc_LineLength);

  scrpix=(cvdu.screeny-box->y0)/sp.sdy;
  if(scrpix>=sp.sypix) ypix=sp.sypix;
  else                 ypix=scrpix;

/*
  dprintf(0,"screen=%x linesize=%d srcpix=%d ypix=%d",
             screen,linesize,scrpix,ypix);

dprintf(0,"spdx=%d spdy=%d dx=%d dy=%d",sp.sdx,sp.sdy,cvdu.deltax,cvdu.deltay);

*/


  screen=screen+linesize*(scrpix-ypix);
  sprite=((char*)sp.spa)+sp.spa->image;
  spritesize=(sp.spa->width+1)*4;
  xshift=((box->x0/sp.sdx)*sp.sbpp)/8;

/*
  dprintf(0,"sprite=%x image=%d",sprite,sp.spa->image);

  dprintf(0,"screen=%x spsz=%d xs=%d",screen,spritesize,xshift);
*/


  for(i=0;i<ypix;i++)
  {
/*   dprintf(0,"screen=%x sprite=%x i=%d",screen+xshift,sprite,i);  */
   XMEMCPYX(sprite,screen+xshift,spritesize);
   screen+=linesize;
   sprite+=spritesize;
  }
 }

/* dprintf(0,"getx"); */
#endif


 return(1);
}



/* pass 0 - zero sprite to 0                             */
/* pass 1 - diff bits to mask2, zero sprite to 0xFF      */
/* pass 2 - diff bits or to mask2, and mask2 to mask */


os_error * sp_pass(int pass)
{
 int   x;
 int   y;
 int * sdata;
 int * mdata;
 int * sdata2;
 int * mdata2;
 int   mask;
 int   width;
 int   c;
 int   w;
 int   shift;
 int   m;
 int   mshift;
 int   mwidth;


 if(sp.sflags & SP_DFILL)
 {
  if(sp.sbpp==1) mask=0x1;
  else
  if(sp.sbpp==2) mask=0x3;
  else
  if(sp.sbpp==4) mask=0xF;
  else
  if(sp.sbpp==8) mask=0xFF;
  else           mask=0xFFFF;


  if(pass==0)
  {
   memset(((char*)sp.spa)+sp.spa->image,0,sp.newsp.imagesize);
  }
  else
  if(pass==1)
  {
   sdata2=(int*)(((char*)sp.spa)+sp.spa->image);
   width=((sp.sxpix*sp.sbpp+31) & (~31))>>3;
   mdata2=(int*)(((char*)sp.spa)+sp.spa->mask+sp.newsp.masksize);
   mwidth=((sp.sxpix+31) & (~31))>>3;

   for(y=0;y<sp.sypix;y++)
   {
    sdata=sdata2;
    mdata=mdata2;

    switch(sp.sbpp)
    {
     case  1:
     case  2:
     case  4:
     case  8:
     case 16:
             w=*sdata++;
             shift=0;
             mshift=m=0;
                                          /* clear 32-shift bits */
             for(x=0;x<sp.sxpix;x++)
             {
              c=(w>>shift)&mask;

              if(c!=0) m|=1<<mshift;

              mshift++;
              if(mshift>=32)
              {
               *mdata++=m;
               mshift=m=0;
              }

              shift+=sp.sbpp;
              if(shift>=32)
              {
               w=*sdata++;
               shift=0;
              }
             }

             if(mshift) *mdata++=m;

             break;


     case 32:
             mshift=m=0;
             for(x=0;x<sp.sxpix;x++)
             {
              c=*sdata++;

              if(c!=0) m|=1<<mshift;

              mshift++;
              if(mshift>=32)
              {
               *mdata++=m;
               mshift=m=0;
              }
             }

             if(mshift) *mdata++=m;

             break;
    }

    sdata2=(int*)((char*)sdata2+width);
    mdata2=(int*)((char*)mdata2+mwidth);
   }

   memset(((char*)sp.spa)+sp.spa->image,0xFF,sp.newsp.imagesize);
  }
  else
  if(pass==2)
  {
   sdata2=(int*)(((char*)sp.spa)+sp.spa->image);
   width=((sp.sxpix*sp.sbpp+31) & (~31))>>3;
   mdata2=(int*)(((char*)sp.spa)+sp.spa->mask+sp.newsp.masksize);
   mwidth=((sp.sxpix+31) & (~31))>>3;

   for(y=0;y<sp.sypix;y++)
   {
    sdata=sdata2;
    mdata=mdata2;

    switch(sp.sbpp)
    {
     case  1:
     case  2:
     case  4:
     case  8:
     case 16:
             w=*sdata++;
             shift=0;
             mshift=0;
             m=*mdata;
                                          /* clear 32-shift bits */
             for(x=0;x<sp.sxpix;x++)
             {
              c=(w>>shift)&mask;

              if(c!=mask) m|=1<<mshift;

              mshift++;
              if(mshift>=32)
              {
               *mdata++=m;
               mshift=0;
               m=*mdata;
              }

              shift+=sp.sbpp;
              if(shift>=32)
              {
               w=*sdata++;
               shift=0;
              }
             }

             if(mshift) *mdata++=m;

             break;


     case 32:
             mshift=0;
             m=*mdata;
             for(x=0;x<sp.sxpix;x++)
             {
              c=*sdata++;

              if(c!=0xFFFFFFFF) m|=1<<mshift;

              mshift++;
              if(mshift>=32)
              {
               *mdata++=m;
               mshift=0;
               m=*mdata;
              }
             }

             if(mshift) *mdata++=m;

             break;
    }

    sdata2=(int*)((char*)sdata2+width);
    mdata2=(int*)((char*)mdata2+mwidth);
   }


   sdata2=(int*)(((char*)sp.spa)+sp.spa->mask);
   width=((sp.sxpix*sp.newsp.mbpp+31) & (~31))>>3;
   mdata2=(int*)(((char*)sp.spa)+sp.spa->mask+sp.newsp.masksize);
   mwidth=((sp.sxpix+31) & (~31))>>3;



   if(sp.newsp.mbpp==1) mask=0x1;
   else
   if(sp.newsp.mbpp==2) mask=0x3;
   else
   if(sp.newsp.mbpp==4) mask=0xF;
   else
   if(sp.newsp.mbpp==8) mask=0xFF;
   else                 mask=0xFFFF;

   for(y=0;y<sp.sypix;y++)
   {
    sdata=sdata2;
    mdata=mdata2;

    w=*sdata;
    shift=0;
    mshift=0;
    m=*mdata++;
                                          /* clear 32-shift bits */
    for(x=0;x<sp.sxpix;x++)
    {
     c=(w>>shift)&mask;

     if(c && !(m & (1<<mshift))) w^=(mask<<shift);
                 
     mshift++;
     if(mshift>=32)
     {
      mshift=0;
      m=*mdata++;
     }

     shift+=sp.newsp.mbpp;
     if(shift>=32)
     {
      *sdata++=w;
      w=*sdata;
      shift=0;
     }
    }

    if(shift) *sdata++=w;

    sdata2=(int*)((char*)sdata2+width);
    mdata2=(int*)((char*)mdata2+mwidth);
   }
  }
 }
 return(NULL);
}



/* input the area in OS units to render */

os_error * sp_renderstart(wimp_box * box,int flags,int memory,int xdpi,int ydpi,
                          int bpp,int xscale,int yscale)
{
 os_error * err;
 int        ospw;


 sp.sbox=*box;
 sp.sflags=flags;
 sp.sxdpi=xdpi;
 sp.sydpi=ydpi;
 sp.sxscale=xscale;
 sp.syscale=yscale;
 sp.sbpp=bpp;


// cprintf("bpp %x",bpp);

 if(xscale!=0x10000 || yscale!=0x10000) sp.sflags|=SP_SCALE;


 sp.newsp.dx=2;
 sp.newsp.dy=2;
 sp.newsp.spbpp=sp.sbpp;

 if(flags & SP_NOMASK)
 {
  sp.newsp.mask=0;
  sp.newsp.maskfill=-1;
 }
 else
 {
  sp.newsp.mask=1;
  sp.newsp.maskfill=0;
 }

 if(flags & SP_DFILL) sp.newsp.mask|=2;

 if(flags & SP_PALETTE)
 {
  if(flags & SP_GREY) sp.newsp.palette=2;
  else                sp.newsp.palette=1;
 }
 else
 {
  sp.newsp.palette=0;
 }

 sp.newsp.mode=sp.smode=makemode(sp.sbpp,sp.newsp.dx,sp.newsp.dy);
 sp.newsp.fill=-1;


 /* logic here is to make sure sprite is >1 word wide and >1 row high */
 /* seems does not render if not                                      */
 /* in addition put sprite on word boundaries                         */

 ospw=((32/sp.sbpp)*180)/sp.sxdpi;
	if(ospw<=0) ospw=1;

 sp.sbox.x0=(sp.sbox.x0/ospw)*ospw;
 sp.sbox.x1=((sp.sbox.x1+ospw-1)/ospw)*ospw;

 sp.sxpix=(sp.sbox.x1-sp.sbox.x0);          // os units
 if(sp.sxpix<=ospw) sp.sxpix=ospw+180/sp.sxdpi;
 sp.sxpix=(sp.sxpix*sp.sxdpi)/180;          // pixels

 sp.sypix=((sp.sbox.y1-sp.sbox.y0)*sp.sydpi)/180+2;

// cprintf("xpix %d ypix %d",sp.sxpix,sp.sypix);

 checksprite(memory,&sp.newsp,&sp.sxpix,&sp.sypix);
 if(sp.sypix<=1) sp.sypix=2;

 err=createsprites(&sp.spa,&sp.newsp,sp.sxpix,sp.sypix,0);
 if(!err)
 {
  sp.sxos=(sp.sxpix*180)/sp.sxdpi;
  sp.sxosp=scale(256*sp.sxos,0x10000,sp.sxscale);

  sp.syos=(sp.sypix*180)/sp.sydpi;
  sp.syosp=scale(256*sp.syos,0x10000,sp.syscale);

  sp.sxpos=sp.sbox.x0-sp.sxos;
  sp.sypos=sp.sbox.y0;
  sp.sxposp=256*sp.sbox.x0-sp.sxosp;
  sp.syposp=256*sp.sbox.y0;
 }

 return(err);
}




