/*->c.prjob */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "flex.h"
#include "transform.h"
#include "xprocess.h"
#include "osunits.h"

#include "wos.h"

#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "colour.h"
#include "xmath.h"
#include "drag.h"
#include "conf.h"
#include "redraw.h"
#include "etc.h"
#include "bits.h"
#include "hourglass.h"
#include "dbhi.h"
#include "fsx.h"
#include "bf.h"
#include "save.h"
#include "csv.h"
#include "osprint.h"
#include "timex.h"
#include "deb.h"
#include "imlib.h"
#include "filetype.h"

#include "str.h"
#include "constants.h"
#include "main.h"
#include "object.h"
#include "reslink.h"

#include "geometry.h"
#include "xredraw.h"

#include "view.h"
#include "viewr.h"
#include "file.h"
#include "page.h"

#include "merge.h"
#include "xxcolour.h"
#include "colsep.h"


#include "prstr.h"
#include "xprint.h"
#include "prstat.h"
#include "pract.h"
#include "preg.h"
#include "postscript.h"


#include "prjob.h"


static prjobstr prjob;


#define PCHUNK 16





/*****************************************************************************/

static int printcancelled;

static int psrecord;



/* worry if this lot should signal that select job has failed */

static os_error * goprinter(void)
{
 os_error * err;


 err=NULL;

 event(EVENT_PRGOPRINTER0,prjob.view,(int)&prjob);

 hourglasson();
 printhg=1;

 osgoprinter();

 event(EVENT_PRGOPRINTER1,prjob.view,(int)&prjob);


 return(err);
}



static os_error * gonormal(void)
{
 os_error * err;


 err=NULL;

 event(EVENT_PRGONORMAL0,prjob.view,(int)&prjob);

 osgonormal();
 hourglassoff();
 printhg=0;


 event(EVENT_PRGONORMAL1,prjob.view,(int)&prjob);


 return(err);
}







static void prinvertgbox(wimp_redrawstr * r,transformstr * tr)
{
	r->g.x0*=400;
	r->g.x1*=400;
	r->g.y0*=400;
	r->g.y1*=400;


 getmaxinvabox((aboxstr*)&r->g,(aboxstr*)&r->g,tr);

	r->g.x0/=400;
	r->g.x1/=400;
	r->g.y0/=400;
	r->g.y1/=400;
}



static void prinvertgbox2(wimp_redrawstr * r,transformstr * tr)
{

 getmaxinvabox((aboxstr*)&r->g,(aboxstr*)&r->g,tr);

}







// tr  is the transform from page space to the current space
// ctr	is the transform this code needs to apply


static os_error * rendermarks(viewstr * view,wimp_redrawstr * r,aboxstr * cbox,
                                     transformstr * tr,transformstr * ctr,int marks,int doevent)
{
 os_error       * err;
 viewredrawstr    v;
 int              oldthickness;
 transformbitstr  bits;
 int              xscale;
 aboxstr          maxbox;
 int              xs;
 int              ys;
 wimp_redrawstr   rs;


 err=NULL;

	rs=*r;
 xs=ys=0;

 initviewredraw(&v);

 if(!tr_isidentity(ctr))
 {
 	if((prjob.bits & PSDIRECT))
		{
   // never expect to get here
		}
  else
  {
   int           dx;
   int           dy;
   coordstr      sc;
   transformstr  tra;
   transformstr  trb;
   transformstr  trc;
   transformstr  ttr;

   dx=ourunits(rs.box.x0-rs.g.x0,view);
   dy=ourunits(rs.box.y0-rs.g.y1,view);

   tr_setshift(&trb,-dx,-dy);
   tr_setshift(&trc,dx,dy);
   tr_multiply(&ttr,ctr,&trc);
   tr_multiply(&tra,&trb,&ttr);


   sc.x=tra.e;
   sc.y=tra.f;
   v.tr=tra;
   v.tr.e=v.tr.f=0;
   tr_inverseset(&sc,1,&v.tr);
   xs=sc.x;
   ys=sc.y;

   prinvertgbox2(&rs,&v.tr);
  }
 }



 /* fiddle to keep regmark thickness constant */

 tr_getbits(tr,&bits);
 oldthickness=regthickness;
 xscale=MIN(bits.xscale,bits.yscale);
 regthickness=scale(regthickness,0x10000,xscale);

 praddmarks(&maxbox,cbox,marks);



 v.view=view;
 v.file=view->file;

	v.isprinter=(prjob.prtype==PRPS)?ISPSPRINTER:ISPRINTERNORM;
 v.prjob=&prjob;
 v.layer=VRBACK;

 v.xps=cbox->x0-maxbox.x0;
 v.yps=(cbox->y1-maxbox.y1);

 v.xpo=0;
 v.ypo=0;

 v.xpe=maxbox.x1-cbox->x0; 
 v.ype=(cbox->y1-maxbox.y0);

 v.ox=rs.box.x0-rs.scx;
 v.oy=rs.box.y0-rs.scy;

 v.ox+=osunits(cbox->x0+xs,view); // was bosunits
 v.oy+=osunits(cbox->y1+ys,view);

 v.redrawstr.g=rs.g;

 v.ylox=-(v.redrawstr.g.y1-v.oy);
 v.yhix=-(v.redrawstr.g.y0-v.oy);
 v.xlox=v.redrawstr.g.x0-v.ox;
 v.xhix=v.redrawstr.g.x1-v.ox;

 v.yloz=ourunits(v.ylox,view);  // was bourunits
 v.yhiz=ourunits(v.yhix,view);
 v.xloz=ourunits(v.xlox,view);
 v.xhiz=ourunits(v.xhix,view);

 v.xhi=v.xpe;
 v.xlo=v.xps;

 if(v.xhi>v.xhiz) v.xhi=v.xhiz;
 if(v.xlo<v.xloz) v.xlo=v.xloz;

 v.xlos=v.xlo-v.xpo;
 v.xhis=v.xhi-v.xpo;

 v.yhi=v.ype;
 v.ylo=v.yps;

 if(v.yhi>v.yhiz) v.yhi=v.yhiz;
 if(v.ylo<v.yloz) v.ylo=v.yloz;

 v.ylos=v.ylo-v.ypo;
 v.yhis=v.yhi-v.ypo;

 if(!(v.xps>v.xhiz || v.xpe<v.xloz || v.yps>v.yhiz || v.ype<v.yloz))
 {
  pregmarks(&v,(cbox->x1-cbox->x0),(cbox->y1-cbox->y0),0,marks);
 }

 regthickness=oldthickness;

 if(doevent) event(EVENT_PRMARKS,view,(int)&v);

 return(err);
}




static os_error * renderpage(viewstr * view,psetstr * ps,wimp_redrawstr * r,transformstr * ctr)
{
 os_error       * err;
 viewredrawstr    v;
 sectionstr     * sectionp;
 pagestr        * page;
 wimp_redrawstr   rs;
 int              xs;
 int              ys;


 err=NULL;

// cprintf("render page ps->page %d",ps->page);

 if(ps->page)
 {
		rs=*r;
  xs=ys=0;

  initviewredraw(&v);

  if(!tr_isidentity(ctr))
  {
 		if((prjob.bits & PSDIRECT))
 		{
    ps_startpagebox(ctr);

    prinvertgbox(&rs,ctr);
 		}
   else
   {
    int           dx;
    int           dy;
    coordstr      sc;
    transformstr  tra;
    transformstr  trb;
    transformstr  trc;
    transformstr  ttr;

    dx=ourunits(rs.box.x0-rs.g.x0,view);
    dy=ourunits(rs.box.y0-rs.g.y1,view);

    tr_setshift(&trb,-dx,-dy);
    tr_setshift(&trc,dx,dy);
    tr_multiply(&ttr,ctr,&trc);
    tr_multiply(&tra,&trb,&ttr);


    sc.x=tra.e;
    sc.y=tra.f;
    v.tr=tra;
    v.tr.e=v.tr.f=0;
    tr_inverseset(&sc,1,&v.tr);
    xs=sc.x;
    ys=sc.y;

    prinvertgbox2(&rs,&v.tr);
   }
  }

  event(EVENT_PRSTARTPAGE,view,(int)&prjob);

  v.view=view;
  v.file=view->file;
  v.page=ps->page;
  v.section=ps->section;
//  v.isprinter=1;

//			cprintf("prjob.prtype %d",prjob.prtype);

		v.isprinter=(prjob.prtype==PRPS)?ISPSPRINTER:ISPRINTERNORM;
  v.prjob=&prjob;
  v.layer=VRBACK;

 /* 

  v.ignore=0;
  v.object=0;
  v.xobject=0;
  v.sobject=0;
  v.szone=0;
  v.onelayer=0;

 */

  sectionp=(sectionstr*)fob_find(v.section,v.file);

  v.xpo=0;
  v.ypo=0;

  v.xps=ps->abox.x0-ps->xpo;
  v.yps=-(ps->abox.y1-ps->ypo);
 
  v.xpe=ps->abox.x1-ps->xpo; 
  v.ype=-(ps->abox.y0-ps->ypo);

//		cprintf("prjob x0 %d	x1 %d y0 %d y1 %d",r->box.x0,r->box.x1,r->box.y0,r->box.y1);

		//setgcol(0);bbc_move(r->g.x0+8,r->g.y0+8);bbc_draw(r->g.x1-8,r->g.y0+8);
		//bbc_draw(r->g.x1-8,r->g.y1-8);bbc_draw(r->g.x0+8,r->g.y1-8);bbc_draw(r->g.x0+8,r->g.y0+8);

  v.ox=rs.box.x0-rs.scx;
  v.oy=rs.box.y0-rs.scy;

  v.ox+=osunits(ps->xpo+xs,view);     // was bosunits
  v.oy+=osunits(ps->ypo+ys,view);

  v.redrawstr.g=rs.g;

  v.ylox=-(v.redrawstr.g.y1-v.oy);
  v.yhix=-(v.redrawstr.g.y0-v.oy);
  v.xlox=v.redrawstr.g.x0-v.ox;
  v.xhix=v.redrawstr.g.x1-v.ox;

//  cprintf("ox %d oy %d ylox %d yhix %d",v.ox,v.oy,v.ylox,v.yhix);
//  cprintf("gy1 %d voy %d",v.redrawstr.g.y1,v.oy);
//  cprintf("gx1 %d vox %d",v.redrawstr.g.x1,v.ox);

  v.yloz=ourunits(v.ylox,view);  // was bourunits
  v.yhiz=ourunits(v.yhix,view);
  v.xloz=ourunits(v.xlox,view);
  v.xhiz=ourunits(v.xhix,view);

//  cprintf("yloz %d yhiz %d xloz %d xhiz %d",v.yloz,v.yhiz,v.xloz,v.xhiz);

  v.xhi=v.xpe;
  v.xlo=v.xps;


  if(v.xhi>v.xhiz) v.xhi=v.xhiz;
  if(v.xlo<v.xloz) v.xlo=v.xloz;

  v.xlos=v.xlo-v.xpo;
  v.xhis=v.xhi-v.xpo;
  
  v.yhi=v.ype;
  v.ylo=v.yps;

  if(v.yhi>v.yhiz) v.yhi=v.yhiz;
  if(v.ylo<v.yloz) v.ylo=v.yloz;

  v.ylos=v.ylo-v.ypo;
  v.yhis=v.yhi-v.ypo;


//  cprintf("render page 0");

//  cprintf("xps %d xhiz %d xpe %d xloz %d",v.xps,v.xhiz,v.xpe,v.xloz);

  if(!(v.xps>v.xhiz || v.xpe<v.xloz || v.yps>v.yhiz || v.ype<v.yloz))
  {
   startredraw();
   getpageoscoords(&v);
   page=(pagestr*)fob_find(v.page,v.file);
   cprintf("render page 1");
   err=objectredraw(&v,(objhdrstr*)page);
  }

//  cprintf("render page x");

  event(EVENT_PRENDPAGE,view,(int)&prjob);

 /* dprintf(0,"render page x2"); */

		if((prjob.bits & PSDIRECT) && !tr_isidentity(ctr))
		{
			ps_endpagebox();

		}

 }

 return(err);
}



int prworkw(int fp)
{
 return(PRJOBP(prjob,prjob.pn)->abox.x1);
 USE(fp);
}


int prworkh(int fp)
{
 return(PRJOBP(prjob,prjob.pn)->abox.y1);
 USE(fp);
}


int prworkmaxw(int fp)
{
 return(prjob.maxbox.x1);
 USE(fp);
}



int prworkmaxh(int fp)
{
 return(prjob.maxbox.y1);
 USE(fp);
}



int prpagew(int fp)
{
 pagestr * pagep;
 pagep=(pagestr*)fob_find(PRJOBP(prjob,prjob.pn)->pset[prjob.ps].page,prjob.view->file);
 return(pagep->box.w);
 USE(fp);
}



int prpageh(int fp)
{
 pagestr * pagep;
 pagep=(pagestr*)fob_find(PRJOBP(prjob,prjob.pn)->pset[prjob.ps].page,prjob.view->file);
 return(pagep->box.h);
 USE(fp);
}



int prpagex(int fp)
{
 return(PRJOBP(prjob,prjob.pn)->pset[prjob.ps].xpo);
 USE(fp);
}


int prpagey(int fp)
{
 return(PRJOBP(prjob,prjob.pn)->pset[prjob.ps].ypo);
 USE(fp);
}


int prareax0(int fp)
{
 paperstr * p;

 p=PRJOBP(prjob,prjob.pn);
 if(p->pset[prjob.ps].id) return(p->pset[prjob.ps].abox.x0);
 else                     return(p->abox.x0);

 USE(fp);
}



int prareay0(int fp)
{
 paperstr * p;

 p=PRJOBP(prjob,prjob.pn);
 if(p->pset[prjob.ps].id) return(p->pset[prjob.ps].abox.y0);
 else                     return(p->abox.y0);

 USE(fp);
}



int prareax1(int fp)
{
 paperstr * p;

 p=PRJOBP(prjob,prjob.pn);
 if(p->pset[prjob.ps].id) return(p->pset[prjob.ps].abox.x1);
 else                     return(p->abox.x1);

 USE(fp);
}



int prareay1(int fp)
{
 paperstr * p;

 p=PRJOBP(prjob,prjob.pn);
 if(p->pset[prjob.ps].id) return(p->pset[prjob.ps].abox.y1);
 else                     return(p->abox.y1);

 USE(fp);
}





int prpageshiftx(int fp)
{
 return(PRJOBP(prjob,prjob.pn)->tr.e);
 USE(fp);
}


int prpageshifty(int fp)
{
 return(PRJOBP(prjob,prjob.pn)->tr.f);
 USE(fp);
}


/*

		For RISC OS, we give a number of boxes on the page area,
		RISC OS then passes back various boxes for us to render

		For Windows, we get a wimp_redrawstr, the box (window area) in this represents
		the paper. The g box is the printable area (visible area). scx, and scy are
		the shift between them.

		If there is a global transform on the printer the redrawstr has to have the
		inverse transform applied to it.



*/




static os_error * printpage(int copies,int pn,viewstr * view,wimp_redrawstr * r)
{
 os_error       * errpoi=NULL;
 int              totcopies;
 int              curcopy;
 int              i;
 paperstr       * p;
	wimp_redrawstr   rs;
	transformstr     tr;
	transformstr   * trs;

 curcopy=totcopies=copies;

 /* set up page  */



 p=PRJOBP(prjob,pn);


// cprintf("box x0=%d x1=%d y0=%d y1=%d",box[0],box[2],box[1],box[3]);



 event(EVENT_PRSTARTPAPER,view,(int)&prjob);

 tr_getscale(&(PRJOBP(prjob,pn))->tr,&prjob.scale);

 while(copies--)					// copies is for real, could be != 1
 {
		rs=*r;
		tr=(PRJOBP(prjob,pn))->tr;

  event(EVENT_PRCOPIES,view,(int)&prjob);
  event(EVENT_PRCOPIES2,view,(int)&prjob);

  goprinter();
  osprintstartpage();

  if(prjob.bits & PSDIRECT) ps_startpage(&prjob,view,pn,&rs,&tr);


  colseparationprint(&prjob,CSPR_STARTCOPY);

  event(EVENT_PRSTARTCOPY,view,(int)&prjob);

  for(prjob.ps=0;prjob.ps<(PRJOBP(prjob,pn))->n;prjob.ps++)
  {
			if(tr_isidentity(&tr))	trs=&((PRJOBP(prjob,pn))->pset[prjob.ps].trs);
			else																			trs=&((PRJOBP(prjob,pn))->pset[prjob.ps].tr);

   errpoi=renderpage(view,&(PRJOBP(prjob,pn))->pset[prjob.ps],&rs,trs);
   if(errpoi) break;
  }


  if(!errpoi) errpoi=rendermarks(view,&rs,&(PRJOBP(prjob,pn))->cbox,
                                          &(PRJOBP(prjob,pn))->tr,&tr,
                                          (PRJOBP(prjob,pn))->marks,1);

  for(i=0;i<(PRJOBP(prjob,pn))->n;i++)
  {
   if((PRJOBP(prjob,pn))->pset[i].marks)
   {
    errpoi=rendermarks(view,&rs,&(PRJOBP(prjob,pn))->pset[i].cbox,
                              &(PRJOBP(prjob,pn))->tr,&tr,
                              (PRJOBP(prjob,pn))->pset[i].marks,0);
    if(errpoi) break;
   }
  }

  event(EVENT_PRENDCOPY,view,(int)&prjob);

  colseparationprint(&prjob,CSPR_ENDCOPY);

  if(prjob.bits & PSDIRECT)
  {

   ps_endpage(&prjob,view,pn);
  }

  osprintendpage();
  gonormal();

  cprintf("end print page");

  if(errpoi) return(errpoi);

  if(copies!=curcopy)
  {
   pstatinc(curcopy-copies);

   if(copies && setpscopy(totcopies-copies+1)) printcancelled=1;
   else
   if(copies && printpaws()) printcancelled=1;
   curcopy=copies;
  }
  else if(updatestatpoll()) printcancelled=1;

//  if(printcancelled);
 }

 event(EVENT_PRENDPAPER,view,(int)&prjob);

 return(errpoi);
}





// print status update

static int xsetpspage(prjobstr * prjob,filestr * file)
{
 paperstr * p;
 int        i;
 int        page;
 pagestr  * pagep;

 p=PRJOBPP(prjob,prjob->pn);

 for(i=0;i<p->n;i++)
 {
  if((page=p->pset[i].page)!=0)
  {
   pagep=(pagestr*)fob_find(page,file);
   return(setpspage(pagep->data.number));
  }
 }
 return(0);
}




/* on entering this function, the oldprinthandle is active */
/* if we leave with an error, then the newone is active    */

static os_error * printpages(printstr * prints,viewstr * view,wimp_redrawstr * r)
{
 os_error * err;
 int        pcopies;
 int        dcopies;
 int        qcopies;
 int        nopages;
 int        i;
 int        j;
 int        k;
 int        shouldpause;


 err=NULL;

 nopages=prjob.papern;


 if(prints->collate)
 {
  pcopies=qcopies=1;
  dcopies=prints->copies;
 }
 else
 {
  dcopies=1;
  if(prints->pause && printmode==0)
  {
   pcopies=1;
   qcopies=prints->copies;
  }
  else
  {
   pcopies=prints->copies;
   qcopies=1;
  }
 }


 shouldpause=(psrecord>1);

 initpstat(nopages,pcopies*dcopies*qcopies,prjob.separations);


 for(i=0;i<dcopies;i++)
 {
  if(setpscopy(i+1)) break;

  for(k=0;k<prjob.papern;k++)
  {
   prjob.pn=prints->backwards?(prjob.papern-1-k):k;

   if((printcancelled=xsetpspage(&prjob,view->file))!=0) break;

   for(j=0;j<qcopies;j++)
   {
    for(prjob.separation=0;
        prjob.separation<prjob.separations;prjob.separation++)
    {
     if(shouldpause && (printcancelled=printpaws())!=0) break;

     colseparationprint(&prjob,CSPR_STARTSEP);
     if((printcancelled=setpsplate(&prjob))==0)
     {
      if(prints->draft)
      {

      }
      else
      {
       err=printpage(pcopies,prjob.pn,view,r);
      }
     }
     colseparationprint(&prjob,CSPR_ENDSEP);

     if(printcancelled || err) break;
     shouldpause=1;
    }
    if(printcancelled || err) break;
   }
   if(printcancelled || err) break;
  }
  if(printcancelled || err) break;
 }

 return(err);
}



static os_error * printrecords(printstr * prints,viewstr * view,wimp_redrawstr * r)
{
 os_error * err;
 int        eof;

 err=NULL;

 if(printbits & PRB_MERGE)
 {
  err=printpages(prints,view,r);
 }
 else
 {
  psrecord=0;

  while(1)
  {
   psrecord++;

   if(prints->merge)
   {
    mergeseek((psrecord==1 && prints->headings)?1:-1,view->file,&eof);
    if(eof) break;
    if(psrecord>1 && (printcancelled=setpsrecord(psrecord))!=0) break;
   }
   else
   if(psrecord>1) break;

   event(EVENT_PRSTARTRECORD,view,(int)&prjob);

   err=printpages(prints,view,r);

   event(EVENT_PRENDRECORD,view,(int)&prjob);

   if(err) break;
  }
 }

 return(err);
}





/* cancel seems to work by the contrived mechanism of breaking out */
/* of the print job, doing something which generates an error      */
/* which then stops things                                         */


/* we always have the newprinthandle selected on leaving this function */

static os_error * doprintjob(printstr * prints,viewstr * view,wimp_redrawstr * r)
{
 os_error * err;

 /* worry that the first line should be outside                   */
 /* this is because this function must return with newprinthandle */
 /* selected, and it won't if this first call fails               */
 /* think if should trap oldprinthandle when select fails         */
 /* set to zero                                                   */


 err=NULL;

 if(prjob.bits & PSDIRECT) ps_startdoc(&prjob,view);
                                              

 err=printrecords(prints,view,r);


 if(prjob.bits & PSDIRECT) ps_enddoc(&prjob,view);


 return(err);
}



static os_error * abortprintfn(int handle,int userhandle,os_error * err,int * result)
{
/*
 gonormal();

 if(updatestatpoll())
 {
  printcancelled=1;
  *result=0;
 }

 goprinter();
*/
 USE(handle);
 USE(userhandle);
 USE(result);

 return(err);
}




static printtypes[]=
{
 PSCRIPT,
 PRNFILE,
 ALLFILES
};



static os_error * printoptionfn(int handle,int opt,int * type,TCHAR * name,int maxlen)
{

 *type=printtypes[opt];

 return(NULL);
 USE(handle);
 USE(name);
}


static saveoptionstr printoptions[]=
{
 TEXT("PostScript (*.ps)"),printoptionfn,
 TEXT("Print file (*.prn)"),printoptionfn,
 TEXT("All files (*.*)"),printoptionfn
};


static int printopt;







static os_error * printfn(wimp_redrawstr * r,int flags,void * data,int userhandle)
{
 os_error * err;
 TCHAR      printfile[MAX_PATH];
 TCHAR      extension[FSMAXEXTLEN];

// trouble here is that startdoc() can if print to file selected pop up a window
// so have to ensure right vdu data present for screen redraws

 err=NULL;


 osgonormal();

 if(prjob.prints->printtofile)
 {
  printfile[0]=0;
  setsaveoptions(sizeof(printoptions)/sizeof(saveoptionstr),printoptions,&printopt);

  err=opensaveparent2(printfile,NITEM(printfile),TEXTFILE,NULL,prjob.launchview->handle);
  if(!err)
  {
   if(printtypes[printopt]!=ALLFILES)
   {
    getextension(printtypes[printopt],extension);
    fs_checkextension(printfile,extension);
   }
  }
 }


 if(!err) err=osprintstartdoc(((viewstr*)userhandle)->name,prjob.prints->printtofile?printfile:NULL); //prints->printtofile?"File:"
 if(!err)
 {
  goprinter();


  if(!err)
  {
   gonormal();
   err=event(EVENT_PRSTARTJOB,(viewstr*)userhandle,(int)&prjob);
   if(!err)
   {
    if(((err=doprintjob((printstr*)data,(viewstr*)userhandle,r))!=NULL) || printcancelled)
    {
    // abortjob
    }

    event(EVENT_PRENDJOB,(viewstr*)userhandle,(int)&prjob);
   }
   goprinter();
   osprintenddoc();
  }

  gonormal();
 }

 osgoprinter();

 return(err);

 USE(flags);
}




static os_error * printgraphics(printstr * prints,viewstr * view)
{
 os_error  * err;
 int         eof;


 err=event(EVENT_PRSTART,view,(int)&prjob);
 if(!err)
 {
  openpstat(prjob.launchview,view->file,prints);

  psrecord=0;

  while(1)
  {
   if(printbits & PRB_MERGE)
   {
    psrecord++;

    if(prints->merge)
    {
     mergeseek((psrecord==1 && prints->headings)?1:-1,view->file,&eof);
     if(eof) break;
     if(psrecord>1 && (printcancelled=setpsrecord(psrecord))!=0) break;
    }
    else
    if(psrecord>1) break;

    event(EVENT_PRSTARTRECORD,view,(int)&prjob);
   }

   err=osxprint(0,(int)view,(void*)prints,printfn,abortprintfn,prjob.rawmode);
			if(err) break;

   if(printbits & PRB_MERGE)
   {
    event(EVENT_PRENDRECORD,view,(int)&prjob);
   }
   else break;

  }

  event(EVENT_PREND,view,(int)&prjob);
 }

	if(err && err->errnum==ESAVECANCELLED) err=NULL;

 return(err);
}


/*****************************************************************************/



os_error * printjobopen(int width)
{
 os_error * err;

 prjob.paperwidth=width;
 prjob.papersize=sizeof(paperstr)+(width-1)*sizeof(psetstr);
 prjob.papern=0;

 if(!prjob.paper) 
     err=flex_alloc((flex_ptr)&prjob.paper,prjob.papersize*PCHUNK);
 else 
     err=flex_chunk((flex_ptr)&prjob.paper,prjob.papersize*PCHUNK,
                                                  prjob.papersize*PCHUNK);

 return(err);
}



os_error * printjobadd(paperstr * paperp)
{
 os_error * err;

 err=flex_chunk((flex_ptr)&prjob.paper,(prjob.papern+1)*prjob.papersize,
                                                   prjob.papersize*PCHUNK);
 if(!err)
 {
  if(!prjob.papern)
  {
   prjob.maxbox=paperp->abox;
			getmaxabox(&prjob.papermaxbox,&paperp->ebox,&paperp->tr);
		}
  else
  {
			aboxstr tbox;

   getsumabox(&prjob.maxbox,&paperp->abox);

			getmaxabox(&tbox,&paperp->ebox,&paperp->tr);
   getsumabox(&prjob.papermaxbox,&tbox);
		}

  XMEMCPYX(PRJOBP(prjob,prjob.papern),paperp,prjob.papersize);
  prjob.papern++;
 }

 return(err);
}


os_error * printjobclose(void)
{
 return(flex_free((flex_ptr)&prjob.paper));
}


// called in pract, so hardware settings applied before job is constructed
// matters for things like sideways

os_error * prjobapplyhardware(printstr *  prints)
{
	os_error * err;
	int        prtype;
 int        propmode;


 err=osprgetcurrenttype(&prtype);

 if(prtype==PRPSTYPE && (printbits & PRB_PSDIRECT)) 
	{
  ps_printpropcollate(prints->collate,NULL,PRPROP_WRITE,&propmode);
  if(propmode & PRPROP_SET)
  {
   prints->collate=0;
  }

  if(!prints->collate)
  {
   ps_printpropcopies(prints->copies,NULL,PRPROP_WRITE,&propmode);
   if(propmode & PRPROP_SET)
   {
    prints->copies=1;
   }
  }


	}
	else
	{
  osxprintpropcollate(prints->collate,NULL,PRPROP_WRITE,&propmode);
  if(propmode & PRPROP_SET)
  {
   prints->collate=0;
  }

  if(!prints->collate)
  {
   osxprintpropcopies(prints->copies,NULL,PRPROP_WRITE,&propmode);
   if(propmode & PRPROP_SET)
   {
    prints->copies=1;
   }
  }

  osxprintpropscale(100,NULL,PRPROP_WRITE,&propmode);

  osxprintproporient(0,NULL,PRPROP_WRITE,&propmode); 
	}


	return(err);
}



#ifdef NEVER

os_error * prjobapplyhardwarelow(printstr *  prints)
{
	os_error * err;
	int        prtype;
 int        propmode;
 int        change;


 change=0;

 err=osprgetcurrenttype(&prtype);

 if(prtype==PRPSTYPE && (printbits & PRB_PSDIRECT)) 
	{



	}
	else
	{
  osxprintproporient(prints->sideways,NULL,PRPROP_WRITE,&propmode);
  if(propmode & PRPROP_SET)
  {
   SWOP(prints->cx,prints->cy);
   prints->sideways=0;
   change=1;
  }

  osxprintpropscale(scale(100,prints->scale,0x10000),NULL,PRPROP_WRITE,&propmode);
  if(propmode & PRPROP_SET)
  {
   prints->scale=0x10000;
   change=1;
  }

  if(change)
  {
//   err=osxactiveprintmargins(&prmargins->leftarea,&prmargins->rightarea,&prmargins->toparea,&prmargins->botarea,&prmargins->paperxsize,&prmargins->paperysize,FONTXRES,FONTYRES);
//   prmargins->toparea=prmargins->paperysize-prmargins->toparea;
//   prmargins->botarea=prmargins->paperysize-prmargins->botarea;

//			cprintf("ysize %d xsize %d",prmargins->paperysize,prmargins->paperxsize);
  }
	}


	return(err);
}


#endif


os_error * printjob(printstr * prints,viewstr * launchview,filestr * file,int branch)
{
 os_error * err;
 viewstr  * view;
 int        prtype;


#ifdef NEVER
 {
  int i;

  for(i=0;i<prjob.papern;i++)
  {
   dprintf(0,"i=%d n=%d",i,prjob.paper[i].n);
   dprintf(0,"x0=%d x1=%d y0=%d y1=%d",prjob.paper[i].abox.x0,
                                     prjob.paper[i].abox.x1,
                                     prjob.paper[i].abox.y0,
                                     prjob.paper[i].abox.y1);


   dprintf(0,"pset[0] page=%d sect=%d",prjob.paper[i].pset[0].page,
                                     prjob.paper[i].pset[0].section);
   dprintf(0,"pset[0] xpo=%d ypo=%d",prjob.paper[i].pset[0].xpo,
                                     prjob.paper[i].pset[0].ypo);
   dprintf(0,"pset[0] id=%d x0=%d x1=%d y0=%d y1=%d",
                               prjob.paper[i].pset[0].id,
                               prjob.paper[i].pset[0].abox.x0,
                               prjob.paper[i].pset[0].abox.x1,
                               prjob.paper[i].pset[0].abox.y0,
                               prjob.paper[i].pset[0].abox.y1);



   dprintf(0,"pset[1] page=%d sect=%d",prjob.paper[i].pset[1].page,
                                     prjob.paper[i].pset[1].section);
   dprintf(0,"pset[1] xpo=%d ypo=%d",prjob.paper[i].pset[1].xpo,
                                     prjob.paper[i].pset[1].ypo);
   dprintf(0,"pset[1] id=%d x0=%d x1=%d y0=%d y1=%d",
                               prjob.paper[i].pset[1].id,
                               prjob.paper[i].pset[1].abox.x0,
                               prjob.paper[i].pset[1].abox.x1,
                               prjob.paper[i].pset[1].abox.y0,
                               prjob.paper[i].pset[1].abox.y1);


  }
 }

/* return(NULL); */

#endif

 err=osprgetcurrenttype(&prtype);


	cprintf("prgetcurrent %d",prtype);

 if(!err)
 {
  prjob.xres=300;
  prjob.yres=300;
  prjob.hxres=300;
  prjob.hyres=300;
  prjob.bits=PRCOLOUR;			// originally various options set up here from SWI call e.g. colour capable printer
  prjob.rawmode=0;

  prjob.launchview=launchview;
  prjob.prints=prints;
  prjob.nopics=prints->nopics;
  prjob.prtype=(prtype==PRPSTYPE)?PRPS:PRNORMAL;
  err=ps_init(&prjob);
  if(!err) err=createnewprintview(&view,file,branch);
  if(!err)
  {
   prjob.view=view;
   view->data.pictures=!prints->nopics;
   view->data.invisibles=0;
   view->data.guides=0;
   view->data.zoom.mul=view->data.zoom.div=1;

   view->data.dble=0; /* very hairy, gets the reg marks right            */
                      /* if the value is inherited as 1 only get one set */

   colseparationprint(&prjob,CSPR_STARTJOB);

   if(prints->merge) err=mergeopen(prints->mergepath,file);
   if(!err)
   {
    err=printgraphics(prints,view);

    if(prints->merge) mergeclose(file);
   }

   colseparationprint(&prjob,CSPR_ENDJOB);

   deleteview(view,file);
  }
 }

 return(err);
}








int prprints(int fp)
{
 char * p;

 p=stringptr(stack[fp]);

// fs_write(prjob.newprinthandle,p,strlen(p));

 oswriteprinter(p);

 return(0);
}



// bits 16..31 driver number, PS =0, LJ=2
// bit 0 set mono only
//     1 unset colour

int prinfo(int fp)
{
 os_error  * err;
 char        string[256];
 int         prtype=0;

 err=osprgetcurrentname(string,sizeof(string));
 if(!err) err=osprgetcurrenttype(&prtype);
 if(!err)
 {
  assignstring(stack[fp],string);
  return((prtype==PRPSTYPE)?(0<<16):(1<<16));
 }
 else return(-1);
}


