/*->c.dbfontman */


#include "stdafx.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <ctype.h>
#include <time.h>



#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "flex.h"
#include "font.h"
#include "sprite.h"
#include "transform.h"


#include "wos.h"
#include "poll.h"
#include "etc.h"
#include "key.h"
#include "wimptext.h"
#include "temp.h"
#include "sp.h"
#include "bits.h"
#include "err.h"
#include "trans.h"
#include "save.h"
#include "xhelp.h"
#include "filetype.h"
#include "fsx.h"
#include "bf.h"
#include "conf.h"

#include "colour.h"
#include "deb.h"


#include "xext.h"


#include "str.h"
#include "constants.h"
#include "reslink.h"

#include "dbhi.h"

#include "file.h"
#include "view.h"
#include "utils.h"


#include "fox.h"
#include "fontmenu.h"


#include "dbfontman.h"



/*****************************************************************************/



#define IGMODE  1
#define REPMODE 0
#define MAPMODE 2
#define PSMODE  3


static dbstackstr  fontmandbstack;

extern dboxstr fontmanbox[2];


static int     fontmanmode=IGMODE;
static int     fontmantotal;											// value not used, just a tag for db's
static int     oldmode;


static viewstr   * cview;

static os_error * checkshade(void);



/****************************************************************************/



static int currentig;
static int currentrep;
static int currentmap;
static int currentps;

static int totalig;
static int totalrep;
static int totalmap;
static int totalps;

static int ptrig;
static int ptrrep;
static int ptrmap;
static int ptrps;

static int activeig;
static int activerep;
static int activemap;
static int activeps;

static int boldmap;
static int italicmap;


static char * xfontmaps;
static int    xfontmaplen;

static char * xfontignores;
static int    xfontignorelen;

static char * xfontreplaces;
static int    xfontreplacelen;

static char * xfontpostscript;
static int    xfontpostscriptlen;




static os_error * savefontfn(char * name,int type)
{
 os_error * err;
 buffer     bf;
 char     * lt;
 char     * p;
 char     * p0;
 char     * p1;
 char     * p2;
 char     * p3;
 char     * p4;
 int        changes;



 err=bf_open(name,'w',DEFBUFFSIZE,&bf);
 if(!err)
 {
  bf_printf(&bf,"void main(void)\r\n{\r\n");

  changes=0;
  
  p=xfontignores;
  lt=p+xfontignorelen;
  while(p<lt)
  {
   bf_printfeol(&bf,"fontignore(\"%s\",0);",p);
   p+=strlen(p)+1;
   changes=1;
  }

  bf_printfeol(&bf,"fontignorestate(%d);",activeig);


  p=xfontmaps;
  lt=p+xfontmaplen;
  while(p<lt)
  {
   p0=p;
   p1=p0+strlen(p0)+1;
   p2=p1+strlen(p1)+1;
   p3=p2+strlen(p2)+1;
   p4=p3+strlen(p3)+1;

   bf_printfeol(&bf,"fontmap(\"%s\",\"%s\",\"%s\",%d,\"%s\",\"\",0,0);",p0,p1,p2,*p4,p3);

   p=p4+1;
   changes=1;
  }

  bf_printfeol(&bf,"fontmapstate(%d);",activemap);


  p=xfontreplaces;
  lt=p+xfontreplacelen;
  while(p<lt)
  {
   p0=p;
   p1=p0+strlen(p)+1;
   p2=p1+strlen(p1)+1;

   bf_printfeol(&bf,"fontreplace(\"%s\",\"%s\",0);",p1,p0);

   p=p2;
  }

  bf_printfeol(&bf,"fontreplacestate(%d);",activerep);



  p=xfontpostscript;
  lt=p+xfontpostscriptlen;
  while(p<lt)
  {
   p0=p;
   p1=p0+strlen(p)+1;
   p2=p1+strlen(p1)+1;

   bf_printfeol(&bf,"fontpostscript(\"%s\",\"%s\",0);",p1,p0);

   p=p2;
  }

  bf_printfeol(&bf,"fontpostscriptstate(%d);",activeps);


  if(activemap || activeig || changes)
  {
   bf_printfeol(&bf,"forcefontschange();");
  }


  bf_printfeol(&bf,"}");

  err=bf_closec(&bf,err,name,type);
 }
 

 return(err);

 USE(type);
}





static os_error * openfontmansave(void)
{
 os_error * err;
 TCHAR      name[FILENAMELEN];

 xzstrncpyu(name,"Fonts",NITEM(name));
 err=opensaveparent(name,NITEM(name),SCRIPT2,savefontfn,fontmanbox[0].handle);

 return(err);
}



static char * fontpath="<HKEY_CURRENT_USER\\Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders\\AppData>\\DavidPilling\\OvationPro\\AutoRun\\!Fonts.csc";


static os_error * savedefaultfontman(void)
{
 os_error * err;
 int        result;

 err=confirmparent(NULL,CONYN,&result,"{FOXCC}");
 if(result==1)
 {
  err=fs_validatepath(fontpath,0);
  if(!err) err=savefontfn(fontpath,SCRIPT2);
 }
 return(err);
}







/* close macros window */

static os_error * fontmanclose(int code)
{
 os_error    * err;


 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  cprintf("maplen %d %d",fontmaplen,xfontmaplen);
  cprintf("ignore %d %d",fontignorelen,xfontignorelen);
  cprintf("replace %d %d",fontreplacelen,xfontreplacelen);

  fontmaplen=xfontmaplen;
  fontmapactive=activemap;
  if(xfontmaps)
  {
   if(fontmaps) err=flex_extend((flex_ptr)&fontmaps,fontmaplen);
   else         err=flex_alloc((flex_ptr)&fontmaps,fontmaplen);
   if(!err) memcpy(fontmaps,xfontmaps,fontmaplen);
  }
  else
  {
   flex_free((flex_ptr)&fontmaps);
   fontmaplen=0;
  }

  fontignorelen=xfontignorelen;
  fontignoreactive=activeig;
  if(xfontignores)
  {
   if(fontignores) err=flex_extend((flex_ptr)&fontignores,fontignorelen);
   else            err=flex_alloc((flex_ptr)&fontignores,fontignorelen);
   if(!err) memcpy(fontignores,xfontignores,fontignorelen);
  }
  else
  {
   flex_free((flex_ptr)&fontignores);
   fontignorelen=0;
  }


  fontreplacelen=xfontreplacelen;
  fontreplaceactive=activerep;
  if(xfontreplaces)
  {
   if(fontreplaces) err=flex_extend((flex_ptr)&fontreplaces,fontreplacelen);
   else             err=flex_alloc((flex_ptr)&fontreplaces,fontreplacelen);
   if(!err) memcpy(fontreplaces,xfontreplaces,fontreplacelen);
  }
  else
  {
   flex_free((flex_ptr)&fontreplaces);
   fontreplacelen=0;
  }


  fontpostscriptlen=xfontpostscriptlen;
  fontpostscriptactive=activeps;
  if(xfontpostscript)
  {
   if(fontpostscript) err=flex_extend((flex_ptr)&fontpostscript,fontpostscriptlen);
   else             err=flex_alloc((flex_ptr)&fontpostscript,fontpostscriptlen);
   if(!err) memcpy(fontpostscript,xfontpostscript,fontpostscriptlen);
  }
  else
  {
   flex_free((flex_ptr)&fontpostscript);
   fontpostscriptlen=0;
  }


  forcefontschangelo();
 }


 if(!err)
 {
  if(code!=DBAPPLY) 
  {
   flex_free((flex_ptr)&xfontignores);
   flex_free((flex_ptr)&xfontreplaces);
   flex_free((flex_ptr)&xfontpostscript);
   flex_free((flex_ptr)&xfontmaps);  
  }
 }

 return(err);
}








static os_error * savefontman(int handle,int userhandle,wimp_mousestr * m)
{
 dbclose(fontmanbox,DBAPPLY);
 return(savedefaultfontman());

 USE(userhandle);
 USE(handle);
 USE(m);
}


static os_error * savefontmanas(int handle,int userhandle,wimp_mousestr * m)
{
 dbreadvalues(&fontmanbox[1]); 
 return(openfontmansave());

 USE(userhandle);
 USE(handle);
 USE(m);
}



/***************************************************************************************/





// font names to postscript, format in memory <old string> <new string>



static int pscount(char * pss,int len)
{
 char * lt;
 char * p;
 int    count;

 count=0;
 if(pss && len)
 {
  lt=pss+len;
  p=pss;
  while(p<lt)
  {
   p+=strlen(p)+1;
   p+=strlen(p)+1;
   count++;
  }
 }

 return(count);
}






static int psnext(int ptr,char * maps,int len)
{
 char * p;

 if(maps && len)
 {
  p=maps+ptr;
  if(ptr<len)
  {
   p+=strlen(p)+1;
   p+=strlen(p)+1;
   ptr+=p-(maps+ptr);
  }
 }
	else
	{
		ptr=0;
	}

 return(ptr);
}



static int psprev(int ptr,char * maps,int len)
{
 char * p;
 char * q;
 char * lt;
 
 if(maps && len)
 {
  q=p=maps;
  lt=p+ptr;

  while(1)
  {
   q=p;
   p+=strlen(p)+1;
   p+=strlen(p)+1;
   if(p>=lt) break;
  }

  ptr=q-maps;
 }
	else
	{
		ptr=0;
	}

 return(ptr);

 USE(len);
}




static os_error * psdelete(void)
{
 os_error * err;
 int        len;
 char     * p;
 char     * q;

 p=q=xfontpostscript+ptrps;
 p+=strlen(p)+1;
 p+=strlen(p)+1;

 len=p-q;

 err=flex_midextend((flex_ptr)&xfontpostscript,ptrps+len,-len);
 if(!err)
 {
  totalps--;
  xfontpostscriptlen-=len;

  if(ptrps>=xfontpostscriptlen)
  {
   ptrps=psprev(ptrps,xfontpostscript,xfontpostscriptlen);
  }
  
  if(currentps>=totalps) currentps--;
  if(currentps<0) currentps=0;
 }

 return(err);
}



static os_error * psdup(void)
{
 os_error * err;
 int        len;
 char     * p;
 char     * q;

	if(xfontpostscriptlen)
	{
  p=q=xfontpostscript+ptrps;
  p+=strlen(p)+1;
  p+=strlen(p)+1;

  len=p-q;
	}
	else
	{
		len=0;
	}

 err=flex_midextend((flex_ptr)&xfontpostscript,ptrps+len,len);
 if(!err)
 {
		memcpy(xfontpostscript+ptrps+len,xfontpostscript+ptrps,len);
  totalps++;
  xfontpostscriptlen+=len;
		currentps++;
		ptrps+=len;
 }

 return(err);
}



static os_error * psnew(void)
{
 os_error * err;
 int        len;
 char     * p;
 char     * q;

	if(xfontpostscriptlen)
	{
  p=q=xfontpostscript+ptrps;
  p+=strlen(p)+1;
  p+=strlen(p)+1;

  len=p-q;
	}
 else
	{
		len=0;
	}

 err=flex_midextend((flex_ptr)&xfontpostscript,ptrps+len,2);
 if(!err)
 {
		memset(xfontpostscript+ptrps+len,0,2);
  totalps++;
  xfontpostscriptlen+=2;
		if(totalps==1)
		{
			currentps=0;
			ptrps=0;
		}
		else
		{
 		currentps++;
			ptrps+=len;
		}
 }

 return(err);
}





static os_error * wrpsorg(int value,char * string)
{

 if(xfontpostscript && xfontpostscriptlen) strcpy(string,xfontpostscript+ptrps);
 else                                      *string=0;

 return(NULL);
 USE(value);
}


static os_error * rdpsorg(int * value,char * string)
{
 os_error * err;
 int        oldlen;
 int        newlen;

	err=NULL;

 if(xfontpostscript && xfontpostscriptlen)
	{
  oldlen=strlen(xfontpostscript+ptrps);
  newlen=strlen(string);

  err=flex_midextend((flex_ptr)&xfontpostscript,ptrps+oldlen,newlen-oldlen);
  if(!err)
  {
   strcpy(xfontpostscript+ptrps,string);
   xfontpostscriptlen+=newlen-oldlen;
  }
	}

 return(err);
 USE(value);
}





static os_error * wrps(int value,char * string)
{
 char * p;

 if(xfontpostscript && xfontpostscriptlen)
 {
  p=xfontpostscript+ptrps;
  strcpy(string,p+strlen(p)+1);
 }
 else
 {
  *string=0;
 }
 
 return(NULL);
 USE(value);
}


static os_error * rdps(int * value,char * string)
{
 os_error * err;
 int        oldlen;
 int        newlen;
 int        orglen;
 char     * p;

	err=NULL;

 if(xfontpostscript && xfontpostscriptlen)
	{
  p=xfontpostscript+ptrps;
  orglen=strlen(p)+1;

  oldlen=strlen(xfontpostscript+orglen+ptrps); 
  newlen=strlen(string);
 

  err=flex_midextend((flex_ptr)&xfontpostscript,ptrps+orglen+oldlen,newlen-oldlen);
  if(!err)
  {
   strcpy(xfontpostscript+orglen+ptrps,string);
   xfontpostscriptlen+=newlen-oldlen;
  }
	}

 return(err);
 USE(value);
}




static os_error * pssetfont(int font)
{
 return(writeicon(fontmanbox[1].handle,10,fontusername(font)));
}



static os_error * psmenu(int handle,int userhandle,wimp_mousestr * m)
{

 fontusermenu(handle,pssetfont,NULL);

 return(NULL);

 USE(userhandle);
 USE(handle);
 USE(m);
}





static dbiconstr psicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */


   17, &activeps,   DBTOGGLE, 0,   0,      1, F4,  0, 0,     NULL,   0,

   10, &currentps,  DBWRITENC,1,   0,      0,  0,  0, 0,     rdpsorg, wrpsorg,
   13, &currentps,  DBWRITENC,1,   0,      0,  0,  0, 0,     rdps, wrps,

   15, NULL,         DBACTION, 1,   0,      0,  0,  0,  0,(dbreadfn)psmenu,0,


    -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr psbox=
{
 0,
 TFONTMANPS,
 DBPANE,
 0,
 NULL,
 NULL,
 NULL,
 NULL,
 psicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};









/***************************************************************************************/



// font names to replace, format in memory <old string> <new string>




static int repcount(char * reps,int len)
{
 char * lt;
 char * p;
 int    count;

 count=0;
 if(reps && len)
 {
  lt=reps+len;
  p=reps;
  while(p<lt)
  {
   p+=strlen(p)+1;
   p+=strlen(p)+1;
   count++;
  }
 }

 return(count);
}






static int repnext(int ptr,char * maps,int len)
{
 char * p;

 if(maps && len)
 {
  p=maps+ptr;
  if(ptr<len)
  {
   p+=strlen(p)+1;
   p+=strlen(p)+1;
   ptr+=p-(maps+ptr);
  }
 }
	else
	{
		ptr=0;
	}

 return(ptr);
}



static int repprev(int ptr,char * maps,int len)
{
 char * p;
 char * q;
 char * lt;
 
 if(maps && len)
 {
  q=p=maps;
  lt=p+ptr;

  while(1)
  {
   q=p;
   p+=strlen(p)+1;
   p+=strlen(p)+1;
   if(p>=lt) break;
  }

  ptr=q-maps;
 }
	else
	{
		ptr=0;
	}

 return(ptr);

 USE(len);
}




static os_error * repdelete(void)
{
 os_error * err;
 int        len;
 char     * p;
 char     * q;

 p=q=xfontreplaces+ptrrep;
 p+=strlen(p)+1;
 p+=strlen(p)+1;

 len=p-q;

 err=flex_midextend((flex_ptr)&xfontreplaces,ptrrep+len,-len);
 if(!err)
 {
  totalrep--;
  xfontreplacelen-=len;

  if(ptrrep>=xfontreplacelen)
  {
   ptrrep=repprev(ptrrep,xfontreplaces,xfontreplacelen);
  }
  
  if(currentrep>=totalrep) currentrep--;
  if(currentrep<0) currentrep=0;
 }

 return(err);
}



static os_error * repdup(void)
{
 os_error * err;
 int        len;
 char     * p;
 char     * q;

	if(xfontreplacelen)
	{
  p=q=xfontreplaces+ptrrep;
  p+=strlen(p)+1;
  p+=strlen(p)+1;

  len=p-q;
	}
	else
	{
		len=0;
	}

 err=flex_midextend((flex_ptr)&xfontreplaces,ptrrep+len,len);
 if(!err)
 {
		memcpy(xfontreplaces+ptrrep+len,xfontreplaces+ptrrep,len);
  totalrep++;
  xfontreplacelen+=len;
		currentrep++;
		ptrrep+=len;
 }

 return(err);
}



static os_error * repnew(void)
{
 os_error * err;
 int        len;
 char     * p;
 char     * q;

	if(xfontreplacelen)
	{
  p=q=xfontreplaces+ptrrep;
  p+=strlen(p)+1;
  p+=strlen(p)+1;

  len=p-q;
	}
 else
	{
		len=0;
	}

 err=flex_midextend((flex_ptr)&xfontreplaces,ptrrep+len,2);
 if(!err)
 {
		memset(xfontreplaces+ptrrep+len,0,2);
  totalrep++;
  xfontreplacelen+=2;
		if(totalrep==1)
		{
			currentrep=0;
			ptrrep=0;
		}
		else
		{
 		currentrep++;
			ptrrep+=len;
		}
 }

 return(err);
}





static os_error * wrorg(int value,char * string)
{

 if(xfontreplaces && xfontreplacelen) strcpy(string,xfontreplaces+ptrrep);
 else                                 *string=0;

 return(NULL);
 USE(value);
}


static os_error * rdorg(int * value,char * string)
{
 os_error * err;
 int        oldlen;
 int        newlen;

	err=NULL;

 if(xfontreplaces && xfontreplacelen)
	{
  oldlen=strlen(xfontreplaces+ptrrep);
  newlen=strlen(string);

  err=flex_midextend((flex_ptr)&xfontreplaces,ptrrep+oldlen,newlen-oldlen);
  if(!err)
  {
   strcpy(xfontreplaces+ptrrep,string);
   xfontreplacelen+=newlen-oldlen;
  }
	}

 return(err);
 USE(value);
}





static os_error * wrrep(int value,char * string)
{
 char * p;

 if(xfontreplaces && xfontreplacelen)
 {
  p=xfontreplaces+ptrrep;
  strcpy(string,p+strlen(p)+1);
 }
 else
 {
  *string=0;
 }
 
 return(NULL);
 USE(value);
}


static os_error * rdrep(int * value,char * string)
{
 os_error * err;
 int        oldlen;
 int        newlen;
 int        orglen;
 char     * p;

	err=NULL;

 if(xfontreplaces && xfontreplacelen)
	{
  p=xfontreplaces+ptrrep;
  orglen=strlen(p)+1;

  oldlen=strlen(xfontreplaces+orglen+ptrrep); 
  newlen=strlen(string);
 

  err=flex_midextend((flex_ptr)&xfontreplaces,ptrrep+orglen+oldlen,newlen-oldlen);
  if(!err)
  {
   strcpy(xfontreplaces+orglen+ptrrep,string);
   xfontreplacelen+=newlen-oldlen;
  }
	}

 return(err);
 USE(value);
}




static os_error * repsetfont(int font)
{
 return(writeicon(fontmanbox[1].handle,13,fontusername(font)));
}



static os_error * repmenu(int handle,int userhandle,wimp_mousestr * m)
{

 fontusermenu(handle,repsetfont,NULL);

 return(NULL);

 USE(userhandle);
 USE(handle);
 USE(m);
}





static dbiconstr repicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */


   17, &activerep,   DBTOGGLE, 0,   0,      1, F4,  0, 0,     NULL,   0,

   10, &currentrep,  DBWRITENC,1,   0,      0,  0,  0, 0,     rdorg, wrorg,
   13, &currentrep,  DBWRITENC,1,   0,      0,  0,  0, 0,     rdrep, wrrep,

   15, NULL,         DBACTION, 1,   0,      0,  0,  0,  0,(dbreadfn)repmenu,0,


    -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr repbox=
{
 0,
 TFONTMANREP,
 DBPANE,
 0,
 NULL,
 NULL,
 NULL,
 NULL,
 repicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};

/********************************************************************************/


// format in memory <family> <member> <identifier> <new identifier> <flags>



static int mapcount(char * maps,int len)
{
 char * lt;
 char * p;
 int    count;

 count=0;
 if(maps && len)
 {
  lt=maps+len;
  p=maps;
  while(p<lt)
  {
   p+=strlen(p)+1;
   p+=strlen(p)+1;
   p+=strlen(p)+1;
   p+=strlen(p)+1;
   p++;
   count++;
  }
 }

 return(count);
}




static int mapnext(int ptr,char * maps,int len)
{
 char * p;
 char * q;

 if(maps && len)
 {
  q=p=maps+ptr;
  if(ptr<len)
  {
   p+=strlen(p)+1;
   p+=strlen(p)+1;
   p+=strlen(p)+1;
   p+=strlen(p)+1;
   p++;
   ptr+=p-(maps+ptr);
  }
 }
	else
	{
		ptr=0;
	}

 return(ptr);
}



static int mapprev(int ptr,char * maps,int len)
{
 char * p;
 char * q;
 char * lt;
 
 if(maps && len)
 {
  q=p=maps;
  lt=p+ptr;

  while(1)
  {
   q=p;
   p+=strlen(p)+1;
   p+=strlen(p)+1;
   p+=strlen(p)+1;
   p+=strlen(p)+1;
   p++;
   if(p>=lt) break;
  }

  ptr=q-maps;
 }
	else
	{
		ptr=0;
	}

 return(ptr);

 USE(len);
}



static os_error * mapdelete(void)
{
 os_error * err;
 int        len;
 char     * p;
 char     * q;

 p=q=xfontmaps+ptrmap;
 p+=strlen(p)+1;
 p+=strlen(p)+1;
 p+=strlen(p)+1;
 p+=strlen(p)+1;
 p++;

 len=p-q;

 err=flex_midextend((flex_ptr)&xfontmaps,ptrmap+len,-len);
 if(!err)
 {
  totalmap--;
  xfontmaplen-=len;

  if(ptrmap>=xfontmaplen)
  {
   ptrmap=mapprev(ptrmap,xfontmaps,xfontmaplen);
  }
  
  if(currentmap>=totalmap) currentmap--;
  if(currentmap<0) currentmap=0;
 }

 return(err);
}



static os_error * mapdup(void)
{
 os_error * err;
 int        len;
 char     * p;
 char     * q;

 p=q=xfontmaps+ptrmap;
 p+=strlen(p)+1;
 p+=strlen(p)+1;
 p+=strlen(p)+1;
 p+=strlen(p)+1;
 p++;

 len=p-q;

 err=flex_midextend((flex_ptr)&xfontmaps,ptrmap+len,len);
 if(!err)
 {
		memcpy(xfontmaps+ptrmap+len,xfontmaps+ptrmap,len);
  totalmap++;
  xfontmaplen+=len;
		currentmap++;
		ptrmap+=len;
 }

 return(err);
}





static os_error * mapnew(void)
{
 os_error * err;
 int        len;
 char     * p;
 char     * q;

	if(xfontmaplen)
	{
  p=q=xfontmaps+ptrmap;
  p+=strlen(p)+1;
  p+=strlen(p)+1;
  p+=strlen(p)+1;
  p+=strlen(p)+1;
  p++;

  len=p-q;
	}
	else
	{
		len=0;
	} 

 err=flex_midextend((flex_ptr)&xfontmaps,ptrmap+len,5);
 if(!err)
 {
		memset(xfontmaps+ptrmap+len,0,5);
  totalmap++;
  xfontmaplen+=5;
		if(totalmap==1)
		{
			currentmap=0;
			ptrmap=0;
		}
		else
		{
	 	currentmap++;
	 	ptrmap+=len;
		}
 }

 return(err);
}








static os_error * mapclose(int code)
{
 os_error    * err;
 char        * p;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  p=xfontmaps+ptrmap;
  p=p+strlen(p)+1;
  p=p+strlen(p)+1;
  p=p+strlen(p)+1;
  p=p+strlen(p)+1; 

  *p=(char)((italicmap<<1)+boldmap);
 }
 
 return(err);
}



static os_error * mapopen(void)
{
 os_error    * err;
 char        * p;

 err=NULL;

 p=xfontmaps+ptrmap;
 p=p+strlen(p)+1;
 p=p+strlen(p)+1;
 p=p+strlen(p)+1;
 p=p+strlen(p)+1; 

 boldmap=(*p) & 0x1;
 italicmap=((*p)>>1)&0x1;
 
 return(err);
}






static os_error * wroldid(int value,char * string)
{
 char * p;

 if(xfontmaps && xfontmaplen)
 {
  p=xfontmaps+ptrmap;
  p=p+strlen(p)+1;
  p=p+strlen(p)+1;
  p=p+strlen(p)+1;
 
  strcpy(string,p);
 }
 else
 {
  *string=0;
 }

 return(NULL);
 USE(value);
}


static os_error * rdoldid(int * value,char * string)
{
 os_error * err;
 int        oldlen;
 int        newlen;
 int        orglen;
 char     * p;

	err=NULL;

 if(xfontmaps && xfontmaplen)
	{
  p=xfontmaps+ptrmap;
  p=p+strlen(p)+1;
  p=p+strlen(p)+1;
  p=p+strlen(p)+1;
  orglen=p-(xfontmaps+ptrmap);

  oldlen=strlen(xfontmaps+orglen+ptrmap); 
  newlen=strlen(string);
 
  err=flex_midextend((flex_ptr)&xfontmaps,ptrmap+orglen+oldlen,newlen-oldlen);
  if(!err)
  {
   strcpy(xfontmaps+orglen+ptrmap,string);
   xfontmaplen+=newlen-oldlen;
  }
	}

 return(err);
 USE(value);
}







static os_error * wrid(int value,char * string)
{
 char * p;

 if(xfontmaps && xfontmaplen)
 {
  p=xfontmaps+ptrmap;
  p=p+strlen(p)+1;
  p=p+strlen(p)+1;
 
  strcpy(string,p);
 }
 else
 {
  *string=0;
 }

 return(NULL);
 USE(value);
}


static os_error * rdid(int * value,char * string)
{
 os_error * err;
 int        oldlen;
 int        newlen;
 int        orglen;
 char     * p;

	err=NULL;

 if(xfontmaps && xfontmaplen)
	{
  p=xfontmaps+ptrmap;
  p=p+strlen(p)+1;
  p=p+strlen(p)+1;
  orglen=p-(xfontmaps+ptrmap);

  oldlen=strlen(xfontmaps+orglen+ptrmap); 
  newlen=strlen(string);
 
  err=flex_midextend((flex_ptr)&xfontmaps,ptrmap+orglen+oldlen,newlen-oldlen);
  if(!err)
  {
   strcpy(xfontmaps+orglen+ptrmap,string);
   xfontmaplen+=newlen-oldlen;
  }
	}

 return(err);
 USE(value);
}









static os_error * wrweight(int value,char * string)
{
 char * p;

 if(xfontmaps && xfontmaplen)
 {
  p=xfontmaps+ptrmap;
  p=p+strlen(p)+1;
  strcpy(string,p);
 }
 else
 {
  *string=0;
 }

 return(NULL);
 USE(value);
}


static os_error * rdweight(int * value,char * string)
{
 os_error * err;
 int        oldlen;
 int        newlen;
 int        orglen;
 char     * p;


	err=NULL;

 if(xfontmaps && xfontmaplen)
	{
  p=xfontmaps+ptrmap;
  orglen=strlen(p)+1;

  oldlen=strlen(xfontmaps+orglen+ptrmap); 
  newlen=strlen(string);
 

  err=flex_midextend((flex_ptr)&xfontmaps,ptrmap+orglen+oldlen,newlen-oldlen);
  if(!err)
  {
   strcpy(xfontmaps+orglen+ptrmap,string);
   xfontmaplen+=newlen-oldlen;
  }
	}

 return(err);
 USE(value);
}







static os_error * wrface(int value,char * string)
{
 if(xfontmaps && xfontmaplen) strcpy(string,xfontmaps+ptrmap);
 else          *string=0;
 return(NULL);
 USE(value);
}


static os_error * rdface(int * value,char * string)
{
 os_error * err;
 int        oldlen;
 int        newlen;

	err=NULL;

 if(xfontmaps && xfontmaplen)
	{
  oldlen=strlen(xfontmaps+ptrmap); 
  newlen=strlen(string);
 
  err=flex_midextend((flex_ptr)&xfontmaps,ptrmap+oldlen,newlen-oldlen);
  if(!err)
  {
   strcpy(xfontmaps+ptrmap,string);
   xfontmaplen+=newlen-oldlen;
  }
	}

 return(err);
 USE(value);
}




static os_error * mapsetfont(int font)
{
 return(writeicon(fontmanbox[1].handle,21,fontosname(font)));
}



static os_error * mapmenu(int handle,int userhandle,wimp_mousestr * m)
{

 fontosmenu(handle,mapsetfont,NULL);

 return(NULL);

 USE(userhandle);
 USE(handle);
 USE(m);
}







static dbiconstr mapicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

   10, &activemap,   DBTOGGLE, 0,   0,      1, F4,  0, 0,     NULL,   0,
   25, &italicmap,   DBTOGGLE, 1,   0,      1, F3,  0, 0,     NULL,   0,
   26, &boldmap,     DBTOGGLE, 1,   0,      1, F5,  0, 0,     NULL,   0,


   17, &currentmap,   DBWRITENC,1,   0,      0,  0,  0, 0,    rdface,wrface,
   19, &currentmap,   DBWRITENC,1,   0,      0,  0,  0, 0,    rdweight,wrweight,
   21, &currentmap,   DBWRITENC,1,   0,      0,  0,  0, 0,    rdoldid,wroldid,
   23, &currentmap,   DBWRITENC,1,   0,      0,  0,  0, 0,    rdid,wrid,

   15, NULL,          DBACTION, 1,   0,      0,  0,  0, 0, (dbreadfn)mapmenu,0,

    -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr mapbox=
{
 0,
 TFONTMANMAP,
 DBPANE,
 0,
 mapclose,
 NULL,
 NULL,
 NULL,
 mapicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};





static int igcount(char * igs,int len)
{
 char * lt;
 char * p;
 int    count;

 count=0;
 if(igs && len)
 {
  lt=igs+len;
  p=igs;
  while(p<lt)
  {
   p+=strlen(p)+1;
   count++;
  }
 }

 return(count);
}




static int ignext(int ptr,char * igs,int len)
{
 char * p;
 
 if(igs && len)
 {
  p=igs+ptr;
  if(ptr<len)
  {
   ptr+=strlen(p)+1;
  }
 }
	else
	{
		ptr=0;
	}

 return(ptr);
}



static int igprev(int ptr,char * igs,int len)
{
 char * p;
 char * q;
 char * lt;
 
 if(igs && len)
 {
  q=p=igs;
  lt=p+ptr;

  while(1)
  {
   q=p;
   p+=strlen(p)+1;
   if(p>=lt) break;
  }

  ptr=q-igs;
 }
	else
	{
		ptr=0;
	}

 return(ptr);

 USE(len);
}



static os_error * igdelete(void)
{
 os_error * err;
 int        len;

 len=strlen(xfontignores+ptrig)+1;

 err=flex_midextend((flex_ptr)&xfontignores,ptrig+len,-len);
 if(!err)
 {
  totalig--;
  xfontignorelen-=len;

  if(ptrig>=xfontignorelen)
  {
   ptrig=igprev(ptrig,xfontignores,xfontignorelen);
  }
  
  if(currentig>=totalig) currentig--;
  if(currentig<0) currentig=0;
 }

 return(err);
}



static os_error * igdup(void)
{
 os_error * err;
 int        len;

	if(xfontignorelen)
	{
  len=strlen(xfontignores+ptrig)+1;
	}
 else
	{
		len=0;
	}

 err=flex_midextend((flex_ptr)&xfontignores,ptrig+len,len);
 if(!err)
 {
		memcpy(xfontignores+ptrig+len,xfontignores+ptrig,len);
  totalig++;
  xfontignorelen+=len;
		ptrig+=len;
 }

 return(err);
}




static os_error * ignew(void)
{
 os_error * err;
 int        len;

	if(xfontignorelen)
	{
  len=strlen(xfontignores+ptrig)+1;
	}
	else
	{
		len=0;
	}

 err=flex_midextend((flex_ptr)&xfontignores,ptrig+len,1);
 if(!err)
 {
		memset(xfontignores+ptrig+len,0,1);
  totalig++;
  xfontignorelen+=1;
		if(totalig==1)
		{
			currentig=0;
			ptrig=0;
		}
		else
		{
  	currentig++;
 		ptrig+=len;
		}
 }

 return(err);
}








static os_error * wrig(int value,char * string)
{
 if(xfontignores && xfontignorelen) strcpy(string,xfontignores+ptrig);
 else                               *string=0;
 return(NULL);
 USE(value);
}


static os_error * rdig(int * value,char * string)
{
 os_error * err;
 int        oldlen;
 int        newlen;

	err=NULL;

 if(xfontignores && xfontignorelen)
	{
  oldlen=strlen(xfontignores+ptrig);
  newlen=strlen(string);
 
  err=flex_midextend((flex_ptr)&xfontignores,ptrig+oldlen,newlen-oldlen);
  if(!err)
  {
   strcpy(xfontignores+ptrig,string);
   xfontignorelen+=newlen-oldlen;
  }
	}

 return(err);
 USE(value);
}



static os_error * igsetfont(int font)
{
 return(writeicon(fontmanbox[1].handle,13,fontosname(font)));
}



static os_error * igmenu(int handle,int userhandle,wimp_mousestr * m)
{

 fontosmenu(handle,igsetfont,NULL);

 return(NULL);

 USE(userhandle);
 USE(handle);
 USE(m);
}




static dbiconstr igicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */


   12, &activeig,    DBTOGGLE, 0,   0,      1, F4,  0, 0,     NULL,   0,

   13, &currentig,   DBWRITENC,1,   0,      0,  0,  0, 0,     rdig, wrig,

   11, NULL,         DBACTION, 1,   0,      0,  0,  0,  0,(dbreadfn)igmenu,0,


    -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr igbox=
{
 0,
 TFONTMANIG,
 DBPANE,
 0,
 NULL,
 NULL,
 NULL,
 NULL,
 igicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};






/* change of macro mode        */
/* called with zero args below */

static os_error * optfn(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

	err=NULL;

 if(oldmode!=fontmanmode)
 {
  oldmode=fontmanmode;


  err=dbreadvalues(&fontmanbox[1]);

  if(!err)
  {

   switch(oldmode)
   {
    case MAPMODE:
                 mapclose(DBOK);
                 break;



   }


   switch(fontmanmode)
   {
    case  IGMODE:
                 dbchangepane(fontmanbox+1,&igbox,fontmanbox);
                 break;

    case REPMODE:
                 dbchangepane(fontmanbox+1,&repbox,fontmanbox);
                 break;


    case  PSMODE:
                 dbchangepane(fontmanbox+1,&psbox,fontmanbox);
                 break;
    
    
    case MAPMODE:
                 mapopen();
                 dbchangepane(fontmanbox+1,&mapbox,fontmanbox);
                 break;

   }
  }


  checkshade();

		dbchangevalue(&fontmantotal,&fontmanbox[0]);

 }

 return(err);

 USE(userhandle);
 USE(handle);
 USE(m);
}







static os_error * fontmandelete(int handle,int userhandle,wimp_mousestr * m)
{

 switch(fontmanmode)
 {
    case  IGMODE:
                 igdelete();
                 break;

    case REPMODE:
                 repdelete();
                 break;


    case  PSMODE:
                 psdelete();
                 break;

    
    case MAPMODE:
                 mapdelete();
                 mapopen();
                 break;

 }


 dbwritevalues(&fontmanbox[1]);
 dbchangevalue(&fontmantotal,&fontmanbox[0]);
 checkshade();

 return(NULL);
 USE(userhandle);
 USE(handle);
 USE(m);
}



static os_error * fontmandup(int handle,int userhandle,wimp_mousestr * m)
{


 dbreadvalues(&fontmanbox[1]);

 
 switch(fontmanmode)
 {
    case  IGMODE:
                 igdup();
                 break;

    case REPMODE:
                 repdup();
                 break;

    case  PSMODE:
                 psdup();
                 break;

    case MAPMODE:
																	mapclose(DBOK);
                 mapdup();
                 mapopen();
                 break;

 }


 dbwritevalues(&fontmanbox[1]);
 dbchangevalue(&fontmantotal,&fontmanbox[0]);

 return(NULL);

 USE(userhandle);
 USE(handle);
 USE(m);
}




static os_error * fontmannew(int handle,int userhandle,wimp_mousestr * m)
{

 dbreadvalues(&fontmanbox[1]);

 
 switch(fontmanmode)
 {
    case  IGMODE:
                 ignew();
                 break;

    case REPMODE:
                 repnew();
                 break;

    case  PSMODE:
                 psnew();
                 break;

    case MAPMODE:
                 mapnew();
                 mapopen();
                 break;

 }


 dbwritevalues(&fontmanbox[1]);
 dbchangevalue(&fontmantotal,&fontmanbox[0]);
 checkshade();

 return(NULL);

 USE(userhandle);
 USE(handle);
 USE(m);
}










static os_error * fontmanprevs(int handle)
{

 dbreadvalues(&fontmanbox[1]);

 switch(fontmanmode)
 {
    case  IGMODE:
                 if(currentig>0)
                 {
                  ptrig=igprev(ptrig,xfontignores,xfontignorelen);
                  currentig--;
                 }
                 break;

    case REPMODE:
                 if(currentrep>0)
                 {
                  ptrrep=repprev(ptrrep,xfontreplaces,xfontreplacelen);
                  currentrep--;
                 }
                 break;


    case  PSMODE:
                 if(currentps>0)
                 {
                  ptrps=psprev(ptrps,xfontpostscript,xfontpostscriptlen);
                  currentps--;
                 }
                 break;
    

    case MAPMODE:
                 if(currentmap>0)
                 {
																		mapclose(DBOK);
                  ptrmap=mapprev(ptrmap,xfontmaps,xfontmaplen);
                  currentmap--;
                  mapopen();
                 }
                 break;

 }
 
 
 dbwritevalues(&fontmanbox[1]);
 dbchangevalue(&fontmantotal,&fontmanbox[0]);
 
 return(NULL);

 USE(handle);
}




static os_error * fontmannexts(int handle)
{


 dbreadvalues(&fontmanbox[1]); 

 switch(fontmanmode)
 {
    case  IGMODE:
                 if(currentig<(totalig-1))
                 {
                  ptrig=ignext(ptrig,xfontignores,xfontignorelen);
                  currentig++;
                 }
                 break;

    case REPMODE:
                 if(currentrep<(totalrep-1))
                 {
                  ptrrep=repnext(ptrrep,xfontreplaces,xfontreplacelen);
                  currentrep++;
                 }
                 break;


    case  PSMODE:
                 if(currentps<(totalps-1))
                 {
                  ptrps=psnext(ptrps,xfontpostscript,xfontpostscriptlen);
                  currentps++;
                 }
                 break;


    case MAPMODE:
                 if(currentmap<(totalmap-1))
                 {
																		mapclose(DBOK);
                  ptrmap=mapnext(ptrmap,xfontmaps,xfontmaplen);
                  currentmap++;
                  mapopen();
                 }

                 break;

 }

 
 dbwritevalues(&fontmanbox[1]);
 dbchangevalue(&fontmantotal,&fontmanbox[0]);


 return(NULL);

 USE(handle);
}


static os_error * fontmanprev(int handle,int userhandle,wimp_mousestr * m)
{
 if(m->bbits==0x1) return(fontmannexts(handle));
 else              return(fontmanprevs(handle));
 USE(userhandle);
}


static os_error * fontmannext(int handle,int userhandle,wimp_mousestr * m)
{
 if(m->bbits==0x1) return(fontmanprevs(handle));
 else              return(fontmannexts(handle));
 USE(userhandle);
}





static os_error * fontmanend(int handle,int userhandle,wimp_mousestr * m)
{


 dbreadvalues(&fontmanbox[1]); 

 switch(fontmanmode)
 {
    case  IGMODE:
                 while(currentig<(totalig-1))
                 {
                  ptrig=ignext(ptrig,xfontignores,xfontignorelen);
                  currentig++;
                 }
                 break;

    case REPMODE:
                 while(currentrep<(totalrep-1))
                 {
                  ptrrep=repnext(ptrrep,xfontreplaces,xfontreplacelen);
                  currentrep++;
                 }
                 break;


    case  PSMODE:
                 while(currentps<(totalps-1))
                 {
                  ptrps=psnext(ptrps,xfontpostscript,xfontpostscriptlen);
                  currentps++;
                 }
                 break;


    case MAPMODE:
																	mapclose(DBOK);
                 while(currentmap<(totalmap-1))
                 {
                  ptrmap=mapnext(ptrmap,xfontmaps,xfontmaplen);
                  currentmap++;
                 }
                 mapopen();
                 break;

 }

 
 dbwritevalues(&fontmanbox[1]);
 dbchangevalue(&fontmantotal,&fontmanbox[0]);


 return(NULL);

 USE(userhandle);
 USE(handle);
 USE(m);
}




static os_error * fontmanstart(int handle,int userhandle,wimp_mousestr * m)
{


 dbreadvalues(&fontmanbox[1]); 

 switch(fontmanmode)
 {
    case  IGMODE:
                 ptrig=0;
                 currentig=0;
                 break;

    case REPMODE:
                 ptrrep=0;
                 currentrep=0;
                 break;

    case  PSMODE:
                 ptrps=0;
                 currentps=0;
                 break;

    case MAPMODE:
																	mapclose(DBOK);
                 ptrmap=0;
                 currentmap=0;
                 mapopen();
                 break;

 }

 
 dbwritevalues(&fontmanbox[1]);
 dbchangevalue(&fontmantotal,&fontmanbox[0]);


 return(NULL);

 USE(userhandle);
 USE(handle);
 USE(m);
}










static os_error * wrtotal(int value,char * string)
{

 switch(fontmanmode)
 {
    case  IGMODE:
																	if(totalig) sprintf(string,"%d/%d",currentig+1,totalig);
																	else								sprintf(string,"0");
                 break;

    case REPMODE:
																	if(totalrep) sprintf(string,"%d/%d",currentrep+1,totalrep);
																	else				 				sprintf(string,"0");
                 break;

    case  PSMODE:
																	if(totalps)  sprintf(string,"%d/%d",currentps+1,totalps);
																	else				 				sprintf(string,"0");
                 break;

    case MAPMODE:
																	if(totalmap) sprintf(string,"%d/%d",currentmap+1,totalmap);
																	else         sprintf(string,"0");
                 break;
 }

 return(NULL);
 USE(value);
}





static os_error * checkshade(void)
{

 switch(fontmanmode)
 {
    case  IGMODE:
                 dbshade(1,totalig?0:DBWRITEG|DBSHADEG,&fontmanbox[1]);
																	dbshade(1,totalig?0:DBWRITEG|DBSHADEG,&fontmanbox[0]);
                 break;

    case REPMODE:
                 dbshade(1,totalrep?0:DBWRITEG|DBSHADEG,&fontmanbox[1]);
																	dbshade(1,totalrep?0:DBWRITEG|DBSHADEG,&fontmanbox[0]);
                 break;

    case  PSMODE:
                 dbshade(1,totalps?0:DBWRITEG|DBSHADEG,&fontmanbox[1]);
																	dbshade(1,totalps?0:DBWRITEG|DBSHADEG,&fontmanbox[0]);
                 break;
    
    case MAPMODE:
                 dbshade(1,totalmap?0:DBWRITEG|DBSHADEG,&fontmanbox[1]);
																	dbshade(1,totalmap?0:DBWRITEG|DBSHADEG,&fontmanbox[0]);
                 break;
 }

 return(NULL);

}




static dbiconstr fontmanicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,

    8, NULL,         DBACTION, 1,   0,      0,  0,  0,  0,(dbreadfn)fontmanprev,0,
   10, NULL,         DBACTION, 1,   0,      0,  0,  0,  0,(dbreadfn)fontmannext,0,
   19, NULL,         DBACTION, 1,   0,      0,  0,  0,  0,(dbreadfn)fontmanend,0,
   14, NULL,         DBACTION, 1,   0,      0,  0,  0,  0,(dbreadfn)fontmanstart,0,
   
    9, NULL,         DBACTION, 0,   0,      0,  0,  0,  0,(dbreadfn)fontmannew,0,
    7, NULL,         DBACTION, 1,   0,      0,  0,  0,  0,(dbreadfn)fontmandelete,0,
   11, NULL,         DBACTION, 1,   0,      0,  0,  0,  0,(dbreadfn)fontmandup,0,
   
    6, NULL,         DBACTION, 0,   0,      0,  0,  0,  0,(dbreadfn)savefontman,0,
   13, NULL,         DBACTION, 0,   0,      0,  0,  0,  0,(dbreadfn)savefontmanas,0,

 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */



   15, &fontmanmode,    DBRADIO,0,    0,IGMODE,0,1,0,    (dbreadfn)optfn,   0,
   16, &fontmanmode,    DBRADIO,0,    0,REPMODE,0,1,0,   (dbreadfn)optfn,   0,
   17, &fontmanmode,    DBRADIO,0,    0,MAPMODE,0,1,0,   (dbreadfn)optfn,   0,
// 20, &fontmanmode,    DBRADIO,0,    0,PSMODE,0,1,0,    (dbreadfn)optfn,   0,

			18, &fontmantotal,   DBTEXT, 1,  0,      0,  0,  0,   0,   NULL,wrtotal,

    -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr fontmanbox[2]=
{
 0,
 TFONTMAN,
 DBFIX,
 0,
 fontmanclose,
 NULL,
 NULL,
 NULL,
 fontmanicondefs,
 0,
 0,
 0,NULL,
 0,
 0,


 0,
 TFONTMANREP,
 DBPANE,
 0,
 NULL,
 NULL,
 NULL,
 NULL,
 NULL,
 0,
 0,
 0,NULL,
 0,
 0,
};




void openfontman(int fp)
{
 os_error * err;


 err=NULL;

 cview=menuview;
 oldmode=fontmanmode;

 if(fontmanbox[0].handle)
 {
  dboxforward(fontmanbox);
 }
 else
 {
//  err=savemacros();
  if(!err)
  {


   xfontmaplen=fontmaplen;
   activemap=fontmapactive;
   ptrmap=0;
   currentmap=0;
   if(fontmaps)
   {
    err=flex_alloc((flex_ptr)&xfontmaps,fontmaplen);
    if(!err) memcpy(xfontmaps,fontmaps,fontmaplen);
    if(!err) totalmap=mapcount(fontmaps,fontmaplen);
   }
   else
   {
    err=flex_alloc((flex_ptr)&xfontmaps,0);
    xfontmaplen=0;
    totalmap=0;
   }

   xfontignorelen=fontignorelen;
   activeig=fontignoreactive;
   ptrig=0;
   currentig=0;
   if(fontignores)
   {
    err=flex_alloc((flex_ptr)&xfontignores,fontignorelen);
    if(!err) memcpy(xfontignores,fontignores,fontignorelen);
    if(!err) totalig=igcount(fontignores,fontignorelen);
   }
   else
   {
    err=flex_alloc((flex_ptr)&xfontignores,0);
    xfontignorelen=0;
    totalig=0;
   }


   xfontreplacelen=fontreplacelen;
   activerep=fontreplaceactive;
   ptrrep=0;
   currentrep=0;
   if(fontreplaces)
   {
    err=flex_alloc((flex_ptr)&xfontreplaces,fontreplacelen);
    if(!err) memcpy(xfontreplaces,fontreplaces,fontreplacelen);
    if(!err) totalrep=repcount(fontreplaces,fontreplacelen);
   }
   else
   {
    err=flex_alloc((flex_ptr)&xfontreplaces,0);
    xfontreplacelen=0;
    totalrep=0;
   }


   
   xfontpostscriptlen=fontpostscriptlen;
   activeps=fontpostscriptactive;
   ptrps=0;
   currentps=0;
   if(fontpostscript)
   {
    err=flex_alloc((flex_ptr)&xfontpostscript,fontpostscriptlen);
    if(!err) memcpy(xfontpostscript,fontpostscript,fontpostscriptlen);
    if(!err) totalps=pscount(fontpostscript,fontpostscriptlen);
   }
   else
   {
    err=flex_alloc((flex_ptr)&xfontpostscript,0);
    xfontpostscriptlen=0;
    totalps=0;
   }
   
   
   
   
   switch(fontmanmode)
   {
    case  IGMODE:
                 fontmanbox[1]=igbox;
                 break;

    case REPMODE:
                 fontmanbox[1]=repbox;
                 break;

    case  PSMODE:
                 fontmanbox[1]=psbox;
                 break;

    case MAPMODE:
                 fontmanbox[1]=mapbox;
                 mapopen();
                 break;
   }

   err=dodboxspparent(fontmanbox,2,fontmanbox,&fontmandbstack,cview->handle);
   if(!err) 
   {
				checkshade();
   }
  }
 }

 zreport(err);
 USE(fp);
}


