/*->h.spell */


#define DCNAMELEN 20

#define SPMAXLEN  32


typedef struct 
{
 char         name[DCNAMELEN];
 int          dict;
 short    int uses;
 unsigned int loaded:1;
 unsigned int modded:1;
 unsigned int current:1;
 unsigned int user:1;
} dlinestr;


extern dlinestr * dtable;
extern int        totnames;
extern int        hpdcno;


extern domainstr * ddomain;



typedef struct spdictstr
{
 char name[DCNAMELEN];
 int  index;
 unsigned int embedded:1;
 unsigned int addto:1;
 unsigned int ignore:1;
 unsigned int browse:1;

} spdictstr;



/* OSPELL object, one per document */

typedef struct spellstr
{
 int       key;
 int       type;

 int       nodc;

 int       spare;
 int       continuous;

 int       stuff[14];

 spdictstr spdict[1];

} spellstr;






extern os_error * spellinit(void);

extern os_error * loaddcn(int n);

extern os_error * dccleanup(void);

extern os_error * newdcmap(filestr * file);
extern os_error * copydcmap(filestr * sfile,filestr * dfile);

extern os_error * dcmap2dtable(filestr * file);
extern os_error * dtable2dcmap(filestr * file);
extern os_error * remfiledc(filestr * file);
extern os_error * addfiledc(filestr * file);

extern int finddc(char * name);

extern os_error * dcaddload(int n,int addto,int browse,filestr * file);


extern os_error * deletedict(int n);
extern os_error * createdict(char * string,int * index);


extern void spstripstring(char * dest,char * src,int destsize);

extern int checkhpdc(char * string,char * result,int minlen);

extern os_error * spsavechanges(void);
extern os_error * spscrapchanges(void);
extern int        spchanges(void);

extern char maindictionary[DCNAMELEN];
extern char userdictionary[DCNAMELEN];


