/*->c.styleif */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "font.h"
#include "transform.h"

#include "etc.h"
#include "err.h"
#include "crc.h"
#include "xext.h"
#include "bits.h"
#include "xmath.h"
#include "fsx.h"
#include "bf.h"
#include "deb.h"

#include "str.h"
#include "constants.h"

#include "reslink.h"
#include "xredraw.h"
#include "object.h"
#include "undo.h"

#include "xcolour.h"

#include "file.h"
#include "view.h"

#include "txstr.h"
#include "tx.h"
#include "sx.h"
#include "fx.h"
#include "codes.h"
#include "fox.h"
#include "tabs.h"
#include "style.h"
#include "ustyle.h"
#include "dbstyle.h"
#include "act.h"
#include "fl.h"
#include "vl.h"
#include "vec.h"
#include "texttool.h"
#include "txchoices.h"


#include "styleif.h"


/****************************************************************************/


int                  actpend;
static absstylestr   actpendstyle;
static filestr     * actpendfile;



static os_error * actsetpend(int state,filestr * file)
{
 cprintf("actsetpend %d",state);


 actpend=state;
 actpendfile=file;
 dupstylechain(actpendfile,actpendstyle.chain);
 duptabruler(actpendfile,actpendstyle.style.data.tab);
 return(NULL);
}


/* called on fonts changed too */

os_error * actclearpend(void)
{
 if(actpend)
 {
  actpend=0;
  remstylechain(actpendfile,actpendstyle.chain,1);
  remtabruler(actpendfile,actpendstyle.style.data.tab);
  txactstylechange(0x1);
 }
 return(NULL);
}



static os_error * pendstyle(xstylestr * style)
{
 int oldtab;

 oldtab=actpendstyle.style.data.tab;
 applystyle(&actpendstyle.style,style);
 duptabruler(actpendfile,actpendstyle.style.data.tab);
 remtabruler(actpendfile,oldtab);

 return(NULL);
}



static os_error * pendstripstyle(void)
{
 int oldtab;

 oldtab=actpendstyle.style.data.tab;
 styleclrall(&actpendstyle.style);
 fillinstyle(&actpendstyle,actpendfile);
 duptabruler(actpendfile,actpendstyle.style.data.tab);
 remtabruler(actpendfile,oldtab);

 return(NULL);
}




static os_error * pendremuserstyle(int usn)
{
 int newchain;
 int oldtab;

 remchainentry(usn,actpendstyle.chain,&newchain,actpendfile);
 if(newchain)
 {
  remstylechain(actpendfile,actpendstyle.chain,1);
  actpendstyle.chain=newchain;
  oldtab=actpendstyle.style.data.tab;
  fillinstyle(&actpendstyle,actpendfile);
  duptabruler(actpendfile,actpendstyle.style.data.tab);
  remtabruler(actpendfile,oldtab);
 }

 return(NULL);
}





static os_error * pendadduserstyle(int usn)
{
 int newchain;
 int oldtab;

 addchainentry(usn,actpendstyle.chain,&newchain,actpendfile);
 if(newchain)
 {
  remstylechain(actpendfile,actpendstyle.chain,1);
  actpendstyle.chain=newchain;
  oldtab=actpendstyle.style.data.tab;
  fillinstyle(&actpendstyle,actpendfile);
  duptabruler(actpendfile,actpendstyle.style.data.tab);
  remtabruler(actpendfile,oldtab);
 }

 return(NULL);
}


static os_error * pendadduserstyletoggle(int usn)
{
 os_error * err;
 int        chainn;
 int      * chainp;
 int        i;


 err=findstylechainp(actpendfile,actpendstyle.chain,&chainp,&chainn);

 for(i=0;i<chainn;i++)
 {
  if(chainp[i]==usn) break;
 }

 if(i<chainn && (usn!=BODYTEXT || i!=(chainn-1)))
 {
  err=pendremuserstyle(usn);
 }
 else
 {
  err=pendadduserstyle(usn);
 }

 return(err);
}





static os_error * stylepends(xstylestr * style,int type,int state)
{
 os_error * err;

 err=NULL;

 if(!actpend)
 {
  err=getcaretstylex(&act,&actpendstyle);
  actsetpend(state,act.file);
 }

 switch(type)
 {
     case    STXEFX:
                    err=pendstyle(style);
                    break;

     case STXADDUSR:
                    err=pendadduserstyletoggle((int)style);
                    break;

     case STXREMUSR:
                    err=pendremuserstyle((int)style);
                    break;

      case STXSTRIP:
                    err=pendstripstyle();
                    break;
 }

 txactstylechange(0x1);

 return(err);
}



static os_error * stylepend(xstylestr * style,int type)
{
 if(actpend==PENDSSHIFT) actclearpend();
 return(stylepends(style,type,PENDSTYLE));
}


os_error * stylependflush(int * snp,int * after)
{
 if(actpend)
 {
  *after=(actpend==PENDSSHIFT);
  addabsstyle(act.file,&actpendstyle,1);
  *snp=actpendstyle.style.n;
  actclearpend();
 }
 else
 {
  *after=*snp=0;
 }

 return(NULL);
}


os_error * stylependflushpost(int sn,int after)
{
 if(sn)
 {
  remabsstyle(act.file,sn);
 }
 return(NULL);
 USE(after);
}



os_error * txsshiftclear(void)
{
 if(actpend==PENDSSHIFT) actclearpend();

 return(NULL);
}



os_error * txsshiftstart(void)
{
 os_error * err;
 xstylestr  style;
 int        ssbold;
 int        ssitalic;
 int        font;

 err=NULL;
 font=findxuserfontstyle(ssfontname,&ssbold,&ssitalic);
 if(font<0) err=geterror(ESSF);
 else
 {
  actclearpend();

  memset(&style,0,sizeof(xstylestr));
  style.action.font=1;
  style.action.italic=1;
  style.action.bold=1;
  style.data.font=font;
  style.data.bold=ssbold;
  style.data.italic=ssitalic;

  stylepends(&style,STXEFX,PENDSSHIFT);
 }

 return(err);
}


os_error * txfixstyle(xstylestr * style)
{
 actclearpend();
 stylepends(style,STXEFX,PENDSSHIFT);

 return(NULL);
}




/*****************************************************************************/


static os_error * findcommonstyles(filestr * file,int chainkey,
                    int * commonstyles,int * commonnp,vector * v1,vector * v2)
{
 os_error    * err;
 int           s;
 int           e;
 int           chain[MAXCHAIN];
 int           chainn;
 int           commonn;
 int           c;
 int           bits;
 int           sn;
 char        * p;
 int           i;
 int           j;
 int           wr;
 absstylestr * stylep;



 err=findstylechains(file,chainkey,commonstyles,&commonn);

 if(v2)
 {
  s=v1->textsrc.offset;
  e=v2->textsrc.offset;

  cprintf("s %d e %d",s,e);

  while(s<e)
  {
   p=txptr(v1->textsrc.sourcep,s);
   c=*p;
   bits=codex[c];
  
   if(c==SNO)
   {
    sn=(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16);
    cprintf("sno %d",sn);
    
    findabsstylep(act.file,sn,&stylep);
    findstylechains(act.file,stylep->chain,chain,&chainn);

    wr=0;
    for(i=0;i<commonn;i++)
    {
     for(j=0;j<chainn;j++)
     {
      if(chain[j]==commonstyles[i]) break;
     }

     if(j<chainn)
     {
      commonstyles[wr++]=commonstyles[i];
     }
    }
    commonn=wr;
   }
   s+=bits & CODELEN;
  }
 }

 *commonnp=commonn;

 return(err);
}














/*

  change of style
  if(zone)
  {
   if(para attribute)
   {
    apply style across paras spanned by zone
   }
   else
   {
    apply style across zone
   }
  }
  else
  {
   if(para attributes)
   {
    apply style across current para
   }
   else
   {
    apply style across caret
   }
  }

  get style at end, and put in code
  get style at start, and put in code

*/




int styleprevcode(vector * s)
{
 int offset;
 int c;
 int c1;
 int lastsn;

 c=c1=*txptr(s->textsrc.sourcep,s->textsrc.offset);
 if(c!=SNO)
 {
  offset=s->textsrc.loffset;
  lastsn=-1;

  while(1)
  {
   c=*txptr(s->textsrc.sourcep,offset);

   if(c!=SNO) lastsn=-1;
   else
   if(lastsn<0) lastsn=offset;

   offset+=codex[c] & CODELEN;
   if(offset>=s->textsrc.offset) break;
  }

  if(lastsn>=0) s->textsrc.offset=lastsn;
  else          c=c1;
 }

 return(c);
}



/* apply the style, act bits show what to change */

static os_error * styleop2(vector * s,vector * e,xstylestr * style,int type)
{
 os_error      * err;
 int             oldssn;         /* style at start, before any changes */
 int             oldesn;         /* style at end,   before any changes */
 char          * p;
 int             c;
 filestr       * file;
 undostylestr    uss;
 texsub        * texup;
 vlstr         * vl;


 file=s->file;


/* dprintf(2,"styleop2");  */




 err=undostylemapstart(file,&uss);


/* dprintf(3,"s loffset=%d offset=%d",s->textsrc.loffset,s->textsrc.offset); */

 if(!err) err=txlock(&s->textsrc,file);
 if(!err)
 {
  txmodvec(s);
  getstylev(s,0,&oldssn);

  /* if s points at a sno - do nothing     */
  /* if s follows a sno, move it backwards */

  c=styleprevcode(s);



  if(c!=SNO)  /* if not leave s one code back */
  {
   txsourceinsertsn(oldssn,1,&s->textsrc,file);

   undostylemapadd(file,&uss,s->textsrc.offset,0);

   /* needed because delta not kept track of */

   texup=(texsub*)(((char*)s->textsrc.textp)+s->textsrc.usize);
   texup[s->textsrc.s].bytes+=SNLEN;


   if(s->textsrc.voffset<s->textsrc.vsourcep->len)  // changed to prevent access past end of vl buffer
   {
    vl=vlptr(s->textsrc.vsourcep,s->textsrc.voffset);
    vl->line.len+=SNLEN;
   }

   if(s[0].textsrc.offset<s[1].textsrc.offset) s[1].textsrc.offset+=SNLEN;
   e[0].textsrc.offset+=SNLEN;
   e[1].textsrc.offset+=SNLEN;
   if(e[0].textsrc.loffset>s[0].textsrc.loffset) e[0].textsrc.loffset+=SNLEN;
   if(e[1].textsrc.loffset>s[0].textsrc.loffset) e[1].textsrc.loffset+=SNLEN;
  } 
  else
  if(e[0].textsrc.offset==s[0].textsrc.offset)
  {
   e[0].textsrc.offset+=SNLEN;
   e[1].textsrc.offset+=SNLEN;
  }

  txunlock(&s->textsrc,file);
 }




 if(!err) err=txlock(&e->textsrc,file);
 if(!err)
 {
  getstylev(e,0,&oldesn);

  /* if e points at a sno do nothing */

  p=txptr(e->textsrc.sourcep,e->textsrc.offset);
  if(*p!=SNO && *p!=EOT)
  {
   txsourceinsertsn(oldesn,1,&e->textsrc,file);

   undostylemapadd(file,&uss,e->textsrc.offset,0);

   /* needed because delta not kept track of */


   texup=(texsub*)(((char*)e->textsrc.textp)+e->textsrc.usize);
   texup[e->textsrc.s].bytes+=SNLEN;

   if(e->textsrc.voffset<e->textsrc.vsourcep->len)  // changed to prevent access past end of vl buffer
   {
    vl=vlptr(e->textsrc.vsourcep,e->textsrc.voffset);
    vl->line.len+=SNLEN;
   }
  }

  txunlock(&e->textsrc,file);
 }


 if(!err)
 {
  switch(type)
  {
      case   STXEFX:
                    err=applystylev(s,e,style,&uss);
                    break;

     case STXADDUSR:
                    err=adduserstylev(s,e,(int)style,&uss);
                    break;

     case STXREMUSR:
                    err=remuserstylev(s,e,(int)style,&uss);
                    break;

      case STXSTRIP:
                    err=stripstylev(s,e,&uss,style);
                    break;
  }
 }

 undostylemapend(file,&uss);

 txactstylechange(0x1);

 return(err);
}



/* tagged to USTYLES */
/* this function is always called last in undo/redo */

os_error * ustyles(filestr * file) 
{
 vector     s;
 flowstr    fl;
 int        offset[2];
 int        loffset;
 int        hoffset;
 int        cdelta;
 os_error * err;

 undoread(file,offset,2*sizeof(int));

 txundoend(&loffset,&hoffset,&cdelta,file);

 /* the problem here is seeing how big an area is changed */
 /* if only one SNO is changed, hoffset is close loffset  */
 /* but the effects may run to the end of the story       */


 /* this is a quick fix - it may be there are no changes, in which case */
 /* loffset<0, movevector() will then hang                              */
 /* no changes? apply a user style twice                                */

 if(loffset<0)
 {
  loffset=hoffset=offset[0];
 }



 s=act;
 movevector(&s,loffset);    /* handles locking vector itself */

 fl.opcode=FDATA|FSUB;
/* if(backflow) fl.opcode|=FLPREV; */

 fl.data.type=FLDIRTY;
 fl.data.offset=loffset;
 fl.data.delta=cdelta;
 fl.data.length=hoffset-loffset;


 if(zone)
 {
  fl.opcode|=FLV0|FLV1;

  if(offset[1]<offset[0])
  {
   fl.roff[0]=offset[1];
   fl.roff[1]=offset[0];
  }
  else
  {
   fl.roff[0]=offset[0];
   fl.roff[1]=offset[1];
  }

  fl.resultv[0]=lozon;
  fl.resultv[1]=hizon;
 }
 else
 {
  fl.opcode|=FLV0;
  fl.roff[0]=offset[0];
  fl.resultv[0]=&s;
 }

 flow(&s,&fl);

 if(zone)
 {


 }
 else
 {
  err=txlock(&s.textsrc,s.file);

  setxa(&s);
  setactive(&s);
  screencaret(&s);

  txunlock(&s.textsrc,s.file);
 }

 undowritefn(file,USTYLEF,NULL,0);

 txactstylechange(0x1);

 return(NULL);
}


/* tagged to USTYLEF */
/* this function is always first in undo/redo */

os_error * ustylef(filestr * file)
{
 int temp[2];

 temp[0]=act.textsrc.offset;
 temp[1]=zon.textsrc.offset;

 undowritefn(file,USTYLES,temp,2*sizeof(int));
 txundostart(&act.textsrc,file);
 return(NULL);
}



static os_error * styleopsetup(vector * s,vector * e,
                                       xstylestr * nstyle,int * type,int scope)
{
 os_error   * err;
 int          chain[MAXCHAIN];
 int          chainn;
 absstylestr  style;
 filestr    * file;
 int          i;


 file=act.file;

 if(zone)
 {
  s[0]=*lozon;
  e[0]=*hizon;
 }
 else
 {
  s[0]=act;
  e[0]=act;
 }

 s[1]=s[0];
 e[1]=e[0];

 err=txlock(&s->textsrc,file);
 if(!err)
 {
  switch(scope)
  {
   case SCOPECURRK:
                   if(!zone) prevch(s,NULL);
                   break;

   case SCOPECURR:
          default:
                  break;

   case SCOPEPARA:
                  /*dprintf(4,"settosop"); */
                  settosop(s);
                  break;

   case SCOPEWORD:
                  /*dprintf(4,"settosow"); */
                  if(!zone || midword(s)) settosow(s);
                  break;

   case SCOPELINE:
//                  cprintf("set sol %d",s->textsrc.loffset);
                  settosol(s);
                  break;

   case SCOPESTORY:
                  settosot(s);
                  break;


  }

  txunlock(&s->textsrc,file);
 }


 if(!err) err=txlock(&e->textsrc,file);
 if(!err)
 {
  switch(scope)
  {
  case SCOPECURRK:
                  if(!zone) nextch(e,NULL);
                  break;

   case SCOPECURR:
          default:
                  break;


   case SCOPEPARA:
                  settosnpx(e);      /* was eop */
                  break;

   case SCOPEWORD:
                  if(!zone || midword(e)) settoeow(e);
                  break;

   case SCOPELINE:
                  // 0 in eol means any LF at line end has style applied to it
                  // problem with applying the style before this LF is that repeated
                  // style applications don't toggle and instead keep adding style codes
                  // at end of line
                  settoeol(e,0);
                  break;

  case SCOPESTORY:
                  settoeot(e);
                  break;


  }

  txunlock(&e->textsrc,file);
 }


 if(*type==STXADDUSR)
 {
  err=txlock(&s->textsrc,file);
  if(!err)
  {
   getcaretstyleinc(s,&style);

   findcommonstyles(file,style.chain,chain,&chainn,s,e);

   for(i=0;i<chainn;i++)
   {
    if(chain[i]==(int)nstyle) break;
   }

//   cprintf("i=%d chainn %d hit %d",i,chainn,i<chainn && (((int)nstyle)!=BODYTEXT || i!=(chainn-1)));

   if(i<chainn && (((int)nstyle)!=BODYTEXT || i!=(chainn-1))) *type=STXREMUSR;

   err=txunlock(&s->textsrc,file);
  }
 }

 return(err);
}





os_error * styleop(xstylestr * style,int type,int scope)
{
 os_error  * err;
 vector      s[2];
 vector      e[2];
 vector      v;
 flowstr     fl;
 int         temp[2];


 err=modfile(act.file,act.section);
 if(!err)
 {
  if(!zone && scope==SCOPECURR) 
  {
   err=stylepend(style,type);
  }
  else
  {
   actclearpend();

   err=styleopsetup(s,e,style,&type,scope);
   if(!err && type!=STXNONE)
   {
    err=undostart(act.file);
    if(!err)
    {
     temp[0]=act.textsrc.offset;
     temp[1]=zon.textsrc.offset;

     undowritefn(act.file,USTYLES,temp,2*sizeof(int));



     err=styleop2(s,e,style,type);

     if(!err)
     {
      if(zone) 
      {
       hizon->textsrc.offset=e[1].textsrc.offset;
       lozon->textsrc.offset=s[1].textsrc.offset;
      }
      else
      {
       act.textsrc.offset=e[1].textsrc.offset;
      }


      if(zone || scope!=SCOPECURR)
      {
       fl.opcode=FDATA|FSUB;
       fl.data.type=FLDIRTY;
       fl.data.offset=s[0].textsrc.offset;
       fl.data.delta=0;
       fl.data.length=e[0].textsrc.offset-s[0].textsrc.offset;

       if(zone)
       {
        fl.opcode|=FLV0|FLV1;
        fl.roff[0]=lozon->textsrc.offset;
        fl.roff[1]=hizon->textsrc.offset;
        fl.resultv[0]=lozon;
        fl.resultv[1]=hizon;
       }
       else
       {
        fl.opcode|=FLV0;
        v=act;
        fl.roff[0]=act.textsrc.offset;
        fl.resultv[0]=&v;
       }



       flow(s,&fl);

       if(zone)
       {

  
       }
       else
       {
        err=txlock(&v.textsrc,v.file);
      
        setxa(&v);
        setactive(&v);
        screencaret(&v);
       
        txunlock(&v.textsrc,v.file);
       }
      }
     }

     undowritefn(act.file,USTYLEF,NULL,0);
     undoend(act.file);
    }
   }
  }
 }
 return(err);
}





/* apply the style, act bits show what to change */

os_error * settextstyle(filestr * file,xstylestr * style,int scope)
{
 os_error * err;

 err=NULL;

 if(act.valid && act.file==file)
 {
  err=styleop(style,STXEFX,scope);
 }

 return(err);
}


/* void cleareffects(int scope); */

void cleareffects(int fp)
{
 if(act.valid && act.file==menufile)
 {
  zreport(styleop(NULL,STXSTRIP,stack[fp]));
 }
}



/* input rank of style in stylebase */

static os_error * addstylen(int rank,filestr * file)
{
 os_error          * err;
 int                 ustyles;
 userstylebasestr  * stylebase;
 int                 usn;
 int                 scope;
 int                 n;

 ustyles=file->hdr.ustyles;
 stylebase=(userstylebasestr*)fob_find(ustyles,file);

 n=styleindex(stylebase,rank);

 usn=stylebase->userstyle[n].style.n;
 scope=stylebase->userstyle[n].scope;

 err=styleop((xstylestr*)usn,STXADDUSR,scope);

 return(err);
}


/* void addstyle(int n); */

void addstyle(int fp)
{
 if(act.valid && act.file==menufile)
 {
  addstylen(stack[fp],menufile);
 }
}



os_error * stylekey(int * key)
{
 os_error         * err;
 int                ch;
 int                usn;
 int                scope;

 err=NULL;
 ch=*key;

 if(ch>0 && act.valid && act.file==menufile)
 {
//  cprintf("stylekey %x",ch);
  
  usn=ustylekey(ch,&scope,menufile);
  if(usn)
  {
//   cprintf("usn %d",usn);

   err=styleop((xstylestr*)usn,STXADDUSR,scope);
   *key=-1;
  }
 }

 return(err);
}



/*

n is an index into the total styles
void remstyle(int n);

*/          


static int commonstyles[MAXCHAIN];
static int commonn;
static int totalstyles[MAXCHAIN];
static int totaln;




static os_error * getcommonstyles(void)
{
 os_error      * err;
 absstylestr     style;

 vector          s;

 err=NULL;

 commonn=0;

 if(act.valid)
 {
  if(zone) s=*lozon;
  else     s=act;

  err=txlock(&s.textsrc,s.file);
  if(!err)
  {
   if(zone) err=getcaretstyleinc(&s,&style);
   else
   {
    if(actpend)  style=actpendstyle;
    else         err=getcaretstyle(&s,&style);
   }

   findcommonstyles(s.file,style.chain,commonstyles,&commonn,&s,
                                                             zone?hizon:NULL);
   txunlock(&s.textsrc,s.file);
  }
 }
 return(err);
}





static os_error * gettotalstyles(int excluding)
{
 os_error      * err;
 absstylestr     style;
 absstylestr   * stylep;
 int             chain[MAXCHAIN];
 int             chainn;
 int             s;
 int             e;
 int             c;
 int             bits;
 int             sn;
 char          * p;
 int             i;
 int             j;

 err=NULL;

 totaln=0;

 if(act.valid)
 {
  err=txlock(&act.textsrc,act.file);
  if(!err)
  {
   if(zone) err=getcaretstyleinc(&act,&style);
   else
   {
    if(actpend)  style=actpendstyle;
    else         err=getcaretstyle(&act,&style);
   }

   if(!err)
   {
    err=findstylechains(act.file,style.chain,totalstyles,&totaln);

    if(excluding)
    {
     j=0;
     for(i=0;i<totaln;i++)
     {
      if(totalstyles[i]!=BODYTEXT || ((excluding==2) && i!=(totaln-1)))
      {
       if(i!=j) totalstyles[j]=totalstyles[i];
       j++;
      }
     }
     totaln=j;
    }
   }

   if(zone)
   {    /* scan across zone, get styles, find total chain entries */
    s=lozon->textsrc.offset;
    e=hizon->textsrc.offset;

    while(s<e)
    {
     p=txptr(act.textsrc.sourcep,s);
     c=*p;
     bits=codex[c];

     if(c==SNO)
     {
      sn=(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16);
      findabsstylep(act.file,sn,&stylep);
      findstylechains(act.file,stylep->chain,chain,&chainn);

      for(j=0;j<chainn;j++)
      {
       if((excluding==2) && 
          j!=(chainn-1) && chain[j]==BODYTEXT) excluding=0;

       if(!excluding || chain[j]!=BODYTEXT)
       {
        for(i=0;i<totaln;i++)
        {
         if(chain[j]==totalstyles[i]) break;
        }

        if(i>=totaln)
        {
         totalstyles[totaln++]=chain[j];
        }
       }
      }
     }
     s+=bits & CODELEN;
    }
   }

   txunlock(&act.textsrc,act.file);

  }
 }
 return(err);
}



/* n index into total styles */

void remstyle(int fp)
{
 int            n;
 int            usn;
 int            scope;
 userstylestr * s;

 if(act.valid && act.file==menufile)
 {
  n=stack[fp];

  if(n>=0 && n<totaln)
  {
   usn=totalstyles[n];

   finduserstylep(&s,usn,menufile);
   scope=s->scope;
   zreport(styleop((xstylestr*)usn,STXREMUSR,scope));
  }
 }

 USE(fp);
}



/* n is an index into user styles   */
/* int iscurrentstyle(int n);       */                 
/* is this in the common styles     */

int iscurrentstyle(int fp)
{
 os_error          * err;
 int                 n;
 userstylebasestr  * stylebase;
 int                 i;
 int                 styles;

 err=NULL;

 n=stack[fp];

 if(act.valid && act.file==menufile)
 {
  if(n==0)
  {
   err=getcommonstyles();
  }

  if(!err)
  {
   styles=menufile->hdr.ustyles;
   stylebase=(userstylebasestr*)fob_find(styles,menufile);
   n=styleindex(stylebase,n);
   if(stylebase && n<stylebase->n)
   {
    n=stylebase->userstyle[n].style.n;

    /* n is now a key value */
   }

   for(i=0;i<commonn;i++) 
     if(commonstyles[i]==n) return(1);
  }
 }

 zreport(err);

 return(0);
}




/* int getcurrentstyle(int i,string & s,int excluding); */

int getcurrentstyle(int fp)
{
 os_error * err;
 userstylestr style;
 int      i;

 err=NULL;

 if(act.valid && act.file==menufile)
 {
  i=stack[fp];

  if(i==0)
  {
   err=gettotalstyles(stack[fp+2]);
  }

  if(i<totaln)
  {
   finduserstyle(&style,totalstyles[i],menufile);
   assignstring(stack[fp+1],style.name);
   return(totalstyles[i]);
  }
 }

 zreport(err);

 return(0);
}




int getcurrentuserstyle(int i)
{

 if(i==0)
 {
  gettotalstyles(0);
 }

 if(i<totaln)
 {
  return(totalstyles[i]);
 }
 else
  return(-1);
}



int curpageno(int fp)
{
 int       page;
 pagestr * pagep;

 if(act.valid && menufile==act.file) page=act.page;
 else                                page=menuview->dpage;

 pagep=(pagestr*)fob_find(page,menufile);
 return(pagep->data.number);

 USE(fp);
}


int cursectionno(int fp)
{
 int          section;
 sectionstr * sectionp;

 if(act.valid && menufile==act.file) section=act.section;
 else                                section=menuview->dsection;

 sectionp=(sectionstr*)fob_find(section,menufile);
 return(sectionp->data.number+1);

 USE(fp);
}


int caretchar(int fp)
{
 os_error * err;
 int        c;
	int        cv;
 vector     s;

 if(act.valid && menufile==act.file)
 {
  s=act;

  err=txlock(&s.textsrc,s.file);
  if(!err)
  {
   c=nextch(&s,&cv);
   txunlock(&s.textsrc,s.file);
   return(c);
  }
 }

 return(-1);

 USE(fp);
}




int prevchar(int fp)
{
 os_error * err;
 int        c;
	int        cv;
 vector     s;

 if(act.valid && menufile==act.file)
 {
  s=act;

  err=txlock(&s.textsrc,s.file);
  if(!err)
  {
   c=prevch(&s,&cv);
   txunlock(&s.textsrc,s.file);
   return(c);
  }
 }

 return(-1);

 USE(fp);
}

/***************************************************************************/
/* get the current style                                  */
/* if(zone), then act flags show what is common across it */
/* else      all  act flags are true                      */


os_error * gettextstyle(filestr * file,xstylestr * xstyle)
{
 os_error    * err;
 vector        s;
 int           c;
 char        * p;
 absstylestr * rstyle;
 absstylestr   style;
 int           sn;
 int           bits;

 err=NULL;


 if(act.valid && act.file==file)
 {
  if(zone)
  {
   s=*lozon;
   err=txlock(&s.textsrc,s.file);
   if(!err)
   {
    err=getcaretstyleinc(&s,&style); /* scan zone, looking for style codes */
    stylesetall(&style.style);
    while(s.textsrc.offset<hizon->textsrc.offset)
    {
     p=txptr(s.textsrc.sourcep,s.textsrc.offset);
     c=*p;
     bits=codex[c];

     if(c==SNO)
     {
      sn=(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16);
      findabsstylep(file,sn,&rstyle);

      stylediffbits(&style.style,&rstyle->style);
     }
 
     s.textsrc.offset+=bits & CODELEN;
    }
    txunlock(&s.textsrc,s.file);
   }
  }
  else
  {
   if(actpend)  style=actpendstyle;
   else         getcaretstylex(&act,&style);
   stylesetall(&style.style);
  }

  *xstyle=style.style;
 }

 return(err);
}




os_error * gettexteffects(filestr * file,xstylestr * xstyle)
{
 os_error    * err;
 vector        s;
 int           c;
 char        * p;
 absstylestr * rstyle;
 absstylestr   style;
 int           sn;
 int           bits;


 err=NULL;


 if(act.valid && act.file==file)
 {
  if(zone)
  {
   s=*lozon;
   err=txlock(&s.textsrc,s.file);
   if(!err)
   {
    err=getcaretstyleinc(&s,&style); /* scan zone, looking for style codes */
    while(s.textsrc.offset<hizon->textsrc.offset)
    {
     p=txptr(s.textsrc.sourcep,s.textsrc.offset);
     c=*p;
     bits=codex[c];

     if(c==SNO)
     {
      sn=(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16);
      findabsstylep(file,sn,&rstyle);

      styleorrbits(&style.style.action,&style.style.action,
                                      &rstyle->style.action);
     }

     s.textsrc.offset+=bits & CODELEN;
    }
    txunlock(&s.textsrc,s.file);
   }
  }
  else
  {
   if(actpend)  style=actpendstyle;
   else         getcaretstylex(&act,&style);
  }

  *xstyle=style.style;
 }

 return(err);
}


