/*->c.textr */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>
#include <limits.h> 

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "font.h"
#include "transform.h"
#include "xprocess.h"


#include "err.h"
#include "xmath.h"
#include "fsx.h"
#include "xext.h"
#include "poll.h"
#include "alloc.h"
#include "trans.h"
#include "colour.h"
#include "etc.h"
#include "bf.h"
#include "sp.h"
#include "deb.h"
#include "osunits.h"


#include "constants.h"
#include "str.h"
#include "obj.h"
#include "object.h"


#include "geometry.h"

#include "viewr.h"
#include "view.h"
#include "file.h"
#include "chain.h"
#include "posn.h"

#include "select.h"

#include "editpath.h"
#include "objectdb.h"
#include "undo.h"
#include "units.h"

#include "xcolour.h"
#include "border.h"
#include "xredraw.h"
#include "curve.h"
#include "chain.h"

#include "pxstr.h"
#include "pict.h"
#include "impex.h"

#include "frameflow.h"
#include "section.h"
#include "fillstub.h"


#include "txstr.h"
#include "tx.h"
#include "sx.h"
#include "txprivate.h"
#include "fx.h"
#include "vl.h"
#include "vi.h"
#include "fl.h"
#include "fl2.h"
#include "style.h"
#include "ustyle.h"
#include "caret.h"
#include "vec.h"
#include "act.h"
#include "texttool.h"
#include "codes.h"
#include "hp.h"
#include "blank.h"
#include "link.h"
#include "spell.h"
#include "fmap.h"
#include "fox.h"
#include "fcache.h"
#include "mx.h"
#include "dbtext.h"
#include "dbstyle.h"
#include "txchoices.h"
#include "stylemap.h"
#include "index.h"
#include "txds.h"

#include "text.h"

#include "textr.h"





void dohf(textboxstr * textp,int page,int * doheader,
                                      int * dofooter,filestr * file) 
{
 pagestr    * pagep;
 sectionstr * sectionp;

 *doheader=*dofooter=1;

 if((textp->data.header || textp->data.footer) && 
                           textp->data.repeat && !textp->fchain.prev)
 {
  if(!page) page=pageof((chainobject*)textp,file);

  pagep=(pagestr*)fob_find(page,file);
  if(!pagep->chain.prev && !pagep->branch)
  {
   sectionp=(sectionstr*)fob_find(pagep->section,file);

   if(sectionp->data.pagenumber.omitheader) *doheader=0;
   if(sectionp->data.pagenumber.omitfooter) *dofooter=0;
  }
 }
}




int guttersize(columnstr * ccol,int columns,int width)
{
 int        gutter;

 if(ccol->mode)
 {
  if(columns>1) gutter=(width-columns*ccol->width)/(columns-1);
  else          gutter=(width-ccol->width);

  if(gutter<0)  gutter=0; /* column too wide */
 }
 else           gutter=ccol->width;

 return(gutter);
}



os_error * settextoffset(filestr * file,textboxstr * textp,
                                                   int * vloffp,int * offsetp)
{
 os_error * err;
 int        vloff;
 int        offset;
 int        n;
 int        usize;
 texsub   * texup;

 err=NULL;

 vloff=0;
 offset=0;

 while(textp->fchain.prev)
 {
  textp=(textboxstr*)fob_find(textp->fchain.prev,file);
  n=textp->data.columns;

  if(textp->data.header || textp->data.footer) 
     usize=sizeof(textboxstr)+3*sizeof(texsrc)+sizeof(texhdr)+2*sizeof(texsub);
  else 
     usize=sizeof(textboxstr)+sizeof(texsrc);

  texup=(texsub*)(((char*)textp)+usize);

  while(n--)
  {
   vloff+=texup[n].vlines;
   offset+=texup[n].bytes;
  }
 }

 *vloffp=vloff;
 *offsetp=offset;

 return(err);
}


static void getclipbox(viewredrawstr * v,textboxstr * text,aboxstr * cbox)
{
 aboxstr box;

 box.x0=v->xlos;
 box.x1=v->xhis;
 box.y0=v->ylos;
 box.y1=v->yhis;

// cprintf("clip in y0=%d y1=%d",v->ylos,v->yhis); 

 getmaxinvabox(cbox,&box,&text->data.transform);

// cprintf("clip xx y0=%d y1=%d fy=%d",cbox->y0,cbox->y1,text->fcurve.box.y);

 cbox->x0-=text->fcurve.box.x;
 cbox->x1-=text->fcurve.box.x;
 cbox->y0-=text->fcurve.box.y;
 cbox->y1-=text->fcurve.box.y;
}


/* is the line in the clip box ? */

static int clipline(vlstr * line,aboxstr * cbox)
{
/*
 cprintf("line x=%d w=%d y=%d h=%d",
           line->line.x,line->line.w,LY(line->line.yy),line->line.h);
 cprintf("box  x0=%d x1=%d y0=%d y1=%d",
           cbox->x0,cbox->x1,cbox->y0,cbox->y1);
 
 cprintf("res =%d %d %d %d",
        (int)line->line.x<=cbox->x1 ,(int)(line->line.x+line->line.w)>=cbox->x0 ,
   (int)LY(line->line.yy)<=cbox->y1 , (int)(LY(line->line.yy)+line->line.h)>=cbox->y0); 
*/

 return((int)line->line.x<=cbox->x1 && (int)(line->line.x+line->line.w)>=cbox->x0 &&
   (int)LY(line->line.yy)<=cbox->y1 && (int)(LY(line->line.yy)+line->line.h)>=cbox->y0);
}



static os_error * markline(vlstr * vline,int offset,int noffset,
             int fill,viewredrawstr * v)
{
 aboxstr    zbox;
 aboxstr    mbox;

 zbox.y0=LY(vline->line.yy);
 zbox.y1=zbox.y0+vline->line.h;
 zbox.x0=vline->line.x;
 zbox.x1=zbox.x0+MAXW(vline);
 mbox=zbox;

 if(offset<lozon->textsrc.offset && fill)
 {
  /* unmarked bit at start of line */
  mbox.x0=lozon->x;
 }

 if(noffset>hizon->textsrc.offset && fill)
 {
  mbox.x1=hizon->x;
 }

 blanklinez(v,&zbox,&mbox,fill);

 return(NULL);
}



static int checkzone(int offset,int noffset)
{
 return(
 (offset>=lozon->textsrc.offset && offset<hizon->textsrc.offset)||
         (lozon->textsrc.offset>=offset && lozon->textsrc.offset<noffset)||
         (hizon->textsrc.offset>offset && hizon->textsrc.offset<=noffset)
       );
}




/*

   Need a better way of working out what is in the blank area
   Try typing into a box at an angle which has more than one column
   Clip rectangle is dragging in previous columns to blank 

 */






static os_error * rendertext(viewredrawstr * v,fxrendstr * fxr)
{
 os_error   * err;
 int          vloff;
 int          offset;
 int          maxline;
 vlstr        vline;
 vlstr        xline;
 aboxstr      clipbox;
 int          blank;
 int          bpaint;
 int          n;
 int          s;
 int          lmw;
 int          lw;
 int          blanky;
 int          newblanky;
 int          inzone;
 int          noffset;
 int          szone;
 int          columns;
 int          fx;
 int          fy;
 int          blankmode;
 int          blanktext;
 textboxstr * textp;
 int          vshift;         /* line shift                       */
 int          vdelta;         /* increment in line shift per line */
 texsub     * texup;
 int          usize;
 int          vlimit;
 int          temp;
 int          vbox;
 int          cvlimit;
 int          visible;
 int          backcol;


 err=NULL;


 flowvalidlimit(v->file,fxr->vec.textsrc.source,fxr->vec.textsrc.vsourcep,
                                                                    &vlimit);

 if(fxr->vec.textsrc.u==0) 
      err=settextoffset(v->file,fxr->vec.textsrc.textp,&vloff,&offset);
 else
 {
  vloff=offset=0;
 }

/* dprintf(1,"(a) textp->type=%x",fxr->vec.textsrc.textp->type); */

 /* nb textp can now have changed */

 textp=fxr->vec.textsrc.textp;
 columns=fxr->vec.textsrc.columns;
 fx=textp->fcurve.box.x;
 fy=textp->fcurve.box.y;


 visiblebox(v,&textp->transform,&textp->fcurve.box,&visible);
 if(!visible)
 {
//  cprintf("skip text");
  return(err);
 }


 getclipbox(v,textp,&clipbox);

 blank=(v->sobject==textp->key);

 szone=v->szone && blank;
 backcol=vfindcolour(v->view,&fxr->backcol);
 blanktext=blank && !szone && (backcol!=-1) && v->sboxn;

 blanky=INT_MIN;
 n=0;


/* dprintf(1,"(b) textp->type=%x",fxr->vec.textsrc.textp->type); */

// fontsetviewscale(v->view); /* can flex an event */
 fxtrash();

/* dprintf(1,"(c) textp->type=%x",fxr->vec.textsrc.textp->type); */


 if(blanktext)
 {
  for(n=0;n<v->sboxn;n++)
  {
   v->sbox[n].blanked=0;
  }
 }

 for(s=0;s<columns;s++)
 {
  textp=fxr->vec.textsrc.textp;
  usize=fxr->vec.textsrc.usize;

  texup=(texsub*)(((char*)textp)+usize);

  maxline=texup[s].vlines;
  vbox=texup[s].vbox;


  if(blank && s!=v->ssub)
  {
   vloff+=maxline;
   offset+=texup[s].bytes;
  }
  else
  {
   /* sort out vertical alignment */

   txgetvshifts(textp,texup+s,&vshift,&vdelta);

 /* dprintf(0,"vdelta=%d vshift=%d s=%d usize=%d",vdelta,vshift,s,usize); */

   maxline+=vloff;
   cvlimit=MIN(vlimit,maxline);

   inzone=szone || (zone && 
                    act.file==fxr->vec.file &&
                    act.textsrc.source==fxr->vec.textsrc.source && 
                    checkzone(offset,offset+texup[s].bytes));

   blankmode=0;
   if(inzone)    blankmode|=BLANKZONE;
   if(blanktext) blankmode|=BLANKTEXT;

   if(blankmode) 
   {
    err=blankstart(v,s,fxr->vec.textsrc.textp,backcol,blankmode);
    if(err) break;
   }

// cprintf("maxline=%d vlimit=%d",maxline,vlimit); 

   while(vloff<cvlimit)
   {
// cprintf("vloff %d limit %d",vloff,cvlimit);
    
    bpaint=0;
    fxr->dobullet=0;
    getvline(&vline,fxr->vec.textsrc.vsourcep,vloff);

    if((vloff+(int)sizeof(vlstr))<cvlimit)
    {
     getvline(&xline,fxr->vec.textsrc.vsourcep,vloff+sizeof(vlstr));

 /* dprintf(4,"xl=%d type=%d",xline.line.xl,xline.ext.type); */

     if(xline.line.xl && xline.ext.type==VLBULLET)
     {
      expandbulletdata(&xline,&fxr->bulletdata);
      fxr->dobullet=1;
     }
    }

    vline.line.yy=LY(vline.line.yy)+vshift;
    lmw=MAXWX(vline);
    lw=vline.line.w;
    noffset=offset+vline.line.len;


    xline=vline;
    if(inzone || xline.line.just==JUSTIFY) xline.line.w=lmw;
    else
    {
     if(xline.line.just==RIGHT)  xline.line.x+=(lmw-lw);
     else
     if(xline.line.just==CENTRE) xline.line.x+=(lmw-lw)>>1;
    }



    if(clipline(&xline,&clipbox))
    {
//     cprintf("paint line");
     
     if(blanktext)
     {
      /* blank any area before this line */

      newblanky=LY(vline.line.yy)+vline.line.h;

      /* only paint lines that are in blank area */

      /* blank stuff from blanky to newblanky */

      for(n=0;n<v->sboxn;n++)
      {
       if(!v->sbox[n].blanked)
       {
        doblank();

        if(v->sbox[n].box.y0>blanky && v->sbox[n].box.y0<=newblanky)
        {
         blankline(v,&v->sbox[n].box);
         v->sbox[n].blanked=1;
        } 
       }
      }

      blanky=newblanky;

      bpaint=1;
     }
     else
     {
      if(!szone) bpaint=1;
     }

     if(bpaint)
     {
      fxr->x=fx+vline.line.x;
      fxr->y=fy+LY(vline.line.yy);

      if(vline.line.just==RIGHT)  fxr->x+=(lmw-lw);
      else
      if(vline.line.just==CENTRE) fxr->x+=(lmw-lw)>>1;

      fxr->vec.textsrc.offset=offset;
      fxr->vec.astyle=vline.line.style;
      fxr->hpend=(vline.line.eol==ISHYP);
      fxr->dropcap=(vline.line.eol==ISDROP);


      if(vline.line.eol==ISSPACE)
       fxr->len=striplen(fxr->vec.textsrc.sourcep,vline.line.len,offset);
      else
       fxr->len=vline.line.len;

      if(vline.line.just==ISJUST)
      {
      /* fxr->len=striplen(fxr->vec.textsrc.sourcep,vline.len,offset); */
       fxr->width=lmw-lw;
      }
      else
      {
      /* fxr->len=vline.len; */
       fxr->width=0;
      }

//      cprintf("fxrender lw=%d lmw=%d width=%d line.just=%d",lw,lmw,fxr->width,vline.line.just);

      err=fxrender(v,fxr);
      if(err) cprintf("render errr %s",err->errmess);
      if(err) break;
     }


   /* do all marking here */
   /* if this line is in the zone, but previous is not, blank prev */
   /* if only part of this line is in the zone, blank previous bit */
   /* blank update */
   /* blank zone area for line */
   /* blank eor    */

     if(!v->isprinter)
     {
      if(inzone)
      {
       if(checkzone(offset,noffset))
       {
        if(!szone || clipline(&vline,&(v->sbox)->box))
        {
         markline(&vline,offset,noffset,1,v);
        }
       }
      }
     }
    }

    vloff+=sizeof(vlstr);
    if(fxr->dobullet) vloff+=sizeof(vlstr);
    vshift+=vdelta;
    offset=noffset;
   }

/* dprintf(0,"vloff=%d",vloff); */

   if(vloff<maxline && !blank)
   {
    frflblanked(v->file,fxr->vec.textsrc.text,&temp);

   /* dprintf(0,"blank check frame %d %d",fxr->vec.textsrc.text,temp); */

    if(!temp)
    {
     aboxstr obox;
     aboxstr abox;
     aboxstr mbox;
     aboxstr vbbox;
     aboxstr mvbox;

     /* should get local area down to min size for this column */
     /* should get min OS area */

     obox.x0=v->xlo;
     obox.x1=v->xhi;
     obox.y0=v->ylo;
     obox.y1=v->yhi;

     box2abox(&(fxr->vec.textsrc.textp)->box,&abox);
     aboxshift(&abox,v->xpo,v->ypo);
     getminabox(&mbox,&abox,&obox);

     getvbbox(&vbbox,vbox,v->file);

     getminabox(&mvbox,&vbbox,&clipbox);

     vxcadd(v,fxr->vec.textsrc.text,s,fxr->vec.textsrc.source,&mbox,&mvbox);
    }
   }

   if(blanktext)   /* should be able to use clip box usefully here */
   {
    for(n=0;n<v->sboxn;n++)
    {
     if(!v->sbox[n].blanked)
     {
      blankline(v,&v->sbox[n].box);
      doblank();
     }
    }
   }

   if(blankmode) blankend();

   vloff=maxline;
  }
 }


// cprintf("blankmode %d blanktext %d",blankmode,blanktext);


/* dprintf(0,"render text x"); */

// fontdefscale();

// cprintf("render text returns %x",err);

 return(err);
}



int txcolwidthb(textboxstr * textp,int u,int * gwidthp,transformbitstr * bits)
{
 int             columns;
 int             gwidth;
 int             width;

 width=scale(textp->fcurve.box.w,bits->xscale,0x10000);

 if(u)
 {
  columns=1;
  gwidth=0;
 }
 else
 {
  columns=textp->data.columns;
  gwidth=guttersize(&textp->data.columndata,columns,width);
 }

 if(gwidthp) *gwidthp=gwidth;    
 return((width-(columns-1)*gwidth)/columns);
}


int txcolwidth(textboxstr * textp,int u,int * gwidthp)
{
 transformbitstr bits;
 tr_getbits(&textp->transform,&bits);
 return(txcolwidthb(textp,u,gwidthp,&bits));
}





/**************************************************************************/

static int * ovptr;
static int   ovwidth;
static int   ovheight;


static os_error * redfull(transformstr * tr)
{
 sprite_id  id;
 
 id.tag=sprite_id_addr;
 id.s.addr=ovptr;

 return(sprite_put_trans((sprite_area*)sprites,&id,8,(sprite_transform*)tr,NULL));
}



os_error * fullinit(void)
{
 os_error    * err;
 sprite_id     id;
 sprite_info   resultinfo;
 int           dx;
 int           dy;

 ovptr=spfind((sprite_area*)sprites,"overflow");

 id.tag=sprite_id_addr;
 id.s.addr=ovptr;

 err=sprite_readsize((sprite_area*)sprites,&id,&resultinfo);
 getdeltas(resultinfo.mode,&dx,&dy);

 ovwidth=resultinfo.width*dx;
 ovheight=resultinfo.height*dy;

 return(err);
}



static os_error * renderfull(viewredrawstr * v,int textk)
{
 os_error      * err;
 filestr       * file;
 viewstr       * view;
 textboxstr    * textp;
 curvestr        fcurve;
 transformstr    tr;
 transformstr    sptr;
 transformbitstr bits;
 int             header;
 int             footer;
 texhdr        * texhp;
 int             footerfull;
 int             headerfull;
 int             full;
 coordstr        cx;
 coordstr        sx;
 int             i;
 int             x;
 int             y;
 int             doheader;
 int             dofooter;



 err=NULL;

 view=v->view;

 if(view->data.guides && !v->isprinter)
 {
  file=v->file;
  textp=(textboxstr*)fob_find(textk,file);

  full=textp->flags.full;
  headerfull=header=textp->data.header;
  footerfull=footer=textp->data.footer;

  if(header || footer)
  {
   texhp=(texhdr*)(((char*)textp)+sizeof(textboxstr)+3*sizeof(texsrc));
   header=texhp->header;
   headerfull=header && texhp->headerfull;
   footer=texhp->footer;
   footerfull=footer && texhp->footerfull;

   if(headerfull || footerfull)
   {
    dohf(textp,v->page,&doheader,&dofooter,file);
    if(!doheader) headerfull=0;
    if(!dofooter) footerfull=0;
   }
  }

  if(full || headerfull || footerfull)
  {
   fcurve=textp->fcurve;
   tr=textp->transform;
   tr_getbits(&tr,&bits);

   tr_setidentity(&sptr);
   tr_setrotationa(&sptr,-bits.angle);

   sx.x=ovwidth;
   sx.y=0;
   tr_transformset(&sx,1,&sptr);

   for(i=0;i<3;i++)
   {
    if((full && i==0) || (headerfull && i==1) || (footerfull && i==2))
    {
     cx.x=fcurve.box.x+fcurve.box.w;

     if(i==0) cx.y=fcurve.box.y+fcurve.box.h-footer;
     else
     if(i==1) cx.y=fcurve.box.y+header;
     else     cx.y=fcurve.box.y+fcurve.box.h;

     tr_transformset(&cx,1,&tr);

     x=v->ox+osunits(v->xpo+cx.x,view);
     y=v->oy-osunits(v->ypo+cx.y,view);

     sptr.e=(x-sx.x)*256;
     sptr.f=(y-sx.y)*256;

     redfull(&sptr);
    }
   }
  }
 }
 return(err);
}



os_error * refreshfull(vector * v)
{
 int               header;
 int               footer;
 texhdr          * texhp;
 transformbitstr   bits;
 textboxstr      * textp;
 viewstr         * view;
 coordstr          cx;
 coordstr          sx;
 aboxstr           abox;
 aboxstr           sbox;
 filestr         * file;
 transformstr      sptr;
 int               xpo;
 int               ypo;
 int               x;
 int               y;



 file=v->file;

 textp=v->textsrc.textp;

 header=textp->data.header;
 footer=textp->data.footer;

 if(header || footer)
 {
  texhp=(texhdr*)(((char*)textp)+sizeof(textboxstr)+3*sizeof(texsrc));
  header=texhp->header;
  footer=texhp->footer;
 }

 tr_getbits(&textp->transform,&bits);

 tr_setidentity(&sptr);
 tr_setrotationa(&sptr,bits.angle);

 sx.x=ovwidth;
 sx.y=ovheight;
 tr_transformset(&sx,1,&sptr);

 cx.x=textp->fcurve.box.x+textp->fcurve.box.w;

 if(v->textsrc.u==0) cx.y=textp->fcurve.box.y+textp->fcurve.box.h-footer;
 else
 if(v->textsrc.u==1) cx.y=textp->fcurve.box.y+header;
 else                cx.y=textp->fcurve.box.y+textp->fcurve.box.h;

 tr_transformset(&cx,1,&textp->transform);

 view=file->view;
 while(view)
 {
  if(view->data.guides)
  {
   getpagecoords(view,v->page,v->section,&xpo,&ypo);

   x=osunits(xpo+cx.x,view);
   y=osunits(ypo+cx.y,view);

   sptr.e=(x-sx.x);
   sptr.f=(y-sx.y);

   sbox.x0=0;
   sbox.x1=ovwidth;
   sbox.y0=0;
   sbox.y1=ovheight;

   getmaxabox(&abox,&sbox,&sptr);

   abox.x0=ourunits(abox.x0,view);
   abox.x1=ourunits(abox.x1,view);
   SWOP(abox.y0,abox.y1);
   abox.y0=ourunits(abox.y0,view);
   abox.y1=ourunits(abox.y1,view);

   viewrefreshaarea(view,&abox,VRBACK);
  }
  view=view->next;
 }

 return(NULL);
}



os_error * refreshfullbox(int text,filestr * file)
{
 os_error * err;
 vector     v;

 err=setpagevectorfrombox(&v,text,file);
 if(!err)
 {
  err=txlock(&v.textsrc,file);
  if(!err)
  {
   err=refreshfull(&v);
   txunlock(&v.textsrc,file);
  }
 }

 return(err);
}


/****************************************************************************/





static os_error * renderguides(viewredrawstr * v,int textk,
                                                        int guidecolour)
{
 os_error      * err;
 filestr       * file;
 int             g;
 int             gwidth;
 int             cwidth;
 int             width;
 int             xleft;
 int             height;
 int             columns;
 int             x;
 clipbuff        buff;
 boxstr          box;
 textboxstr    * textp;
 curvestr        fcurve;
 transformstr    tr;
 columnstr       columndata;
 transformbitstr bits;
 int             header;
 int             footer;
 texhdr        * texhp;
 int             doheader;
 int             dofooter;


 err=NULL;

 

 file=v->file;
 textp=(textboxstr*)fob_find(textk,file);
 header=textp->data.header;
 footer=textp->data.footer;
 columndata=textp->data.columndata;

 if((((columns=textp->data.columns)>1) || header || footer) && 
                 (guidecolour || columndata.guides))
 {
  fcurve=textp->fcurve;
  tr=textp->transform;

//cprintf("render guides");

  if(header || footer)
  {
   texhp=(texhdr*)(((char*)textp)+sizeof(textboxstr)+3*sizeof(texsrc));
   header=texhp->header;
   footer=texhp->footer;

   dohf(textp,v->page,&doheader,&dofooter,file);
   if(!doheader) header=0;
   if(!dofooter) footer=0;
  }

  tr_getbits(&tr,&bits);

  columndata.width=scale(columndata.width,0x10000,bits.xscale);
  columndata.guidewidth=scale(columndata.guidewidth,0x10000,bits.xscale);
  header=scale(header,0x10000,bits.yscale);
  footer=scale(footer,0x10000,bits.yscale);

  height=textp->fcurve.box.h;
  xleft=textp->fcurve.box.x;
  width=textp->fcurve.box.w;
  gwidth=guttersize(&columndata,columns,width);
  cwidth=(width-(columns-1)*gwidth)/columns;
  box=textp->fcurve.box;
  box.y+=header;
  box.h-=header+footer;

  err=clipopen(&buff);
  if(!err)
  {
   for(g=0;g<columns-1;g++) /* count accross gutters */
   {
    x=cwidth+(cwidth+gwidth)*g+fcurve.box.x;

    if(guidecolour)
    {
     box.x=x;
     err=clipvline(&fcurve,&box,file,&buff);
     outlinesections(v,buff.path,guidecolour,NULL,-1,&tr);
     clipreset(&buff);
    }

    x+=gwidth/2;
    if(columndata.guides)   /* paint column guides   */
    {
     box.x=x;
     err=clipvline(&fcurve,&box,file,&buff);

     err=outlinesections(v,buff.path,OUTLINECVLINE,&columndata.colour,
                                                 columndata.guidewidth,&tr);

     clipreset(&buff);
    }

    x+=gwidth/2;

    if(guidecolour)
    {
     box.x=x;
     err=clipvline(&fcurve,&box,file,&buff);
     err=outlinesections(v,buff.path,guidecolour,NULL,-1,&tr);
     clipreset(&buff);
    }
   }

   if((header || footer) && guidecolour)
   {
    box.w=width;
    box.x=xleft;

    if(header)
    {
     err=cliphline(&fcurve,&box,file,&buff);
     err=outlinesections(v,buff.path,guidecolour,NULL,-1,&tr);
     clipreset(&buff);
    }

    if(footer)
    {
     box.y+=height-header-footer;
     err=cliphline(&fcurve,&box,file,&buff);
     err=outlinesections(v,buff.path,guidecolour,NULL,-1,&tr);
     clipreset(&buff);
    }
   }

   clipclose(&buff);
  }
 }
 return(err);
}



os_error * redrawtext(viewredrawstr * v,textboxstr * textp)
{
 os_error    * err;
 viewstr     * view;
 filestr     * file;
 int           guidecolour;
 int           blank;
 int           szone;
 fxrendstr     fxr;
 curvestr      fcurve;
 transformstr  tr;
 colourvalue   colour;
 texsrc      * texsp; 
 int           header;
 int           footer;
 int           textk;
 texsrc        src[3];
 int           lines[3];
 int           usize;
 int           u;
 int           offset;
 int           voffset;
 vlstr       * vline;
 sourcestr   * sourcep;
 vsourcestr  * vsourcep;
 int           goffset;
 int           xoffset;
 int           maxoffset;
 int           ch;
 char        * r;
 int           bits;
 int           maxv;
 int           object;
 int           doborder;
 int           docontents;
 int           doheader=0;
 int           dofooter=0;
 curvestylestr cstyle;
 int           fbits;



/* int          time=clock(); */

 err=NULL;

 textk=textp->key;

 if(textk==v->object) v->ignore=0;

// cprintf("redraw text %d",textk);

 if(!textp->flags.invisible && boxinredraw(v,&textp->box))
 {
// cprintf("redraw 2 ignore=%d textk %d",v->ignore,textk);
  
  view=v->view;
  file=v->file;

  header=textp->data.header;
  footer=textp->data.footer;

  texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
  src[0]=*texsp++;
  boxcontents(textp,0,NULL,lines);

  if(header || footer)
  {
   usize=sizeof(textboxstr)+3*sizeof(texsrc)+sizeof(texhdr)+2*sizeof(texsub);
   for(u=1;u<3;u++)
   {
    src[u]=*texsp++;
    boxcontents(textp,u,NULL,&lines[u]);
   }

   dohf(textp,v->page,&doheader,&dofooter,file);
  }
  else
  {
   usize=sizeof(textboxstr)+sizeof(texsrc);
  }


  if(v->ignore) /* check child objects */
  {
   for(u=0;u<3;u++)
   {
    if(u==0 || (u==1 && header && doheader) || (u==2 && footer && dofooter))
    {
     if(u==0) settextoffset(v->file,textp,&voffset,&offset);
     else     voffset=offset=0;

     maxv=voffset+lines[u];
     vsourcep=(vsourcestr*)fob_find(src[u].vsource,file);
     vline=(vlstr*)(vsourcep->data+voffset);
     goffset=vsourcep->goffset;
     if(maxv>=goffset) maxv+=vsourcep->maxlen-vsourcep->len;

     while(1)
     {
      while(voffset<maxv && voffset<goffset)
      {
       if(!vline->line.xl)
       {
        if(vline->line.object)
        {
         xoffset=offset;
         maxoffset=offset+vline->line.len;

         sourcep=(sourcestr*)fob_find(src[u].source,file);

         while(offset<maxoffset)
         {
          r=txptr(sourcep,xoffset);
          ch=*r;
          bits=codex[ch];
          if(ch==EOB)
          {
           object=(*(r+1))+((*(r+2))<<8)+((*(r+3))<<16)+((*(r+4))<<24);
           err=objectredraw(v,(objhdrstr *)fob_find(object,v->file));
           sourcep=(sourcestr*)fob_find(src[u].source,file);
          }
          xoffset+=bits & CODELEN;
          if(bits & CODETERMINATOR) break;
         }

         vsourcep=(vsourcestr*)fob_find(src[u].vsource,file);
         vline=(vlstr*)(vsourcep->data+voffset);
        }

        offset+=vline->line.len;
       }
       voffset+=sizeof(vlstr);
       vline++;
      }

      if(voffset>=maxv || voffset>=vsourcep->maxlen) break;

      voffset+=vsourcep->maxlen-vsourcep->len;
      goffset=vsourcep->maxlen;
      vline=(vlstr*)(vsourcep->data+voffset);
     }
    }
   }
  }
  else /* !v->ignore */
  {
   blank=(v->sobject==textk);
   szone=blank && v->szone;
   doborder=docontents=1;

//    cprintf("blank %d szone %d doborder %d",blank,szone,doborder);

   if(v->sobject && v->sshortcuts)
   {
    if(!blank)
    {
     if(textp->textflow.omode==FROFRAME &&
        !textp->textflow.changeo)
     {
      docontents=textp->textflow.o<0;
      doborder=textp->textflow.o<=0;
     }
     if(doborder || docontents) v->sshortcuts=0;
    }
    else
    {
     if(textp->data.columns<=1) doborder=0;

     if(doborder) v->sshortcuts=0;
    }

    if(!docontents || !doborder)
    {
     if(embededobject(textk,file)) docontents=doborder=1;
     if(docontents || doborder) textp=(textboxstr*)fob_find(textk,file);
    }
   }

// cprintf("dob %d doc %d",doborder,docontents);

   if(doborder || docontents)
   {
    guidecolour=(view->data.guides)?(GUIDECOLOUR|OUTLINEWIMPLINE):0;

    fcurve=textp->fcurve;
    tr=textp->transform;
    colour=textp->data.colour;

    memset(&fxr,0,sizeof(fxrendstr));

    fxr.vec.file=file;
    fxr.vec.page=v->page;
    fxr.vec.section=v->section;
    fxr.vec.textsrc.text=textk;
    fxr.transform=textp->data.transform;
    fxr.vec.textsrc.columns=textp->data.columns;
    fxr.backcol=colour;

    infofill(&textp->data.fill,v,&fbits,NULL);
    if(fbits & FILL_SHADEDCOLOUR)
    {
     cvfrompal(&fxr.backcol,-1);
     if(v->sobject && v->sshortcuts) v->sshortcuts=0;
    }

    if(!blank || ((fbits & FILL_SHADEDCOLOUR) && !szone))
    {
     cstyle.fillcolour=cstyle.linecolour=colour;
     cstyle.fill=textp->data.fill;
     rcreatepathstyle(&cstyle.pstyle,0);
     cstyle.pstyle.action=0x2;
     err=renderfill(v,&fcurve,&cstyle,&tr); 
    /* err=outlinecurve(v,&fcurve,OUTLINECVFILL,&colour,&tr);  */
    }

    for(u=0;u<3;u++)
    {
     if((u==0 || (u==1 && header && doheader) || (u==2 && footer && dofooter)) 
                                         && (!blank || u==v->sunit))
     {
      fxr.vec.textsrc.u=u;
      fxr.vec.textsrc.source=src[u].source;
      fxr.vec.textsrc.vsource=src[u].vsource;
      fxr.vec.textsrc.usize=usize;

      if(u)
      {
       fxr.vec.textsrc.columns=1;
       if(u==1) fxr.vec.textsrc.usize-=2*sizeof(texsub);
       else     fxr.vec.textsrc.usize-=sizeof(texsub);
      }

      err=txlock(&fxr.vec.textsrc,file);
      if(!err)
      {
       if(!err) err=rendertext(v,&fxr);
       err=txunlock(&fxr.vec.textsrc,file);
      }
     }
    }



    if(!szone && doborder)
    {
     textp=(textboxstr*)fob_find(textk,file);
     
     if(!err) err=renderborder(textp->frame,&fcurve,&tr,v);
     if(!err) err=outlinecurve(v,&fcurve,guidecolour,NULL,&tr);
     if(!err) err=renderguides(v,textk,guidecolour);
     if(!err) err=renderfull(v,textk);
    }
   }



#ifdef NEVER
    if(debugactive())
    {
     int          i;
     int          j;
     int          vboxk;
     textvbox   * vboxp;
     transformstr trx;
     transformstr xtry;
     transformstr trz;
     int          k;
     int          xcolumns;
     texsub     * texup;
     int          usize;
     static int   xc[]={WIMPYELLOW,WIMPRED,WIMPGREEN,WIMPLBLUE};

     xcolumns=textp->data.columns;
     if(textp->data.header || textp->data.footer) 
     {
      xcolumns+=2;
      usize=sizeof(textboxstr)+3*sizeof(texsrc)+sizeof(texhdr);
     }
     else
     {
      usize=sizeof(textboxstr)+sizeof(texsrc);
     }

     for(i=0;i<xcolumns;i++)
     {
      texup=texup=(texsub*)(((char*)textp)+usize);
      vboxk=texup[i].vbox;

      trx=textp->data.transform;
      tr_setshift(&xtry,textp->fcurve.box.x,textp->fcurve.box.y);

      tr_multiply(&trz,&xtry,&trx);

      j=0;k=0;
      while(vboxk)
      {
       vboxp=(textvbox*)fob_find(vboxk,file);



       if(j<vboxp->nc)
       {
     /*  dprintf(2,"vboxk=%d ylo=%d yhi=%d",vboxk,vboxp->curve[j].box.y,
                           vboxp->curve[j].box.y+vboxp->curve[j].box.h); */

        outlinecurve(v,&vboxp->curve[j],xc[(j+k*3) & 0x3]|OUTLINEWIMPLINE,
                                        NULL,&trz);
        j++;
        /* if(k==2 && j==2) break; */
       }
       else
       {
        vboxk=vboxp->down;
        j=0;
        k++;
        /* if(k>2) break;  */
       }
      }
     }
    }

#endif

  }
 }


/* dprintf(0,"time=%d",time-clock()); */

 return(err);
}










#ifdef NEVER


static viewredrawstr * paintv;

static os_error * paintr(textboxstr * textp,filestr * file,int * message)
{
 os_error   * err;
 texsrc     * texsp;
 texsub     * texup;
 int          columns;
 int          offset;
 int          noffset;
 int          vloff;
 int          zvoff;
 int          bvoff;
 int          maxline;
 int          u;
 int          usize;
 int          backcol;
 vsourcestr * vsourcep;
 aboxstr      clipbox;
 vlstr        vline;
 vlstr        xline;
 int          s;
 int          vshift;
 int          vdelta;
 int          vlimit;
 int          lmw;
 int          lw;
 int          valign;


 err=NULL;

 if(textp->type==OTEXTBOX)
 {
  texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));

  if(texsp[0].source==act.textsrc.source || textp->key==act.textsrc.text)
  {
   u=act.textsrc.u;

   if(textp->data.header || textp->data.footer)
   {
    usize=sizeof(textboxstr)+3*sizeof(texsrc)+sizeof(texhdr);
    if(u==0) usize+=2*sizeof(texsub);
    else
    if(u==2) usize+=sizeof(texsub);
   }
   else usize=sizeof(textboxstr)+sizeof(texsrc);

   if(u==0)
   {
    columns=textp->data.columns;
    err=settextoffset(file,textp,&vloff,&offset);
   }
   else
   {
    columns=1;
    vloff=offset=0;
   }


   texup=(texsub*)(((char*)textp)+usize);
   noffset=offset;
   for(s=0;s<columns;s++)
   {
    noffset+=texup[s].bytes;
   }

   if(checkzone(offset,noffset))
   {
    backcol=vfindcolour(view,&textp->data.colour);

    getclipbox(paintv,textp,&clipbox);

    zvoff=bvoff=vloff;

    err=fob_lock((fobjptr)&vsourcep,act.textsrc.vsource,file);
    if(!err)
    {
     flowvalidlimit(file,act.textsrc.source,vsourcep,&vlimit);

     for(s=0;s<columns;s++)
     {
      texup=(texsub*)(((char*)textp)+usize);
      maxline=texup[s].vlines;

      if(!checkzone(offset,offset+texup[s].bytes))
      {
       vloff+=maxline;
       offset+=texup[s].bytes;
      }
      else
      {

       /* sort out vertical alignment */

       vshift=vdelta=0;
  
       if(maxline)
       {
        valign=textp->data.valign & 0x3;

        if(valign==VBOTTOM)
        {
         vshift=texup[s].vdelta;
        }
        else
        if(valign==VCENTRE)
        {
         vshift=texup[s].vdelta/2;
        }
        else
        if(valign==VJUSTIFY && maxline>sizeof(vlstr))
        {
         vdelta=texup[s].vdelta/((maxline/sizeof(vlstr))-1);
        }
       }

       maxline+=vloff;

       err=blankstart(paintv,s,textp,backcol,BLANKZONE);
       if(err) break;

       while(vloff<maxline && vloff<vlimit)
       {
        getvline(&vline,vsourcep,vloff);
        vline.y+=vshift;
        lmw=MAXWX(vline);
        lw=vline.w;
        noffset=offset+vline.len;

        xline=vline;
        xline.w=lmw;

        if(clipline(&xline,&clipbox))
        {
         /* do all marking here */
         /* if this line is in the zone, but previous is not, blank prev */
         /* if only part of this line is in the zone, blank previous bit */
         /* blank update */
         /* blank zone area for line */
         /* blank eor    */

         if(checkzone(offset,noffset))
         {
          if(zvoff!=vloff) /* blank previous */
          {
           if(vloff>0 && vloff>bvoff)
           {
            getvline(&xline,vsourcep,vloff-sizeof(vlstr));
            markline(&xline,offset,noffset,0,paintv);
           }
           zvoff=vloff;
          }
          markline(&vline,offset,noffset,1,paintv);
          zvoff+=sizeof(vlstr);
         }
        }

        vloff+=sizeof(vlstr);
        vshift+=vdelta;
        offset=noffset;
       }

       blankend();

       vloff=maxline;
      }
     }

     fob_unlock((fobjptr)&vsourcep,file);
    }
   }
  }
 }
 return(err);

 USE(message);
}




os_error * paintzone(viewredrawstr * v)
{
 os_error * err;
 pagestr  * pagep;
 int        message;

 paintv=v;

 message=OM_FUNCTION;
 pagep=fob_find(v->page,v->file);
 err=objectmessage((objhdrstr*)pagep,v->file,&message,(void*)paintr);

 return(err);
}



#endif



