#include <stdafx.h>
#include <stdlib.h>
#include <ctype.h>

#include "dde.h"


#include "os.h"
#include "wimp.h"
#include "flex.h"

#include "wos.h"
#include "deb.h"
#include "bits.h"
#include "etc.h"
#include "osglue.h"
#include "oserr.h"
#include "fsx.h"
#include "poll.h"
#include "werr.h"
#include "alloc.h"


#include "osddex.h"
#include "osdde.h"


/*
  Notes

  PackDDE is used for everthing except init message - could be wrong
  The code works because all ACK's received have the same format, long run
  may be better to set up the ack fn for the expected reply. Fair to assume
  there will be a reply before another message is sent which may get a reply


*/




typedef struct ddechannelstr
{
 HWND            hwnd;
 HWND            remote;
 uservalue       userhandle;
 ddeserverfn     serverfn;
 ddechannelstr * next;
 ddechannelstr * prev;
 unsigned int    newflag:1;

} ddechannelstr;



typedef int (*ddeackfn)(HWND hwnd,HWND client,LPARAM lParam);



static ddeackfn        ddeackf;
static char          * appname;
static ddeserverfn     ddeserver;
static ddechannelstr * ddefirst;
static HWND            ddehwnd;





#ifdef _DEBUG


static os_error * ddetestserver(ddech channel,uservalue userhandle,int code,void * data,int size,char * item)
{
 ddechannelstr * ddec;

 cprintf("ddetest server channel %x",channel);
 ddec=(ddechannelstr*)channel;

 if(ddec)
 {
  cprintf("hwnd %x remote %x",ddec->hwnd,ddec->remote);
 }

 return(NULL);

 USE(item);
 USE(size);
 USE(data);
 USE(code);
 USE(userhandle);
}


#endif







static os_error * ddecreatechannel(HWND hwnd,HWND remote,ddeserverfn ddeserver,uservalue userhandle,ddechannelstr ** ddecp)
{
 os_error      * err;
 ddechannelstr * ddec;

 err=salloc((flex_ptr)&ddec,sizeof(ddechannelstr));
 if(!err)
 {
  ddec->hwnd=hwnd;
  ddec->remote=remote;
  ddec->serverfn=ddeserver;
  ddec->next=ddefirst;
  ddec->userhandle=userhandle;
  if(ddefirst) ddefirst->prev=ddec;
  ddefirst=ddec;
  if(ddecp) *ddecp=ddec;
 }

 return(err);
}


static ddechannelstr * ddefindchannel(HWND hwnd,HWND remote)
{
 ddechannelstr * ddec;

 ddec=ddefirst;
 while(ddec)
 {
  if(ddec->hwnd==hwnd && (ddec->remote==remote || remote==NULL)) break;
  ddec=ddec->next;
 }

 return(ddec);
}


static os_error * ddescrapchannel(ddechannelstr * ddec)
{
 os_error      * err;
 ddechannelstr * prev;
 ddechannelstr * next;

 cprintf("ddescrap first %x ddec %x",ddefirst,ddec);

 prev=ddec->prev;
 next=ddec->next;

 if(prev) prev->next=next;
 if(next) next->prev=prev;
 if(ddefirst==ddec) ddefirst=next;

 err=sfree((flex_ptr)&ddec);

 return(err);
}



#ifdef _DEBUG

static void ddecount(void)
{
 ddechannelstr * next;
 int             count;

 count=0;

 next=ddefirst;
 while(next)
 {
  count++;
  next=next->next;
 }


 cprintf("ddecount %d",count);
}


#endif


// a window is deleted

os_error * ddedelete(wimp_w w)
{
 ddechannelstr * ddec;

 while(1)
 {
  ddec=ddefindchannel((HWND)w,NULL);
  if(ddec)
  {
   if(ddec->serverfn) ddec->serverfn((ddech)ddec,ddec->userhandle,OSDDE_FINIT,NULL,0,NULL);
   ddescrapchannel(ddec);
  }
  else
  {
   break;
  }
 }

 return(NULL);
}







static int ddedefack(HWND hwnd,HWND remote,LPARAM lParam)
{
 DDEACK  ack;
 ATOM    atom;

 UnpackDDElParam(WM_DDE_ACK,lParam,(PUINT_PTR)&ack,(PUINT_PTR)&atom); 
 GlobalDeleteAtom(atom);

 return(0);

 USE(remote);
 USE(hwnd);
}







// we receive a WM_DDE_INITIATE message

int ddeinit(HWND hwnd,HWND client,int appatom,int topicatom)
{
 os_error      * err;
 char            appbuffer[256];
 char            topicbuffer[256];
 ATOM            ourtopic;
 ATOM            ourapp;
 ddechannelstr * ddec;
 int             flags;

 
 err=wimp_getwindowflags((wimp_w)hwnd,&flags);

 if(appname && (flags & WINDOWDDE) && hwnd!=client)
 {
  if(appatom)
  {
   GlobalGetAtomName((ATOM)appatom,appbuffer,sizeof(appbuffer)/sizeof(TCHAR));
   cprintf("appatom %s",appbuffer);
  }


  if(topicatom)
  {
   GlobalGetAtomName((ATOM)topicatom,topicbuffer,sizeof(topicbuffer)/sizeof(TCHAR));
   cprintf("topicatom %s",topicbuffer);
  }


  if((!appatom && !topicatom) ||
     (!cstrcmp(appbuffer,appname) && (!topicatom || !cstrcmp(topicbuffer,"system")))
    )
  {
   ourtopic=GlobalAddAtom("system");
   ourapp=GlobalAddAtom(appname);

   cprintf("+ve ack client %x wnd %x",client,hwnd);

   SendMessage(client,                // handle to destination window 
               WM_DDE_ACK,            // message to send
               (WPARAM)hwnd,          // handle to window (HWND)
               (LPARAM)MAKELONG(ourapp,ourtopic)          // message-specific data
              );

   GlobalDeleteAtom((ATOM)ourapp);
   GlobalDeleteAtom((ATOM)ourtopic);
  }


  if(ddeserver)
  {
   ddecreatechannel(hwnd,client,ddeserver,0,&ddec);
   ddeserver((ddech)ddec,ddec->userhandle,OSDDE_INIT,NULL,0,NULL);
  }

  return(0); // we did something
 }

 return(1);
}




/* A DDE client application posts a WM_DDE_POKE message to a DDE server
   application. A client uses this message to request the server to accept
   an unsolicited data item. The server is expected to reply with a 
   WM_DDE_ACK message indicating whether it accepted the data item. 
*/


int ddepoke(HWND hwnd,HWND client,LPARAM lParam)
{
 char            szItemName[256];
 char            szItemValue[256];
 DDEPOKE       * lpPokeData;
 ddechannelstr * ddec;
 int             bRelease;
 int             appatom;
 UINT_PTR        hPokeData;



 UnpackDDElParam(WM_DDE_POKE,lParam,(PUINT_PTR)&hPokeData,(PUINT_PTR)&appatom); 


 cprintf("get poke hpoke %x atom %x",hPokeData,appatom);

 GlobalGetAtomName((unsigned short)appatom,szItemName,256); 

 cprintf("get poke item %s",szItemName);

 if((lpPokeData=(DDEPOKE FAR*)GlobalLock((void*)hPokeData))==NULL) 
 { 
  lParam=PackDDElParam(WM_DDE_ACK,0,appatom);

  if(!PostMessage(client,WM_DDE_ACK,(WPARAM)hwnd,lParam))  // negative ACK
  {
   FreeDDElParam(WM_DDE_ACK,lParam);
  }
 } 
 else
 {
  strcpy(szItemValue,(char*)lpPokeData->Value); // copies value 
  bRelease=lpPokeData->fRelease; 
  GlobalUnlock((void*)hPokeData); 
  if (bRelease) 
  { 
   GlobalFree((void*)hPokeData); 
  } 

  lParam=PackDDElParam(WM_DDE_ACK,0x8000,appatom);

  if(!PostMessage(client,WM_DDE_ACK,(WPARAM)hwnd,lParam))    // positive ACK
  {
   FreeDDElParam(WM_DDE_ACK,lParam);
  }


  ddec=ddefindchannel(hwnd,client);
  if(ddec)
  {
   if(ddec->serverfn) ddec->serverfn((ddech)ddec,ddec->userhandle,OSDDE_POKE,szItemValue,strlen(szItemValue)+1,szItemName);
  }
 }

 return(0); // we did something
}




/* A DDE server application posts a WM_DDE_DATA message to a DDE client
   application to pass a data item to the client or to notify the client 
   of the availability of a data item
*/


int ddedata(HWND hwnd,HWND client,LPARAM lParam)
{
 char            szItemName[256];
 char            szItemValue[256];
 DDEDATA       * lpDDEData;
 ddechannelstr * ddec;
 int             bRelease;
 int             appatom;
 UINT_PTR        hData;


 UnpackDDElParam(WM_DDE_DATA,lParam,(PUINT_PTR)&hData,(PUINT_PTR)&appatom); 

 GlobalGetAtomName((unsigned short)appatom,szItemName,256); 

 if((lpDDEData=(DDEDATA FAR*)GlobalLock((void*)hData))==NULL)
 {
  lParam=PackDDElParam(WM_DDE_ACK,0,appatom);

  if(!PostMessage(client,WM_DDE_ACK,(WPARAM)hwnd,lParam)) // Negative ACK.
  {
   FreeDDElParam(WM_DDE_ACK,lParam);
  }
 } 
 else
 {
  // Copy data from lpDDEData here. 
 
  if(lpDDEData->fAckReq) 
  { 
   lParam=PackDDElParam(WM_DDE_ACK,0x8000,appatom);

   if(!PostMessage(client,WM_DDE_ACK,(WPARAM)hwnd,lParam)) // Positive ACK
   {
    FreeDDElParam(WM_DDE_ACK,lParam);
   }
  } 

  strcpy(szItemValue,(char*)lpDDEData->Value); // copies value 
 
  bRelease=lpDDEData->fRelease; 
  GlobalUnlock((void*)hData); 
  if(bRelease)
  {
   GlobalFree((void*)hData); 
  }


  ddec=ddefindchannel(hwnd,client);
  if(ddec)
  {
   if(ddec->serverfn) ddec->serverfn((ddech)ddec,ddec->userhandle,OSDDE_DATA,szItemValue,strlen(szItemValue)+1,szItemName);
  }
 }

 return(0);
}



/* A DDE client application posts a WM_DDE_REQUEST message to a DDE
   server application to request the value of a data item. 
*/



int dderequest(HWND hwnd,HWND client,LPARAM lParam)
{

 USE(lParam);
 USE(client);
 USE(hwnd);

 return(0); // we did something
}





int ddeack(HWND hwnd,HWND client,LPARAM lParam)
{
 if(ddeackf) return(ddeackf(hwnd,client,lParam));
 return(0); // we did something
}







static char * getcode(char * string)
{
 while(*string==' ') string++;
 return(string);
}


static char * gettoken(char * string,char * token)
{
 int ch;

 while(1)
 {
  ch=*string;

  if(isalnum(ch)) *token++=(char)ch;
  else            break;

  string++;
 }

 *token=0;

 return(string);
}



static char * getstring(char * string,char * token)
{
 int ch;


 *token=0;

 string=getcode(string);
 if(*string=='"')
 {
  string++;

  while(1)
  {
   ch=*string++;

   if(ch=='"' || ch==0) break;

   *token++=(char)ch;
  }
 }

 *token=0;

 return(string);
}



static int ddeparsecommand(char * command)
{
 char * p;
 char   path[MAX_PATH];
 char   name[256];
 int    bar;
 int    open;
 int    print;
 int    print2;
 int    ack;

 p=command;

 while(1)
 {
  p=getcode(p);

  if(*p=='[')
  {
   bar=1;
   p++;
  }
  else
  {
   bar=0;
  } 
  if(*p==0) break;


  p=gettoken(p,path);
  if(*p==0) break;

  open=!cstrcmp(path,"open");
  print=!cstrcmp(path,"print");
  print2=!cstrcmp(path,"printto");

  p=getcode(p);
  // better be (
  if(*p!='(') break;
  p++;

  p=getstring(p,path);
  if(*p==0) break;

//  cprintf("open %s",path);
  if(open)
  {
   report(dataopen(path,0,&ack));
  }
  else
  if(print)
  {
   wimp_msgstr msg;

   msg.hdr.action=wimp_MPrintTypeOdd;
   msg.data.print.name=path;
   msg.data.print.printer=NULL;
   msg.data.print.type=fs_filetypefromextension(path);

   wmgeneratemessage2(&msg);
  }
  else
  if(print2)
  {
   wimp_msgstr msg;

   p=getcode(p);
   // better be ,
   if(*p!=',') break;
   p++;

   p=getstring(p,name);
   if(*p==0) break;

   msg.hdr.action=wimp_MPrintTypeOdd;
   msg.data.print.name=path;
   msg.data.print.printer=name;
   msg.data.print.type=fs_filetypefromextension(path);

   wmgeneratemessage2(&msg);
  }


  p=getcode(p);
  // better be )
  if(*p!=')') break;
  p++;

  if(bar)
  {
   p=getcode(p);
   // better be ]
   if(*p!=']') break;
   p++;
  }
 }


 return(1);
}





int ddeexec(HWND hwnd,HWND client,HGLOBAL handle)
{
 DDEACK   ack;
 LPARAM   lParam;
 char   * command;
        
 if(appname)
 {
  command=(char*)GlobalLock(handle);
  
  cprintf("dde exec hwnd %x client %x %s",hwnd,client,command);
  
  ack.bAppReturnCode=0; 
  ack.reserved=0; 
  ack.fBusy=0; 
  ack.fAck=ddeparsecommand(command); 

  GlobalUnlock(handle);

  lParam=PackDDElParam(WM_DDE_ACK,*((unsigned int*)(&ack)),(UINT_PTR)handle);

  if(!PostMessage(client,WM_DDE_ACK,(WPARAM)hwnd,lParam))
  {
   FreeDDElParam(WM_DDE_ACK,lParam);
  }

  return(0);
 }

 return(1);
}




int ddeterm(HWND hwnd,HWND client,LPARAM spare)
{
 ddechannelstr * ddec;

 if(appname)
 {
  cprintf("dde term hwnd %x client %x",hwnd,client);

  PostMessage(client,WM_DDE_TERMINATE,(WPARAM)hwnd,(LPARAM)0);

  ddec=ddefindchannel(hwnd,client);
  if(ddec)
  {
   if(ddec->serverfn) ddec->serverfn((ddech)ddec,ddec->userhandle,OSDDE_FINIT,NULL,0,NULL);
   ddescrapchannel(ddec);
  }


#ifdef _DEBUG
  ddecount();
#endif

  
  return(0);
 }

 return(1);

 USE(spare);
}







static int ddeinitack(HWND hwnd,HWND remote,LPARAM lParam)
{
 ddechannelstr * ddec;

 if(!ddefindchannel(hwnd,remote))
 {
  ddecreatechannel((HWND)hwnd,remote,NULL,0,&ddec);
  ddec->newflag=1;
 }

 return(0);

 USE(lParam);
}


static os_error * ddesendinit(HWND hwnd,char * szApplication,char * szTopic)
{
 os_error  * err;
 ATOM        atomApplication;
 ATOM        atomTopic;

 err=NULL;

	cprintf("ddesend init");

 atomApplication=(unsigned short)((szApplication==NULL)?NULL:GlobalAddAtom((LPSTR)szApplication));
 atomTopic=(unsigned short)((szTopic==NULL)?NULL:GlobalAddAtom((LPSTR)szTopic));

 ddeackf=ddeinitack;

 SendMessage((HWND)-1,                 // broadcasts message 
             WM_DDE_INITIATE,          // initiates conversation 
             (WPARAM)hwnd,             // handle to client DDE window 
             MAKELONG(atomApplication, // application-name atom 
             atomTopic));              // topic-name atom 

 ddeackf=ddedefack;

 if(atomApplication!=NULL) GlobalDeleteAtom(atomApplication); 
 if(atomTopic != NULL)     GlobalDeleteAtom(atomTopic); 

 return(err);
}




static os_error * ddesendpoke(HWND client,HWND server,char * szValue,int size,int type,char * szItem)
{
 HGLOBAL   hPokeData;
 DDEPOKE * lpPokeData;
 ATOM      atomItem;
 LPARAM    lParam;
 
 cprintf("ddesend poke");
 
 if((hPokeData=GlobalAlloc(GMEM_MOVEABLE,(LONG)sizeof(DDEPOKE)+size))==NULL)
 {
  return(NULL); 
 }
 
 if((lpPokeData=(DDEPOKE FAR*)GlobalLock(hPokeData))==NULL) 
 { 
  GlobalFree(hPokeData); 
  return(NULL); 
 } 
 
 lpPokeData->fRelease=TRUE; 
 lpPokeData->cfFormat=(short)type; 
 memcpy((LPSTR)lpPokeData->Value,(LPSTR)szValue,size); 
 
 GlobalUnlock(hPokeData);

 if((atomItem=GlobalAddAtom((LPSTR)szItem))!=0) 
 {
  cprintf("post %x->%x hpoke %x atom %x",client,server,(UINT_PTR)hPokeData,atomItem);

  lParam=PackDDElParam(WM_DDE_POKE,(UINT_PTR)hPokeData,atomItem);

  if(!PostMessage(server,WM_DDE_POKE,(WPARAM)client,lParam))
  { 
   FreeDDElParam(WM_DDE_POKE,lParam); 
   GlobalDeleteAtom(atomItem); 
   GlobalFree(hPokeData); 
  } 
 } 
 
 if(atomItem==0) 
 { 

    // Handle errors. 

 } 
 

 return(NULL);
}




static os_error * ddesenddata(HWND client,HWND server,char * szValue,int size,int type,char * szItem)
{
 HGLOBAL   hData;
 DDEDATA * lpData;
 ATOM      atomItem;
 LPARAM    lParam;
 
 cprintf("ddesend data %x->%x",client,server);
 

 if((hData=GlobalAlloc(GMEM_MOVEABLE,(LONG)sizeof(DDEDATA)+size))==NULL) 
 {
  return(NULL); 
 }
 
 if((lpData=(DDEDATA FAR*) GlobalLock(hData))==NULL)  
 {
  GlobalFree(hData); 
  return(NULL); 
 } 
 
 lpData->cfFormat=(short)type;
 lpData->fAckReq=0;
 lpData->fRelease=TRUE;
 
 memcpy((LPSTR)lpData->Value,(LPSTR)szValue,size); 
 
 GlobalUnlock(hData); 

 if((atomItem=GlobalAddAtom((LPSTR)szItem))!=0)
 {
  lParam=PackDDElParam(WM_DDE_DATA,(UINT_PTR)hData,atomItem);
  if(!PostMessage(server,WM_DDE_DATA,(WPARAM)client,lParam))
  {
   FreeDDElParam(WM_DDE_DATA,lParam);
   GlobalFree(hData);
   GlobalDeleteAtom(atomItem);
  }

  cprintf("post OK");
 } 
 
 if(atomItem == 0) 
 { 

    // Handle errors.  

 } 
 

 return(NULL);
}





static os_error * ddesendfinit(HWND client,HWND server)
{

 PostMessage(server,WM_DDE_TERMINATE,(WPARAM)client,(LPARAM)0); 
      

 return(NULL);
}



// we're only going to report the first channel and close any others


os_error * ddeopenchannel(wimp_w hwnd,char * data,char * app,char * path,ddeserverfn ddeserver,int userhandle,ddech * channel)
{
 os_error      * err;
 ddechannelstr * ddec;
 ddechannelstr * prev;
 int             pass;

	err=NULL;


 *channel=0;
	ddec=NULL;

	for(pass=0;pass<2;pass++)
	{
		cprintf("pass %d",pass);

		if(pass==1)
		{
			char                 exppath[MAX_PATH];
	  UINT				             ret;
  	PROCESS_INFORMATION  pi;
	  STARTUPINFO			       si;

 	 ZeroMemory(&pi,sizeof(PROCESS_INFORMATION));

  	ZeroMemory(&si,sizeof(STARTUPINFO));
   si.cb=sizeof(STARTUPINFO);
   si.lpDesktop=TEXT("");

			fs_expandpath(path,exppath,sizeof(exppath)/sizeof(TCHAR));
	  ret=CreateProcess(exppath,NULL,0,0,FALSE,NORMAL_PRIORITY_CLASS,0,0,&si,&pi);
			if(ret)
			{
				WaitForInputIdle(pi.hProcess,5000);
			}
   else
   {
    break;
   }
		}


  err=ddesendinit(hwnd==0?ddehwnd:(HWND)hwnd,app,data);
  if(!err)
  {
   ddec=ddefirst;
   while(ddec)
   {
    if(ddec->newflag) break;
    ddec=ddec->next;
   }
   
   if(ddec)
   {
    ddec->serverfn=ddeserver;
    ddec->userhandle=userhandle;
    *channel=(ddech)ddec;

    ddec=ddec->next;

    while(ddec)
    {
     cprintf("ddec %x first %x",ddec,ddefirst);

     if(ddec->newflag)
     {
      ddesendfinit((HWND)ddec->hwnd,(HWND)ddec->remote);
      prev=ddec;
      ddec=ddec->next;
      ddescrapchannel(prev);
     }
    }
			}
		}

		if(*channel) break;
		if(err) break;
 }

 return(err);
}



os_error * ddeclosechannel(ddech channel)
{
 os_error      * err;
 ddechannelstr * ddec;

 err=NULL;

 ddec=(ddechannelstr*)channel;
 if(ddec)
 {
  ddesendfinit((HWND)ddec->hwnd,(HWND)ddec->remote);
  ddescrapchannel(ddec);
 }

 return(err);
}



os_error * ddewritechannel(ddech channel,char * data,int size,int type,char * item)
{
 os_error      * err;
 ddechannelstr * ddec;

 err=NULL;

 ddec=(ddechannelstr*)channel;
 if(ddec)
 {
  err=ddesendpoke((HWND)ddec->hwnd,(HWND)ddec->remote,data,size,type,item);
 }

 return(err);
}



os_error * ddeserverwritechannel(ddech channel,char * data,int size,int type,char * item)
{
 os_error      * err;
 ddechannelstr * ddec;

 err=NULL;

 ddec=(ddechannelstr*)channel;
 if(ddec)
 {
  err=ddesenddata((HWND)ddec->hwnd,(HWND)ddec->remote,data,size,type,item);
 }

 return(err);
}



os_error * dderegisterserver(ddeserverfn xddeserver)
{

 ddeserver=xddeserver;

 return(NULL);
}





os_error * ddestart(char * name)
{
 appname=name;


#ifdef NEVER
 WNDCLASS   wndclass;
 ATOM       atom;





 memset(&wndclass,0,sizeof(wndclass));

 wndclass.style=CS_DBLCLKS;
 wndclass.lpfnWndProc=pollevent;
 wndclass.cbClsExtra=0;
 wndclass.cbWndExtra=DLGWINDOWEXTRA;
 wndclass.hInstance=AppInstance;
 wndclass.hIcon=NULL;
 wndclass.hCursor=LoadCursor(NULL,IDC_ARROW);
 wndclass.hbrBackground=(HBRUSH)(COLOR_BTNFACE+1);
 wndclass.lpszMenuName=NULL;
 wndclass.lpszClassName="Task2";

 XRegisterClass(&wndclass,&atom);

#endif

 ddehwnd=CreateWindow(TEXT("Task"),TEXT("osdde"),
                          WS_OVERLAPPEDWINDOW,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                          NULL, NULL,AppInstance,NULL);

	wimp_setwindowflags((wimp_w)ddehwnd,WINDOWDDE,0);


 return(NULL);
}


