/*->c.wimptext */

#include <stdafx.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>


#include "bbc.h"
#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "font.h"
#include "deb.h"
#include "transform.h"

#include "wos.h"
#include "task.h"
#include "osglue.h"
#include "osgraphics.h"
#include "colour.h"
#include "sp.h"
#include "etc.h"

#include "wimptext.h"






//int wimpavfontwidth=16;


static font wimpfonthandle;
static int wimpfontlead;
static int wimpfontheight;
static int wimpfontwidth;
static wimp_w wimpfontwindow;



int wimpfontgetlead(void)
{
 return(wimpfontlead);
}



static void wimpfontstartwf(int avwidth,wimp_w handle)
{
 os_error * err;
 font_metric metric;

 wimpfontwindow=handle;

 if(handle)
 {
  err=wimp_getfont(handle,&wimpfonthandle);
 }
 else
 {
  err=font_find("Arial",0,8*16,0,0,&wimpfonthandle);
 }

 if(!err) err=font_setfont(wimpfonthandle);
 if(!err) err=font_getmetric(&metric);
 if(!err) err=font_align(FA_BASELINE|FA_LEFT);

 wimpfontheight=metric.height;
 wimpfontwidth=metric.averagewidth; //wimpavfontwidth=
 wimpfontlead=metric.ascent;

// if(handle)
 {
  wimpfontheight=(wimpfontheight*currenthdcptr->osxres)/currenthdcptr->vduxres;
  wimpfontwidth=(wimpfontwidth*currenthdcptr->osxres)/currenthdcptr->vduxres;
  wimpfontlead=(wimpfontlead*currenthdcptr->osxres)/currenthdcptr->vduxres;
 }

 USE(avwidth);
}


void wimpfontstart(int avwidth)
{
 wimpfontstartwf(avwidth,0);
}


int wimpfontstringwidth(char * string,wimp_w handle)
{
 os_error    * err;
 font_string   fs;
 font          oldwimpfonthandle;

 fs.x=0;

 err=graphicscheck(0);
 if(!err)
 {
  oldwimpfonthandle=wimpfonthandle;
  if(!oldwimpfonthandle) wimpfontstartwf(0,handle);
  
  fs.s=string;
  fs.split=-1;
  fs.term=strlen(string);
  fs.x=0x3FFFFFFF;
  fs.y=0;

  font_strwidth(&fs);

  if(!oldwimpfonthandle) wimpfontend();

//  if(handle)
  fs.x=(fs.x*currenthdcptr->osxres)/currenthdcptr->vduxres;

  graphicsclear();
 }
 return(fs.x);
}


void wimpfontend(void)
{
 if(wimpfonthandle)
 {
  if(!wimpfontwindow) font_lose(wimpfonthandle);
  wimpfonthandle=0;
 }
}





void stringat(int x,int y,char * string,int col,int height)
{
 int       shift;
 int       back;

 if(wimpfonthandle)
 {
  shift=(height-cvdu.extray-wimpfontheight)/2+wimpfontlead;

  back=(col>>8)&0xFF;
  if(back==WIMPTRANS) back=PALTRANSPARENT;
  else                back=cvdu.vdupal.c[back].word;

  font_setcolour(0,back,cvdu.vdupal.c[(col)&0xFF].word,0);
  font_paint(string,font_ABS|font_OSCOORDS,x,y-shift);
 }
}




#ifdef NEVER


void plinthtext(int x,int y,int w,int h,char * string,int col)
{
#ifdef NEVER
 int i;

 wimp_setcolour((col>>8) & 0xFF);
 bbc_rectanglefill(x,y,w,-h);

 wimp_setcolour(4);

 for(i=0;i<4;i+=cvdu.deltay)
 {
  bbc_move(x,y+i);
  bbc_draw(x+w,y+i);
 }

 for(i=0;i<4;i+=cvdu.deltax)
 {
  bbc_move(x+i,y);
  bbc_draw(x+i,y-h);
 }

 wimp_setcolour(0);

 for(i=0;i<4;i+=cvdu.deltay)
 {
  bbc_move(x,y-h+i);
  bbc_draw(x+w,y-h+i);
 }

 for(i=0;i<4;i+=cvdu.deltax)
 {
  bbc_move(x+w-i,y);
  bbc_draw(x+w-i,y-h);
 }

 stringat(x+6,y,string,col,h);
#endif
}


void noplinthtext(int x,int y,int w,int h,char * string,int col)
{
#ifdef NEVER
 wimp_setcolour((col>>8) & 0xFF);
 bbc_rectanglefill(x,y,w,-h);
 wimp_setcolour(7);
 bbc_rectangle(x,y,w,-h);
 stringat(x+8,y,string,col,h);
#endif
}


#endif



static int * otickptr;
static int   otickwidth;
static int   otickheight;


os_error * tickat(int x,int y,int col)
{
 static sprite_id id;
 sprite_info      resultinfo;
 int              dx;
 int              dy;
 int              fore;
 int              back;
 int              i;
 int            * pal;
 int              r;
 int              g;
 int              b;
 int              dr;
 int              dg;
 int              db;
 int              savepal[16];
 int            * spal;

 if(!otickptr)
 {
  otickptr=spfind((sprite_area*)sprites,"otick");

  id.tag=sprite_id_addr;
  id.s.addr=otickptr;

  sprite_readsize((sprite_area*)sprites,&id,&resultinfo);
  getdeltas(resultinfo.mode,&dx,&dy);

  otickwidth=resultinfo.width*dx;
  otickheight=resultinfo.height*dy;
 }

 if(otickptr)
 {
  spal=pal=(int*)(((char*)otickptr)+sizeof(sprite_header));

  memcpy(savepal,spal,sizeof(int)*16);

  fore=cvdu.vdupal.c[(col>>8) & 0xFF].word;
  back=cvdu.vdupal.c[col & 0xFF].word;

  dr=((back>>8)&0xFF)-((fore>>8)&0xFF);
  dg=((back>>16)&0xFF)-((fore>>16)&0xFF);
  db=((back>>24)&0xFF)-((fore>>24)&0xFF);
  r=((fore>>8)&0xFF)*8;
  g=((fore>>16)&0xFF)*8;
  b=((fore>>24)&0xFF)*8;

  for(i=0;i<8;i++)
  {
   *pal=*(pal+1)=((b/8)<<24)|((g/8)<<16)|((r/8)<<8);
   pal+=2;
   r+=dr;
   g+=dg;
   b+=db;
  }

  sprite_put_given((sprite_area*)sprites,&id,0,x,y/*-otickheight*/);

  memcpy(spal,savepal,sizeof(int)*16);
 }

 return(NULL);
}

